import { BFormInput as go, BFormInvalidFeedback as pt, BFormGroup as mt, BFormCheckbox as yu, BFormCheckboxGroup as pu, BFormRadioGroup as mu, BFormSelect as vu, BFormTextarea as hu, BForm as Xu, BFormFloatingLabel as Ku, BFormRadio as Ju, BFormRow as Zu, BFormSelectOption as el, BFormSelectOptionGroup as tl, BFormSpinButton as nl, BFormTag as rl, BFormTags as al, BFormText as ol, BFormValidFeedback as il } from "bootstrap-vue-next";
import { computed as F, unref as l, defineComponent as Ie, openBlock as g, createElementBlock as B, toDisplayString as $e, createBlock as oe, normalizeClass as pe, withCtx as Q, createTextVNode as Fe, createVNode as Re, isRef as Le, createElementVNode as ie, renderSlot as W, createCommentVNode as x, reactive as Qt, ref as H, useSlots as wo, toRef as ra, onMounted as tt, onUnmounted as _o, watch as Xt, mergeProps as Ye, createSlots as Xe, renderList as Ae, normalizeProps as Je, guardReactiveProps as ct, Teleport as ul, withKeys as ye, withModifiers as ft, Transition as It, Fragment as he, normalizeStyle as Nt, resolveDynamicComponent as rn, nextTick as Kt, withDirectives as an, vShow as on, onBeforeUpdate as ll, getCurrentScope as sl, onScopeDispose as cl } from "vue";
function Tt(e) {
  const t = F(() => {
    const o = l(e.showAsRequired);
    if (o === !1 || o === !0)
      return !!o;
    if (e.validation !== void 0) {
      const i = JSON.parse(JSON.stringify(e.validation));
      if (i && typeof i == "object")
        return Object.keys(i).filter((c) => !`${c}`.startsWith("$")).length > 0;
    }
    return !1;
  }), n = F(() => {
    const o = l(e.validation);
    return (o == null ? void 0 : o.$invalid) !== void 0 && o.$dirty ? o.$invalid : null;
  });
  return {
    isRequired: t,
    invalid: n,
    onEvent: function(o) {
      return (i) => {
        $emit(o, i);
      };
    },
    formatValue: function(o) {
      const i = l(e.formatter);
      return typeof i == "function" ? i(o) : o;
    }
  };
}
const fl = Ie({
  name: "FormInputFeedbackMessage",
  props: {
    messages: {
      type: Object,
      required: !1
    },
    validationModel: {
      type: Object,
      required: !0
    }
  },
  computed: {
    ruleNames() {
      return [
        ...new Set(
          [
            "required",
            "requiredIf",
            "requiredUnless",
            "minLength",
            "maxLength",
            "minValue",
            "maxValue",
            "between",
            "alpha",
            "alphaNum",
            "numeric",
            "integer",
            "decimal",
            "email",
            "ipAddress",
            "macAddress",
            "sameAs",
            "url",
            "validated_email"
            // eslint-disable-next-line @typescript-eslint/strict-boolean-expressions
          ].concat(this.messages ? Object.keys(this.messages) : [])
        )
      ];
    },
    message() {
      const e = Object.keys(this.validationModel).filter((t) => !`${t}`.startsWith("$"));
      for (const t of e)
        if (this.ruleNames.includes(t) && this.validationModel[t].$invalid)
          return this.messages && this.messages[t] ? this.messages[t] : this.getDefaultMessage(t, this.validationModel[t].$params || {});
      return this.getDefaultMessage();
    }
  },
  methods: {
    getDefaultMessage(e, t) {
      let n;
      if (this.$i18n !== void 0 && this.$t !== void 0)
        switch (e) {
          case "required":
          case "requiredIf":
          case "requiredUnless":
            return this.$t("vueFormInputs.feedback.required");
          case "minLength":
            return this.$t("vueFormInputs.feedback.minLength", { minLength: t.min });
          case "maxLength":
            return this.$t("vueFormInputs.feedback.maxLength", { maxLength: t.max });
          case "minValue":
            return n = t.min instanceof Date ? t.min.toLocaleDateString() : t.min, this.$t("vueFormInputs.feedback.minValue", { minValue: n });
          case "maxValue":
            return n = t.max instanceof Date ? t.max.toLocaleDateString() : t.max, this.$t("vueFormInputs.feedback.maxValue", { maxValue: n });
          case "between":
            return this.$t("vueFormInputs.feedback.between", { betweenMin: t.min, betweenMax: t.max });
          case "alpha":
            return this.$t("vueFormInputs.feedback.alpha");
          case "alphaNum":
            return this.$t("vueFormInputs.feedback.alphaNum");
          case "numeric":
            return this.$t("vueFormInputs.feedback.numeric");
          case "integer":
            return this.$t("vueFormInputs.feedback.integer");
          case "decimal":
            return this.$t("vueFormInputs.feedback.decimal");
          case "email":
            return this.$t("vueFormInputs.feedback.email");
          case "ipAddress":
            return this.$t("vueFormInputs.feedback.ipAddress");
          case "macAddress":
            return this.$t("vueFormInputs.feedback.macAddress");
          case "sameAs":
            return this.$t("vueFormInputs.feedback.sameAs");
          case "url":
            return this.$t("vueFormInputs.feedback.url");
          case "validated_email":
          case "validatedEmail":
            return this.$t("vueFormInputs.feedback.validatedEmail");
          default:
            return this.$t("vueFormInputs.feedback.invalidValue");
        }
      switch (e) {
        case "required":
        case "requiredIf":
        case "requiredUnless":
          return "Toto pole je nutné vyplnit.";
        case "minLength":
          return `Hodnota musí být minimálně ${t.min} znaků dlouhá.`;
        case "maxLength":
          return `Hodnota musí být maximálně ${t.max} znaků dlouhá.`;
        case "minValue":
          return n = t.min instanceof Date ? t.min.toLocaleDateString() : t.min, `Hodnota musí být minimálně ${n}.`;
        case "maxValue":
          return n = t.max instanceof Date ? t.max.toLocaleDateString() : t.max, `Hodnota musí být maximálně ${n}.`;
        case "between":
          return `Hodnota musí být mezi ${t.min} a ${t.max}.`;
        case "alpha":
          return "Jsou povoleny pouze písmena.";
        case "alphaNum":
          return "Jsou povoleny pouze písmena a čísla.";
        case "numeric":
          return "Jsou povoleny pouze čísla.";
        case "integer":
          return "Jsou povolena pouze celá čísla.";
        case "decimal":
          return "Jsou povolena pouze desetinná čísla.";
        case "email":
          return "Chybný formát emailové adresy.";
        case "ipAddress":
          return "Chybný formát IP adresy.";
        case "macAddress":
          return "Chybný formát MAC adresy.";
        case "sameAs":
          return "Hodnota není shodná.";
        case "url":
          return "Chybný formát URL adresy.";
        case "validated_email":
        case "validatedEmail":
          return "Nefunkční nebo chybná emailová adresa.";
        default:
          return "Chybně vyplněná hodnota.";
      }
    }
  }
}), dl = (e, t) => {
  const n = e.__vccOpts || e;
  for (const [r, a] of t)
    n[r] = a;
  return n;
};
function yl(e, t, n, r, a, o) {
  return g(), B("span", null, $e(e.message), 1);
}
const Dt = /* @__PURE__ */ dl(fl, [["render", yl]]), pl = { class: "input-group-append" }, ml = /* @__PURE__ */ Ie({
  __name: "FormInput",
  props: {
    label: null,
    type: { default: "text" },
    size: null,
    validationMessages: null,
    validation: null,
    disabled: { type: Boolean, default: !1 },
    modelValue: null,
    hint: null,
    placeholder: null,
    formatter: null,
    renderAsGroup: { type: Boolean, default: !1 },
    id: null,
    readOnly: { type: Boolean, default: !1 },
    showAsRequired: { type: Boolean }
  },
  emits: ["update:modelValue", "change", "update", "blur"],
  setup(e, { emit: t }) {
    const n = e, r = F({
      get() {
        const s = l(n.modelValue);
        if (typeof s == "string" || typeof s == "number")
          return s;
      },
      set(s) {
        t("update:modelValue", s);
        const d = l(n.validation);
        typeof (d == null ? void 0 : d.$touch) == "function" && d.$touch();
      }
    }), {
      isRequired: a,
      invalid: o,
      onEvent: i,
      formatValue: c
    } = Tt(n);
    return (s, d) => {
      const b = go, y = pt, f = mt;
      return g(), oe(f, {
        description: e.hint,
        "label-for": e.id,
        class: pe({ "form-group-required": l(a) })
      }, {
        label: Q(() => [
          Fe($e(e.label), 1)
        ]),
        default: Q(() => [
          e.renderAsGroup ? (g(), B("div", {
            key: 0,
            class: pe({ "input-group": !0, "is-invalid": l(o) !== null ? !l(o) : null, "is-valid": l(o) !== null ? !!l(o) : null })
          }, [
            Re(b, {
              modelValue: l(r),
              "onUpdate:modelValue": d[0] || (d[0] = (v) => Le(r) ? r.value = v : null),
              modelModifiers: { trim: !0 },
              id: e.id,
              size: e.size,
              type: e.type,
              state: l(o) !== null ? !l(o) : null,
              disabled: e.disabled,
              formatter: l(c),
              placeholder: e.placeholder,
              readonly: e.readOnly,
              "lazy-formatter": "",
              onChange: d[1] || (d[1] = (v) => l(i)("change")),
              onUpdate: d[2] || (d[2] = (v) => l(i)("update")),
              onBlur: d[3] || (d[3] = (v) => l(i)("blur"))
            }, null, 8, ["modelValue", "id", "size", "type", "state", "disabled", "formatter", "placeholder", "readonly"]),
            ie("div", pl, [
              W(s.$slots, "default")
            ])
          ], 2)) : (g(), oe(b, {
            key: 1,
            modelValue: l(r),
            "onUpdate:modelValue": d[4] || (d[4] = (v) => Le(r) ? r.value = v : null),
            modelModifiers: { trim: !0 },
            id: e.id,
            size: e.size,
            type: e.type,
            state: l(o) !== null ? !l(o) : null,
            disabled: e.disabled,
            formatter: l(c),
            placeholder: e.placeholder,
            readonly: e.readOnly,
            "lazy-formatter": "",
            onChange: d[5] || (d[5] = (v) => l(i)("change")),
            onUpdate: d[6] || (d[6] = (v) => l(i)("update")),
            onBlur: d[7] || (d[7] = (v) => l(i)("blur"))
          }, null, 8, ["modelValue", "id", "size", "type", "state", "disabled", "formatter", "placeholder", "readonly"])),
          l(o) ? (g(), oe(y, { key: 2 }, {
            default: Q(() => [
              Re(Dt, {
                "validation-model": e.validation,
                messages: e.validationMessages
              }, null, 8, ["validation-model", "messages"])
            ]),
            _: 1
          })) : x("", !0),
          W(s.$slots, "input-text")
        ]),
        _: 3
      }, 8, ["description", "label-for", "class"]);
    };
  }
});
const vl = /* @__PURE__ */ Ie({
  __name: "FormInputCheckbox",
  props: {
    label: null,
    size: null,
    validationMessages: null,
    validation: null,
    disabled: { type: Boolean, default: !1 },
    modelValue: { type: Boolean },
    hint: null,
    id: null,
    readOnly: { type: Boolean, default: !1 },
    showAsRequired: { type: Boolean },
    renderAsSwitch: { type: Boolean }
  },
  emits: ["update:modelValue", "change", "update", "blur"],
  setup(e, { emit: t }) {
    const n = e, r = F({
      get() {
        const c = l(n.modelValue);
        if (typeof c == "boolean")
          return c;
      },
      set(c) {
        t("update:modelValue", c);
        const s = l(n.validation);
        typeof (s == null ? void 0 : s.$touch) == "function" && s.$touch();
      }
    }), {
      isRequired: a,
      invalid: o,
      onEvent: i
    } = Tt(n);
    return (c, s) => {
      const d = yu, b = pt, y = mt;
      return g(), oe(y, {
        description: e.hint,
        class: pe({ "form-group-required": l(a) })
      }, {
        default: Q(() => [
          Re(d, {
            modelValue: l(r),
            "onUpdate:modelValue": s[0] || (s[0] = (f) => Le(r) ? r.value = f : null),
            id: e.id,
            size: e.size,
            state: l(o) !== null ? !l(o) : null,
            switch: e.renderAsSwitch === !0 ? !0 : void 0,
            disabled: e.disabled || e.readOnly,
            onChange: s[1] || (s[1] = (f) => l(i)("change")),
            onUpdate: s[2] || (s[2] = (f) => l(i)("update")),
            onBlur: s[3] || (s[3] = (f) => l(i)("blur"))
          }, {
            default: Q(() => [
              W(c.$slots, "default", {}, () => [
                Fe($e(e.label), 1)
              ])
            ]),
            _: 3
          }, 8, ["modelValue", "id", "size", "state", "switch", "disabled"]),
          l(o) ? (g(), oe(b, { key: 0 }, {
            default: Q(() => [
              Re(Dt, {
                "validation-model": e.validation,
                messages: e.validationMessages
              }, null, 8, ["validation-model", "messages"])
            ]),
            _: 1
          })) : x("", !0)
        ]),
        _: 3
      }, 8, ["description", "class"]);
    };
  }
}), hl = /* @__PURE__ */ Ie({
  __name: "FormInputCheckboxGroup",
  props: {
    label: null,
    type: null,
    size: null,
    validationMessages: null,
    validation: null,
    disabled: { type: Boolean, default: !1 },
    modelValue: null,
    hint: null,
    id: null,
    readOnly: { type: Boolean, default: !1 },
    showAsRequired: { type: Boolean },
    options: { default: () => [] },
    stacked: { type: Boolean, default: !0 }
  },
  emits: ["update:modelValue", "change", "update", "blur"],
  setup(e, { emit: t }) {
    const n = e, r = F({
      get() {
        const c = l(n.modelValue);
        if (Array.isArray(c))
          return c;
      },
      set(c) {
        t("update:modelValue", c);
        const s = l(n.validation);
        typeof (s == null ? void 0 : s.$touch) == "function" && s.$touch();
      }
    }), {
      isRequired: a,
      invalid: o,
      onEvent: i
    } = Tt(n);
    return (c, s) => {
      const d = pu, b = pt, y = mt;
      return g(), oe(y, {
        description: e.hint,
        class: pe({ "form-group-required": l(a) }),
        "label-for": e.id
      }, {
        label: Q(() => [
          Fe($e(e.label), 1)
        ]),
        default: Q(() => [
          Re(d, {
            modelValue: l(r),
            "onUpdate:modelValue": s[0] || (s[0] = (f) => Le(r) ? r.value = f : null),
            id: e.id,
            size: e.size,
            state: l(o) !== null ? !l(o) : null,
            disabled: e.disabled || e.readOnly,
            options: e.options,
            stacked: e.stacked,
            onChange: s[1] || (s[1] = (f) => l(i)("change")),
            onUpdate: s[2] || (s[2] = (f) => l(i)("update")),
            onBlur: s[3] || (s[3] = (f) => l(i)("blur"))
          }, null, 8, ["modelValue", "id", "size", "state", "disabled", "options", "stacked"]),
          l(o) ? (g(), oe(b, { key: 0 }, {
            default: Q(() => [
              Re(Dt, {
                "validation-model": e.validation,
                messages: e.validationMessages
              }, null, 8, ["validation-model", "messages"])
            ]),
            _: 1
          })) : x("", !0)
        ]),
        _: 1
      }, 8, ["description", "class", "label-for"]);
    };
  }
}), bl = /* @__PURE__ */ Ie({
  __name: "FormInputRadioGroup",
  props: {
    label: null,
    type: null,
    size: null,
    validationMessages: null,
    validation: null,
    disabled: { type: Boolean, default: !1 },
    modelValue: null,
    hint: null,
    id: null,
    readOnly: { type: Boolean, default: !1 },
    showAsRequired: { type: Boolean },
    options: { default: () => [] },
    stacked: { type: Boolean, default: !0 }
  },
  emits: ["update:modelValue", "change", "update", "blur"],
  setup(e, { emit: t }) {
    const n = e, r = F({
      get() {
        const c = l(n.modelValue);
        if (Array.isArray(c))
          return c;
      },
      set(c) {
        t("update:modelValue", c);
        const s = l(n.validation);
        typeof (s == null ? void 0 : s.$touch) == "function" && s.$touch();
      }
    }), {
      isRequired: a,
      invalid: o,
      onEvent: i
    } = Tt(n);
    return (c, s) => {
      const d = mu, b = pt, y = mt;
      return g(), oe(y, {
        description: e.hint,
        class: pe({ "form-group-required": l(a) }),
        "label-for": e.id
      }, {
        label: Q(() => [
          Fe($e(e.label), 1)
        ]),
        default: Q(() => [
          Re(d, {
            modelValue: l(r),
            "onUpdate:modelValue": s[0] || (s[0] = (f) => Le(r) ? r.value = f : null),
            id: e.id,
            size: e.size,
            state: l(o) !== null ? !l(o) : null,
            disabled: e.disabled || e.readOnly,
            options: e.options,
            stacked: e.stacked,
            onChange: s[1] || (s[1] = (f) => l(i)("change")),
            onUpdate: s[2] || (s[2] = (f) => l(i)("update")),
            onBlur: s[3] || (s[3] = (f) => l(i)("blur"))
          }, null, 8, ["modelValue", "id", "size", "state", "disabled", "options", "stacked"]),
          l(o) ? (g(), oe(b, { key: 0 }, {
            default: Q(() => [
              Re(Dt, {
                "validation-model": e.validation,
                messages: e.validationMessages
              }, null, 8, ["validation-model", "messages"])
            ]),
            _: 1
          })) : x("", !0)
        ]),
        _: 1
      }, 8, ["description", "class", "label-for"]);
    };
  }
}), gl = { class: "input-group-append" }, wl = /* @__PURE__ */ Ie({
  __name: "FormInputSelect",
  props: {
    label: null,
    size: null,
    validationMessages: null,
    validation: null,
    disabled: { type: Boolean, default: !1 },
    modelValue: null,
    hint: null,
    placeholder: null,
    renderAsGroup: { type: Boolean, default: !1 },
    id: null,
    readOnly: { type: Boolean, default: !1 },
    showAsRequired: { type: Boolean },
    options: { default: () => [] },
    multi: { type: Boolean },
    selectSize: null
  },
  emits: ["update:modelValue", "change", "update", "blur"],
  setup(e, { emit: t }) {
    const n = e, r = F({
      get() {
        const c = l(n.modelValue);
        if (typeof c == "string" || typeof c == "number")
          return c;
      },
      set(c) {
        t("update:modelValue", c);
        const s = l(n.validation);
        typeof (s == null ? void 0 : s.$touch) == "function" && s.$touch();
      }
    }), {
      isRequired: a,
      invalid: o,
      onEvent: i
    } = Tt(n);
    return (c, s) => {
      const d = vu, b = pt, y = mt;
      return g(), oe(y, {
        description: e.hint,
        class: pe({ "form-group-required": l(a) }),
        "label-for": e.id
      }, {
        label: Q(() => [
          Fe($e(e.label), 1)
        ]),
        default: Q(() => [
          e.renderAsGroup ? (g(), B("div", {
            key: 0,
            class: pe({ "input-group": !0, "is-invalid": l(o) !== null ? !l(o) : null, "is-valid": l(o) !== null ? !!l(o) : null })
          }, [
            Re(d, {
              modelValue: l(r),
              "onUpdate:modelValue": s[0] || (s[0] = (f) => Le(r) ? r.value = f : null),
              size: e.size,
              id: e.id,
              state: l(o) !== null ? !l(o) : null,
              disabled: e.disabled || e.readOnly,
              placeholder: e.placeholder,
              options: e.options,
              onChange: s[1] || (s[1] = (f) => l(i)("change")),
              onUpdate: s[2] || (s[2] = (f) => l(i)("update")),
              onBlur: s[3] || (s[3] = (f) => l(i)("blur")),
              multiple: e.multi,
              "select-size": e.multi === !0 ? e.selectSize : void 0
            }, null, 8, ["modelValue", "size", "id", "state", "disabled", "placeholder", "options", "multiple", "select-size"]),
            ie("div", gl, [
              W(c.$slots, "default")
            ])
          ], 2)) : (g(), oe(d, {
            key: 1,
            modelValue: l(r),
            "onUpdate:modelValue": s[4] || (s[4] = (f) => Le(r) ? r.value = f : null),
            size: e.size,
            id: e.id,
            state: l(o) !== null ? !l(o) : null,
            disabled: e.disabled || e.readOnly,
            placeholder: e.placeholder,
            options: e.options,
            onChange: s[5] || (s[5] = (f) => l(i)("change")),
            onUpdate: s[6] || (s[6] = (f) => l(i)("update")),
            onBlur: s[7] || (s[7] = (f) => l(i)("blur")),
            multiple: e.multi,
            "select-size": e.multi === !0 ? e.selectSize : void 0
          }, null, 8, ["modelValue", "size", "id", "state", "disabled", "placeholder", "options", "multiple", "select-size"])),
          l(o) ? (g(), oe(b, { key: 2 }, {
            default: Q(() => [
              Re(Dt, {
                "validation-model": e.validation,
                messages: e.validationMessages
              }, null, 8, ["validation-model", "messages"])
            ]),
            _: 1
          })) : x("", !0)
        ]),
        _: 3
      }, 8, ["description", "class", "label-for"]);
    };
  }
}), _l = /* @__PURE__ */ Ie({
  __name: "FormInputTextarea",
  props: {
    label: null,
    size: null,
    validationMessages: null,
    validation: null,
    disabled: { type: Boolean, default: !1 },
    modelValue: null,
    hint: null,
    placeholder: null,
    formatter: null,
    renderAsGroup: { type: Boolean, default: !1 },
    id: null,
    readOnly: { type: Boolean, default: !1 },
    showAsRequired: { type: Boolean }
  },
  emits: ["update:modelValue", "change", "update", "blur"],
  setup(e, { emit: t }) {
    const n = e, r = F({
      get() {
        const s = l(n.modelValue);
        if (typeof s == "string" || typeof s == "number")
          return s;
      },
      set(s) {
        t("update:modelValue", s);
        const d = l(n.validation);
        typeof (d == null ? void 0 : d.$touch) == "function" && d.$touch();
      }
    }), {
      isRequired: a,
      invalid: o,
      onEvent: i,
      formatValue: c
    } = Tt(n);
    return (s, d) => {
      const b = hu, y = pt, f = mt;
      return g(), oe(f, {
        label: e.label,
        description: e.hint,
        "label-for": e.id,
        class: pe({ "form-group-required": l(a) })
      }, {
        label: Q(() => [
          Fe($e(e.label), 1)
        ]),
        default: Q(() => [
          Re(b, {
            modelValue: l(r),
            "onUpdate:modelValue": d[0] || (d[0] = (v) => Le(r) ? r.value = v : null),
            modelModifiers: { trim: !0 },
            size: e.size,
            id: e.id,
            state: l(o) !== null ? !l(o) : null,
            disabled: e.disabled,
            formatter: l(c),
            placeholder: e.placeholder,
            "lazy-formatter": "",
            onChange: d[1] || (d[1] = (v) => l(i)("change")),
            onUpdate: d[2] || (d[2] = (v) => l(i)("update")),
            onBlur: d[3] || (d[3] = (v) => l(i)("blur")),
            readonly: e.readOnly
          }, null, 8, ["modelValue", "size", "id", "state", "disabled", "formatter", "placeholder", "readonly"]),
          l(o) ? (g(), oe(y, { key: 0 }, {
            default: Q(() => [
              Re(Dt, {
                "validation-model": e.validation,
                messages: e.validationMessages
              }, null, 8, ["validation-model", "messages"])
            ]),
            _: 1
          })) : x("", !0),
          W(s.$slots, "input-text")
        ]),
        _: 3
      }, 8, ["label", "description", "label-for", "class"]);
    };
  }
}), Ol = (e) => `${e < 10 ? "0" : ""}${e}`, bu = (e) => e instanceof Date ? `${e.getDate()}.${e.getMonth() + 1}. ${e.getFullYear()}` : null, $l = (e) => {
  if (e instanceof Date) {
    const t = bu(e);
    return t === null ? null : `${t} - ${e.getHours()}:${Ol(e.getMinutes())}`;
  }
  return null;
};
function re(e) {
  if (e === null || e === !0 || e === !1)
    return NaN;
  var t = Number(e);
  return isNaN(t) ? t : t < 0 ? Math.ceil(t) : Math.floor(t);
}
function J(e, t) {
  if (t.length < e)
    throw new TypeError(e + " argument" + (e > 1 ? "s" : "") + " required, but only " + t.length + " present");
}
function un(e) {
  return typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? un = function(n) {
    return typeof n;
  } : un = function(n) {
    return n && typeof Symbol == "function" && n.constructor === Symbol && n !== Symbol.prototype ? "symbol" : typeof n;
  }, un(e);
}
function ae(e) {
  J(1, arguments);
  var t = Object.prototype.toString.call(e);
  return e instanceof Date || un(e) === "object" && t === "[object Date]" ? new Date(e.getTime()) : typeof e == "number" || t === "[object Number]" ? new Date(e) : ((typeof e == "string" || t === "[object String]") && typeof console < "u" && (console.warn("Starting with v2.0.0-beta.1 date-fns doesn't accept strings as date arguments. Please use `parseISO` to parse strings. See: https://github.com/date-fns/date-fns/blob/master/docs/upgradeGuide.md#string-arguments"), console.warn(new Error().stack)), new Date(NaN));
}
function yt(e, t) {
  J(2, arguments);
  var n = ae(e), r = re(t);
  return isNaN(r) ? new Date(NaN) : (r && n.setDate(n.getDate() + r), n);
}
function ot(e, t) {
  J(2, arguments);
  var n = ae(e), r = re(t);
  if (isNaN(r))
    return new Date(NaN);
  if (!r)
    return n;
  var a = n.getDate(), o = new Date(n.getTime());
  o.setMonth(n.getMonth() + r + 1, 0);
  var i = o.getDate();
  return a >= i ? o : (n.setFullYear(o.getFullYear(), o.getMonth(), a), n);
}
function ln(e) {
  return typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? ln = function(n) {
    return typeof n;
  } : ln = function(n) {
    return n && typeof Symbol == "function" && n.constructor === Symbol && n !== Symbol.prototype ? "symbol" : typeof n;
  }, ln(e);
}
function gu(e, t) {
  if (J(2, arguments), !t || ln(t) !== "object")
    return new Date(NaN);
  var n = t.years ? re(t.years) : 0, r = t.months ? re(t.months) : 0, a = t.weeks ? re(t.weeks) : 0, o = t.days ? re(t.days) : 0, i = t.hours ? re(t.hours) : 0, c = t.minutes ? re(t.minutes) : 0, s = t.seconds ? re(t.seconds) : 0, d = ae(e), b = r || n ? ot(d, r + n * 12) : d, y = o || a ? yt(b, o + a * 7) : b, f = c + i * 60, v = s + f * 60, A = v * 1e3, V = new Date(y.getTime() + A);
  return V;
}
function Pl(e, t) {
  J(2, arguments);
  var n = ae(e).getTime(), r = re(t);
  return new Date(n + r);
}
var kl = {};
function vt() {
  return kl;
}
function aa(e, t) {
  var n, r, a, o, i, c, s, d;
  J(1, arguments);
  var b = vt(), y = re((n = (r = (a = (o = t == null ? void 0 : t.weekStartsOn) !== null && o !== void 0 ? o : t == null || (i = t.locale) === null || i === void 0 || (c = i.options) === null || c === void 0 ? void 0 : c.weekStartsOn) !== null && a !== void 0 ? a : b.weekStartsOn) !== null && r !== void 0 ? r : (s = b.locale) === null || s === void 0 || (d = s.options) === null || d === void 0 ? void 0 : d.weekStartsOn) !== null && n !== void 0 ? n : 0);
  if (!(y >= 0 && y <= 6))
    throw new RangeError("weekStartsOn must be between 0 and 6 inclusively");
  var f = ae(e), v = f.getDay(), A = (v < y ? 7 : 0) + v - y;
  return f.setDate(f.getDate() - A), f.setHours(0, 0, 0, 0), f;
}
function Gn(e) {
  return J(1, arguments), aa(e, {
    weekStartsOn: 1
  });
}
function Tl(e) {
  J(1, arguments);
  var t = ae(e), n = t.getFullYear(), r = new Date(0);
  r.setFullYear(n + 1, 0, 4), r.setHours(0, 0, 0, 0);
  var a = Gn(r), o = new Date(0);
  o.setFullYear(n, 0, 4), o.setHours(0, 0, 0, 0);
  var i = Gn(o);
  return t.getTime() >= a.getTime() ? n + 1 : t.getTime() >= i.getTime() ? n : n - 1;
}
function Dl(e) {
  J(1, arguments);
  var t = Tl(e), n = new Date(0);
  n.setFullYear(t, 0, 4), n.setHours(0, 0, 0, 0);
  var r = Gn(n);
  return r;
}
function Qn(e) {
  var t = new Date(Date.UTC(e.getFullYear(), e.getMonth(), e.getDate(), e.getHours(), e.getMinutes(), e.getSeconds(), e.getMilliseconds()));
  return t.setUTCFullYear(e.getFullYear()), e.getTime() - t.getTime();
}
function Io(e) {
  J(1, arguments);
  var t = ae(e);
  return t.setHours(0, 0, 0, 0), t;
}
var Sl = 864e5;
function xl(e, t) {
  J(2, arguments);
  var n = Io(e), r = Io(t), a = n.getTime() - Qn(n), o = r.getTime() - Qn(r);
  return Math.round((a - o) / Sl);
}
function wu(e, t) {
  J(2, arguments);
  var n = re(t);
  return ot(e, n * 12);
}
var Oo = 6e4, $o = 36e5, Rl = 1e3;
function sn(e) {
  return typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? sn = function(n) {
    return typeof n;
  } : sn = function(n) {
    return n && typeof Symbol == "function" && n.constructor === Symbol && n !== Symbol.prototype ? "symbol" : typeof n;
  }, sn(e);
}
function _u(e) {
  return J(1, arguments), e instanceof Date || sn(e) === "object" && Object.prototype.toString.call(e) === "[object Date]";
}
function Ht(e) {
  if (J(1, arguments), !_u(e) && typeof e != "number")
    return !1;
  var t = ae(e);
  return !isNaN(Number(t));
}
function Eo(e, t) {
  var n;
  J(1, arguments);
  var r = e || {}, a = ae(r.start), o = ae(r.end), i = o.getTime();
  if (!(a.getTime() <= i))
    throw new RangeError("Invalid interval");
  var c = [], s = a;
  s.setHours(0, 0, 0, 0);
  var d = Number((n = t == null ? void 0 : t.step) !== null && n !== void 0 ? n : 1);
  if (d < 1 || isNaN(d))
    throw new RangeError("`options.step` must be a number greater than 1");
  for (; s.getTime() <= i; )
    c.push(ae(s)), s.setDate(s.getDate() + d), s.setHours(0, 0, 0, 0);
  return c;
}
function Ml(e, t) {
  var n, r, a, o, i, c, s, d;
  J(1, arguments);
  var b = vt(), y = re((n = (r = (a = (o = t == null ? void 0 : t.weekStartsOn) !== null && o !== void 0 ? o : t == null || (i = t.locale) === null || i === void 0 || (c = i.options) === null || c === void 0 ? void 0 : c.weekStartsOn) !== null && a !== void 0 ? a : b.weekStartsOn) !== null && r !== void 0 ? r : (s = b.locale) === null || s === void 0 || (d = s.options) === null || d === void 0 ? void 0 : d.weekStartsOn) !== null && n !== void 0 ? n : 0);
  if (!(y >= 0 && y <= 6))
    throw new RangeError("weekStartsOn must be between 0 and 6 inclusively");
  var f = ae(e), v = f.getDay(), A = (v < y ? -7 : 0) + 6 - (v - y);
  return f.setDate(f.getDate() + A), f.setHours(23, 59, 59, 999), f;
}
function Ou(e, t) {
  J(2, arguments);
  var n = re(t);
  return Pl(e, -n);
}
var Nl = 864e5;
function Cl(e) {
  J(1, arguments);
  var t = ae(e), n = t.getTime();
  t.setUTCMonth(0, 1), t.setUTCHours(0, 0, 0, 0);
  var r = t.getTime(), a = n - r;
  return Math.floor(a / Nl) + 1;
}
function Bt(e) {
  J(1, arguments);
  var t = 1, n = ae(e), r = n.getUTCDay(), a = (r < t ? 7 : 0) + r - t;
  return n.setUTCDate(n.getUTCDate() - a), n.setUTCHours(0, 0, 0, 0), n;
}
function $u(e) {
  J(1, arguments);
  var t = ae(e), n = t.getUTCFullYear(), r = new Date(0);
  r.setUTCFullYear(n + 1, 0, 4), r.setUTCHours(0, 0, 0, 0);
  var a = Bt(r), o = new Date(0);
  o.setUTCFullYear(n, 0, 4), o.setUTCHours(0, 0, 0, 0);
  var i = Bt(o);
  return t.getTime() >= a.getTime() ? n + 1 : t.getTime() >= i.getTime() ? n : n - 1;
}
function Bl(e) {
  J(1, arguments);
  var t = $u(e), n = new Date(0);
  n.setUTCFullYear(t, 0, 4), n.setUTCHours(0, 0, 0, 0);
  var r = Bt(n);
  return r;
}
var Al = 6048e5;
function Pu(e) {
  J(1, arguments);
  var t = ae(e), n = Bt(t).getTime() - Bl(t).getTime();
  return Math.round(n / Al) + 1;
}
function kt(e, t) {
  var n, r, a, o, i, c, s, d;
  J(1, arguments);
  var b = vt(), y = re((n = (r = (a = (o = t == null ? void 0 : t.weekStartsOn) !== null && o !== void 0 ? o : t == null || (i = t.locale) === null || i === void 0 || (c = i.options) === null || c === void 0 ? void 0 : c.weekStartsOn) !== null && a !== void 0 ? a : b.weekStartsOn) !== null && r !== void 0 ? r : (s = b.locale) === null || s === void 0 || (d = s.options) === null || d === void 0 ? void 0 : d.weekStartsOn) !== null && n !== void 0 ? n : 0);
  if (!(y >= 0 && y <= 6))
    throw new RangeError("weekStartsOn must be between 0 and 6 inclusively");
  var f = ae(e), v = f.getUTCDay(), A = (v < y ? 7 : 0) + v - y;
  return f.setUTCDate(f.getUTCDate() - A), f.setUTCHours(0, 0, 0, 0), f;
}
function Po(e, t) {
  var n, r, a, o, i, c, s, d;
  J(1, arguments);
  var b = ae(e), y = b.getUTCFullYear(), f = vt(), v = re((n = (r = (a = (o = t == null ? void 0 : t.firstWeekContainsDate) !== null && o !== void 0 ? o : t == null || (i = t.locale) === null || i === void 0 || (c = i.options) === null || c === void 0 ? void 0 : c.firstWeekContainsDate) !== null && a !== void 0 ? a : f.firstWeekContainsDate) !== null && r !== void 0 ? r : (s = f.locale) === null || s === void 0 || (d = s.options) === null || d === void 0 ? void 0 : d.firstWeekContainsDate) !== null && n !== void 0 ? n : 1);
  if (!(v >= 1 && v <= 7))
    throw new RangeError("firstWeekContainsDate must be between 1 and 7 inclusively");
  var A = new Date(0);
  A.setUTCFullYear(y + 1, 0, v), A.setUTCHours(0, 0, 0, 0);
  var V = kt(A, t), q = new Date(0);
  q.setUTCFullYear(y, 0, v), q.setUTCHours(0, 0, 0, 0);
  var ee = kt(q, t);
  return b.getTime() >= V.getTime() ? y + 1 : b.getTime() >= ee.getTime() ? y : y - 1;
}
function Il(e, t) {
  var n, r, a, o, i, c, s, d;
  J(1, arguments);
  var b = vt(), y = re((n = (r = (a = (o = t == null ? void 0 : t.firstWeekContainsDate) !== null && o !== void 0 ? o : t == null || (i = t.locale) === null || i === void 0 || (c = i.options) === null || c === void 0 ? void 0 : c.firstWeekContainsDate) !== null && a !== void 0 ? a : b.firstWeekContainsDate) !== null && r !== void 0 ? r : (s = b.locale) === null || s === void 0 || (d = s.options) === null || d === void 0 ? void 0 : d.firstWeekContainsDate) !== null && n !== void 0 ? n : 1), f = Po(e, t), v = new Date(0);
  v.setUTCFullYear(f, 0, y), v.setUTCHours(0, 0, 0, 0);
  var A = kt(v, t);
  return A;
}
var El = 6048e5;
function ku(e, t) {
  J(1, arguments);
  var n = ae(e), r = kt(n, t).getTime() - Il(n, t).getTime();
  return Math.round(r / El) + 1;
}
function we(e, t) {
  for (var n = e < 0 ? "-" : "", r = Math.abs(e).toString(); r.length < t; )
    r = "0" + r;
  return n + r;
}
var Yl = {
  // Year
  y: function(t, n) {
    var r = t.getUTCFullYear(), a = r > 0 ? r : 1 - r;
    return we(n === "yy" ? a % 100 : a, n.length);
  },
  // Month
  M: function(t, n) {
    var r = t.getUTCMonth();
    return n === "M" ? String(r + 1) : we(r + 1, 2);
  },
  // Day of the month
  d: function(t, n) {
    return we(t.getUTCDate(), n.length);
  },
  // AM or PM
  a: function(t, n) {
    var r = t.getUTCHours() / 12 >= 1 ? "pm" : "am";
    switch (n) {
      case "a":
      case "aa":
        return r.toUpperCase();
      case "aaa":
        return r;
      case "aaaaa":
        return r[0];
      case "aaaa":
      default:
        return r === "am" ? "a.m." : "p.m.";
    }
  },
  // Hour [1-12]
  h: function(t, n) {
    return we(t.getUTCHours() % 12 || 12, n.length);
  },
  // Hour [0-23]
  H: function(t, n) {
    return we(t.getUTCHours(), n.length);
  },
  // Minute
  m: function(t, n) {
    return we(t.getUTCMinutes(), n.length);
  },
  // Second
  s: function(t, n) {
    return we(t.getUTCSeconds(), n.length);
  },
  // Fraction of second
  S: function(t, n) {
    var r = n.length, a = t.getUTCMilliseconds(), o = Math.floor(a * Math.pow(10, r - 3));
    return we(o, n.length);
  }
};
const dt = Yl;
var Rt = {
  am: "am",
  pm: "pm",
  midnight: "midnight",
  noon: "noon",
  morning: "morning",
  afternoon: "afternoon",
  evening: "evening",
  night: "night"
}, Vl = {
  // Era
  G: function(t, n, r) {
    var a = t.getUTCFullYear() > 0 ? 1 : 0;
    switch (n) {
      case "G":
      case "GG":
      case "GGG":
        return r.era(a, {
          width: "abbreviated"
        });
      case "GGGGG":
        return r.era(a, {
          width: "narrow"
        });
      case "GGGG":
      default:
        return r.era(a, {
          width: "wide"
        });
    }
  },
  // Year
  y: function(t, n, r) {
    if (n === "yo") {
      var a = t.getUTCFullYear(), o = a > 0 ? a : 1 - a;
      return r.ordinalNumber(o, {
        unit: "year"
      });
    }
    return dt.y(t, n);
  },
  // Local week-numbering year
  Y: function(t, n, r, a) {
    var o = Po(t, a), i = o > 0 ? o : 1 - o;
    if (n === "YY") {
      var c = i % 100;
      return we(c, 2);
    }
    return n === "Yo" ? r.ordinalNumber(i, {
      unit: "year"
    }) : we(i, n.length);
  },
  // ISO week-numbering year
  R: function(t, n) {
    var r = $u(t);
    return we(r, n.length);
  },
  // Extended year. This is a single number designating the year of this calendar system.
  // The main difference between `y` and `u` localizers are B.C. years:
  // | Year | `y` | `u` |
  // |------|-----|-----|
  // | AC 1 |   1 |   1 |
  // | BC 1 |   1 |   0 |
  // | BC 2 |   2 |  -1 |
  // Also `yy` always returns the last two digits of a year,
  // while `uu` pads single digit years to 2 characters and returns other years unchanged.
  u: function(t, n) {
    var r = t.getUTCFullYear();
    return we(r, n.length);
  },
  // Quarter
  Q: function(t, n, r) {
    var a = Math.ceil((t.getUTCMonth() + 1) / 3);
    switch (n) {
      case "Q":
        return String(a);
      case "QQ":
        return we(a, 2);
      case "Qo":
        return r.ordinalNumber(a, {
          unit: "quarter"
        });
      case "QQQ":
        return r.quarter(a, {
          width: "abbreviated",
          context: "formatting"
        });
      case "QQQQQ":
        return r.quarter(a, {
          width: "narrow",
          context: "formatting"
        });
      case "QQQQ":
      default:
        return r.quarter(a, {
          width: "wide",
          context: "formatting"
        });
    }
  },
  // Stand-alone quarter
  q: function(t, n, r) {
    var a = Math.ceil((t.getUTCMonth() + 1) / 3);
    switch (n) {
      case "q":
        return String(a);
      case "qq":
        return we(a, 2);
      case "qo":
        return r.ordinalNumber(a, {
          unit: "quarter"
        });
      case "qqq":
        return r.quarter(a, {
          width: "abbreviated",
          context: "standalone"
        });
      case "qqqqq":
        return r.quarter(a, {
          width: "narrow",
          context: "standalone"
        });
      case "qqqq":
      default:
        return r.quarter(a, {
          width: "wide",
          context: "standalone"
        });
    }
  },
  // Month
  M: function(t, n, r) {
    var a = t.getUTCMonth();
    switch (n) {
      case "M":
      case "MM":
        return dt.M(t, n);
      case "Mo":
        return r.ordinalNumber(a + 1, {
          unit: "month"
        });
      case "MMM":
        return r.month(a, {
          width: "abbreviated",
          context: "formatting"
        });
      case "MMMMM":
        return r.month(a, {
          width: "narrow",
          context: "formatting"
        });
      case "MMMM":
      default:
        return r.month(a, {
          width: "wide",
          context: "formatting"
        });
    }
  },
  // Stand-alone month
  L: function(t, n, r) {
    var a = t.getUTCMonth();
    switch (n) {
      case "L":
        return String(a + 1);
      case "LL":
        return we(a + 1, 2);
      case "Lo":
        return r.ordinalNumber(a + 1, {
          unit: "month"
        });
      case "LLL":
        return r.month(a, {
          width: "abbreviated",
          context: "standalone"
        });
      case "LLLLL":
        return r.month(a, {
          width: "narrow",
          context: "standalone"
        });
      case "LLLL":
      default:
        return r.month(a, {
          width: "wide",
          context: "standalone"
        });
    }
  },
  // Local week of year
  w: function(t, n, r, a) {
    var o = ku(t, a);
    return n === "wo" ? r.ordinalNumber(o, {
      unit: "week"
    }) : we(o, n.length);
  },
  // ISO week of year
  I: function(t, n, r) {
    var a = Pu(t);
    return n === "Io" ? r.ordinalNumber(a, {
      unit: "week"
    }) : we(a, n.length);
  },
  // Day of the month
  d: function(t, n, r) {
    return n === "do" ? r.ordinalNumber(t.getUTCDate(), {
      unit: "date"
    }) : dt.d(t, n);
  },
  // Day of year
  D: function(t, n, r) {
    var a = Cl(t);
    return n === "Do" ? r.ordinalNumber(a, {
      unit: "dayOfYear"
    }) : we(a, n.length);
  },
  // Day of week
  E: function(t, n, r) {
    var a = t.getUTCDay();
    switch (n) {
      case "E":
      case "EE":
      case "EEE":
        return r.day(a, {
          width: "abbreviated",
          context: "formatting"
        });
      case "EEEEE":
        return r.day(a, {
          width: "narrow",
          context: "formatting"
        });
      case "EEEEEE":
        return r.day(a, {
          width: "short",
          context: "formatting"
        });
      case "EEEE":
      default:
        return r.day(a, {
          width: "wide",
          context: "formatting"
        });
    }
  },
  // Local day of week
  e: function(t, n, r, a) {
    var o = t.getUTCDay(), i = (o - a.weekStartsOn + 8) % 7 || 7;
    switch (n) {
      case "e":
        return String(i);
      case "ee":
        return we(i, 2);
      case "eo":
        return r.ordinalNumber(i, {
          unit: "day"
        });
      case "eee":
        return r.day(o, {
          width: "abbreviated",
          context: "formatting"
        });
      case "eeeee":
        return r.day(o, {
          width: "narrow",
          context: "formatting"
        });
      case "eeeeee":
        return r.day(o, {
          width: "short",
          context: "formatting"
        });
      case "eeee":
      default:
        return r.day(o, {
          width: "wide",
          context: "formatting"
        });
    }
  },
  // Stand-alone local day of week
  c: function(t, n, r, a) {
    var o = t.getUTCDay(), i = (o - a.weekStartsOn + 8) % 7 || 7;
    switch (n) {
      case "c":
        return String(i);
      case "cc":
        return we(i, n.length);
      case "co":
        return r.ordinalNumber(i, {
          unit: "day"
        });
      case "ccc":
        return r.day(o, {
          width: "abbreviated",
          context: "standalone"
        });
      case "ccccc":
        return r.day(o, {
          width: "narrow",
          context: "standalone"
        });
      case "cccccc":
        return r.day(o, {
          width: "short",
          context: "standalone"
        });
      case "cccc":
      default:
        return r.day(o, {
          width: "wide",
          context: "standalone"
        });
    }
  },
  // ISO day of week
  i: function(t, n, r) {
    var a = t.getUTCDay(), o = a === 0 ? 7 : a;
    switch (n) {
      case "i":
        return String(o);
      case "ii":
        return we(o, n.length);
      case "io":
        return r.ordinalNumber(o, {
          unit: "day"
        });
      case "iii":
        return r.day(a, {
          width: "abbreviated",
          context: "formatting"
        });
      case "iiiii":
        return r.day(a, {
          width: "narrow",
          context: "formatting"
        });
      case "iiiiii":
        return r.day(a, {
          width: "short",
          context: "formatting"
        });
      case "iiii":
      default:
        return r.day(a, {
          width: "wide",
          context: "formatting"
        });
    }
  },
  // AM or PM
  a: function(t, n, r) {
    var a = t.getUTCHours(), o = a / 12 >= 1 ? "pm" : "am";
    switch (n) {
      case "a":
      case "aa":
        return r.dayPeriod(o, {
          width: "abbreviated",
          context: "formatting"
        });
      case "aaa":
        return r.dayPeriod(o, {
          width: "abbreviated",
          context: "formatting"
        }).toLowerCase();
      case "aaaaa":
        return r.dayPeriod(o, {
          width: "narrow",
          context: "formatting"
        });
      case "aaaa":
      default:
        return r.dayPeriod(o, {
          width: "wide",
          context: "formatting"
        });
    }
  },
  // AM, PM, midnight, noon
  b: function(t, n, r) {
    var a = t.getUTCHours(), o;
    switch (a === 12 ? o = Rt.noon : a === 0 ? o = Rt.midnight : o = a / 12 >= 1 ? "pm" : "am", n) {
      case "b":
      case "bb":
        return r.dayPeriod(o, {
          width: "abbreviated",
          context: "formatting"
        });
      case "bbb":
        return r.dayPeriod(o, {
          width: "abbreviated",
          context: "formatting"
        }).toLowerCase();
      case "bbbbb":
        return r.dayPeriod(o, {
          width: "narrow",
          context: "formatting"
        });
      case "bbbb":
      default:
        return r.dayPeriod(o, {
          width: "wide",
          context: "formatting"
        });
    }
  },
  // in the morning, in the afternoon, in the evening, at night
  B: function(t, n, r) {
    var a = t.getUTCHours(), o;
    switch (a >= 17 ? o = Rt.evening : a >= 12 ? o = Rt.afternoon : a >= 4 ? o = Rt.morning : o = Rt.night, n) {
      case "B":
      case "BB":
      case "BBB":
        return r.dayPeriod(o, {
          width: "abbreviated",
          context: "formatting"
        });
      case "BBBBB":
        return r.dayPeriod(o, {
          width: "narrow",
          context: "formatting"
        });
      case "BBBB":
      default:
        return r.dayPeriod(o, {
          width: "wide",
          context: "formatting"
        });
    }
  },
  // Hour [1-12]
  h: function(t, n, r) {
    if (n === "ho") {
      var a = t.getUTCHours() % 12;
      return a === 0 && (a = 12), r.ordinalNumber(a, {
        unit: "hour"
      });
    }
    return dt.h(t, n);
  },
  // Hour [0-23]
  H: function(t, n, r) {
    return n === "Ho" ? r.ordinalNumber(t.getUTCHours(), {
      unit: "hour"
    }) : dt.H(t, n);
  },
  // Hour [0-11]
  K: function(t, n, r) {
    var a = t.getUTCHours() % 12;
    return n === "Ko" ? r.ordinalNumber(a, {
      unit: "hour"
    }) : we(a, n.length);
  },
  // Hour [1-24]
  k: function(t, n, r) {
    var a = t.getUTCHours();
    return a === 0 && (a = 24), n === "ko" ? r.ordinalNumber(a, {
      unit: "hour"
    }) : we(a, n.length);
  },
  // Minute
  m: function(t, n, r) {
    return n === "mo" ? r.ordinalNumber(t.getUTCMinutes(), {
      unit: "minute"
    }) : dt.m(t, n);
  },
  // Second
  s: function(t, n, r) {
    return n === "so" ? r.ordinalNumber(t.getUTCSeconds(), {
      unit: "second"
    }) : dt.s(t, n);
  },
  // Fraction of second
  S: function(t, n) {
    return dt.S(t, n);
  },
  // Timezone (ISO-8601. If offset is 0, output is always `'Z'`)
  X: function(t, n, r, a) {
    var o = a._originalDate || t, i = o.getTimezoneOffset();
    if (i === 0)
      return "Z";
    switch (n) {
      case "X":
        return Vo(i);
      case "XXXX":
      case "XX":
        return Ot(i);
      case "XXXXX":
      case "XXX":
      default:
        return Ot(i, ":");
    }
  },
  // Timezone (ISO-8601. If offset is 0, output is `'+00:00'` or equivalent)
  x: function(t, n, r, a) {
    var o = a._originalDate || t, i = o.getTimezoneOffset();
    switch (n) {
      case "x":
        return Vo(i);
      case "xxxx":
      case "xx":
        return Ot(i);
      case "xxxxx":
      case "xxx":
      default:
        return Ot(i, ":");
    }
  },
  // Timezone (GMT)
  O: function(t, n, r, a) {
    var o = a._originalDate || t, i = o.getTimezoneOffset();
    switch (n) {
      case "O":
      case "OO":
      case "OOO":
        return "GMT" + Yo(i, ":");
      case "OOOO":
      default:
        return "GMT" + Ot(i, ":");
    }
  },
  // Timezone (specific non-location)
  z: function(t, n, r, a) {
    var o = a._originalDate || t, i = o.getTimezoneOffset();
    switch (n) {
      case "z":
      case "zz":
      case "zzz":
        return "GMT" + Yo(i, ":");
      case "zzzz":
      default:
        return "GMT" + Ot(i, ":");
    }
  },
  // Seconds timestamp
  t: function(t, n, r, a) {
    var o = a._originalDate || t, i = Math.floor(o.getTime() / 1e3);
    return we(i, n.length);
  },
  // Milliseconds timestamp
  T: function(t, n, r, a) {
    var o = a._originalDate || t, i = o.getTime();
    return we(i, n.length);
  }
};
function Yo(e, t) {
  var n = e > 0 ? "-" : "+", r = Math.abs(e), a = Math.floor(r / 60), o = r % 60;
  if (o === 0)
    return n + String(a);
  var i = t || "";
  return n + String(a) + i + we(o, 2);
}
function Vo(e, t) {
  if (e % 60 === 0) {
    var n = e > 0 ? "-" : "+";
    return n + we(Math.abs(e) / 60, 2);
  }
  return Ot(e, t);
}
function Ot(e, t) {
  var n = t || "", r = e > 0 ? "-" : "+", a = Math.abs(e), o = we(Math.floor(a / 60), 2), i = we(a % 60, 2);
  return r + o + n + i;
}
const Fl = Vl;
var Fo = function(t, n) {
  switch (t) {
    case "P":
      return n.date({
        width: "short"
      });
    case "PP":
      return n.date({
        width: "medium"
      });
    case "PPP":
      return n.date({
        width: "long"
      });
    case "PPPP":
    default:
      return n.date({
        width: "full"
      });
  }
}, Tu = function(t, n) {
  switch (t) {
    case "p":
      return n.time({
        width: "short"
      });
    case "pp":
      return n.time({
        width: "medium"
      });
    case "ppp":
      return n.time({
        width: "long"
      });
    case "pppp":
    default:
      return n.time({
        width: "full"
      });
  }
}, Ul = function(t, n) {
  var r = t.match(/(P+)(p+)?/) || [], a = r[1], o = r[2];
  if (!o)
    return Fo(t, n);
  var i;
  switch (a) {
    case "P":
      i = n.dateTime({
        width: "short"
      });
      break;
    case "PP":
      i = n.dateTime({
        width: "medium"
      });
      break;
    case "PPP":
      i = n.dateTime({
        width: "long"
      });
      break;
    case "PPPP":
    default:
      i = n.dateTime({
        width: "full"
      });
      break;
  }
  return i.replace("{{date}}", Fo(a, n)).replace("{{time}}", Tu(o, n));
}, Ll = {
  p: Tu,
  P: Ul
};
const oa = Ll;
var Wl = ["D", "DD"], zl = ["YY", "YYYY"];
function Du(e) {
  return Wl.indexOf(e) !== -1;
}
function Su(e) {
  return zl.indexOf(e) !== -1;
}
function Xn(e, t, n) {
  if (e === "YYYY")
    throw new RangeError("Use `yyyy` instead of `YYYY` (in `".concat(t, "`) for formatting years to the input `").concat(n, "`; see: https://github.com/date-fns/date-fns/blob/master/docs/unicodeTokens.md"));
  if (e === "YY")
    throw new RangeError("Use `yy` instead of `YY` (in `".concat(t, "`) for formatting years to the input `").concat(n, "`; see: https://github.com/date-fns/date-fns/blob/master/docs/unicodeTokens.md"));
  if (e === "D")
    throw new RangeError("Use `d` instead of `D` (in `".concat(t, "`) for formatting days of the month to the input `").concat(n, "`; see: https://github.com/date-fns/date-fns/blob/master/docs/unicodeTokens.md"));
  if (e === "DD")
    throw new RangeError("Use `dd` instead of `DD` (in `".concat(t, "`) for formatting days of the month to the input `").concat(n, "`; see: https://github.com/date-fns/date-fns/blob/master/docs/unicodeTokens.md"));
}
var Hl = {
  lessThanXSeconds: {
    one: "less than a second",
    other: "less than {{count}} seconds"
  },
  xSeconds: {
    one: "1 second",
    other: "{{count}} seconds"
  },
  halfAMinute: "half a minute",
  lessThanXMinutes: {
    one: "less than a minute",
    other: "less than {{count}} minutes"
  },
  xMinutes: {
    one: "1 minute",
    other: "{{count}} minutes"
  },
  aboutXHours: {
    one: "about 1 hour",
    other: "about {{count}} hours"
  },
  xHours: {
    one: "1 hour",
    other: "{{count}} hours"
  },
  xDays: {
    one: "1 day",
    other: "{{count}} days"
  },
  aboutXWeeks: {
    one: "about 1 week",
    other: "about {{count}} weeks"
  },
  xWeeks: {
    one: "1 week",
    other: "{{count}} weeks"
  },
  aboutXMonths: {
    one: "about 1 month",
    other: "about {{count}} months"
  },
  xMonths: {
    one: "1 month",
    other: "{{count}} months"
  },
  aboutXYears: {
    one: "about 1 year",
    other: "about {{count}} years"
  },
  xYears: {
    one: "1 year",
    other: "{{count}} years"
  },
  overXYears: {
    one: "over 1 year",
    other: "over {{count}} years"
  },
  almostXYears: {
    one: "almost 1 year",
    other: "almost {{count}} years"
  }
}, jl = function(t, n, r) {
  var a, o = Hl[t];
  return typeof o == "string" ? a = o : n === 1 ? a = o.one : a = o.other.replace("{{count}}", n.toString()), r != null && r.addSuffix ? r.comparison && r.comparison > 0 ? "in " + a : a + " ago" : a;
};
const ql = jl;
function Wr(e) {
  return function() {
    var t = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {}, n = t.width ? String(t.width) : e.defaultWidth, r = e.formats[n] || e.formats[e.defaultWidth];
    return r;
  };
}
var Gl = {
  full: "EEEE, MMMM do, y",
  long: "MMMM do, y",
  medium: "MMM d, y",
  short: "MM/dd/yyyy"
}, Ql = {
  full: "h:mm:ss a zzzz",
  long: "h:mm:ss a z",
  medium: "h:mm:ss a",
  short: "h:mm a"
}, Xl = {
  full: "{{date}} 'at' {{time}}",
  long: "{{date}} 'at' {{time}}",
  medium: "{{date}}, {{time}}",
  short: "{{date}}, {{time}}"
}, Kl = {
  date: Wr({
    formats: Gl,
    defaultWidth: "full"
  }),
  time: Wr({
    formats: Ql,
    defaultWidth: "full"
  }),
  dateTime: Wr({
    formats: Xl,
    defaultWidth: "full"
  })
};
const Jl = Kl;
var Zl = {
  lastWeek: "'last' eeee 'at' p",
  yesterday: "'yesterday at' p",
  today: "'today at' p",
  tomorrow: "'tomorrow at' p",
  nextWeek: "eeee 'at' p",
  other: "P"
}, es = function(t, n, r, a) {
  return Zl[t];
};
const ts = es;
function Ut(e) {
  return function(t, n) {
    var r = n != null && n.context ? String(n.context) : "standalone", a;
    if (r === "formatting" && e.formattingValues) {
      var o = e.defaultFormattingWidth || e.defaultWidth, i = n != null && n.width ? String(n.width) : o;
      a = e.formattingValues[i] || e.formattingValues[o];
    } else {
      var c = e.defaultWidth, s = n != null && n.width ? String(n.width) : e.defaultWidth;
      a = e.values[s] || e.values[c];
    }
    var d = e.argumentCallback ? e.argumentCallback(t) : t;
    return a[d];
  };
}
var ns = {
  narrow: ["B", "A"],
  abbreviated: ["BC", "AD"],
  wide: ["Before Christ", "Anno Domini"]
}, rs = {
  narrow: ["1", "2", "3", "4"],
  abbreviated: ["Q1", "Q2", "Q3", "Q4"],
  wide: ["1st quarter", "2nd quarter", "3rd quarter", "4th quarter"]
}, as = {
  narrow: ["J", "F", "M", "A", "M", "J", "J", "A", "S", "O", "N", "D"],
  abbreviated: ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"],
  wide: ["January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"]
}, os = {
  narrow: ["S", "M", "T", "W", "T", "F", "S"],
  short: ["Su", "Mo", "Tu", "We", "Th", "Fr", "Sa"],
  abbreviated: ["Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"],
  wide: ["Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"]
}, is = {
  narrow: {
    am: "a",
    pm: "p",
    midnight: "mi",
    noon: "n",
    morning: "morning",
    afternoon: "afternoon",
    evening: "evening",
    night: "night"
  },
  abbreviated: {
    am: "AM",
    pm: "PM",
    midnight: "midnight",
    noon: "noon",
    morning: "morning",
    afternoon: "afternoon",
    evening: "evening",
    night: "night"
  },
  wide: {
    am: "a.m.",
    pm: "p.m.",
    midnight: "midnight",
    noon: "noon",
    morning: "morning",
    afternoon: "afternoon",
    evening: "evening",
    night: "night"
  }
}, us = {
  narrow: {
    am: "a",
    pm: "p",
    midnight: "mi",
    noon: "n",
    morning: "in the morning",
    afternoon: "in the afternoon",
    evening: "in the evening",
    night: "at night"
  },
  abbreviated: {
    am: "AM",
    pm: "PM",
    midnight: "midnight",
    noon: "noon",
    morning: "in the morning",
    afternoon: "in the afternoon",
    evening: "in the evening",
    night: "at night"
  },
  wide: {
    am: "a.m.",
    pm: "p.m.",
    midnight: "midnight",
    noon: "noon",
    morning: "in the morning",
    afternoon: "in the afternoon",
    evening: "in the evening",
    night: "at night"
  }
}, ls = function(t, n) {
  var r = Number(t), a = r % 100;
  if (a > 20 || a < 10)
    switch (a % 10) {
      case 1:
        return r + "st";
      case 2:
        return r + "nd";
      case 3:
        return r + "rd";
    }
  return r + "th";
}, ss = {
  ordinalNumber: ls,
  era: Ut({
    values: ns,
    defaultWidth: "wide"
  }),
  quarter: Ut({
    values: rs,
    defaultWidth: "wide",
    argumentCallback: function(t) {
      return t - 1;
    }
  }),
  month: Ut({
    values: as,
    defaultWidth: "wide"
  }),
  day: Ut({
    values: os,
    defaultWidth: "wide"
  }),
  dayPeriod: Ut({
    values: is,
    defaultWidth: "wide",
    formattingValues: us,
    defaultFormattingWidth: "wide"
  })
};
const cs = ss;
function Lt(e) {
  return function(t) {
    var n = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {}, r = n.width, a = r && e.matchPatterns[r] || e.matchPatterns[e.defaultMatchWidth], o = t.match(a);
    if (!o)
      return null;
    var i = o[0], c = r && e.parsePatterns[r] || e.parsePatterns[e.defaultParseWidth], s = Array.isArray(c) ? ds(c, function(y) {
      return y.test(i);
    }) : fs(c, function(y) {
      return y.test(i);
    }), d;
    d = e.valueCallback ? e.valueCallback(s) : s, d = n.valueCallback ? n.valueCallback(d) : d;
    var b = t.slice(i.length);
    return {
      value: d,
      rest: b
    };
  };
}
function fs(e, t) {
  for (var n in e)
    if (e.hasOwnProperty(n) && t(e[n]))
      return n;
}
function ds(e, t) {
  for (var n = 0; n < e.length; n++)
    if (t(e[n]))
      return n;
}
function ys(e) {
  return function(t) {
    var n = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {}, r = t.match(e.matchPattern);
    if (!r)
      return null;
    var a = r[0], o = t.match(e.parsePattern);
    if (!o)
      return null;
    var i = e.valueCallback ? e.valueCallback(o[0]) : o[0];
    i = n.valueCallback ? n.valueCallback(i) : i;
    var c = t.slice(a.length);
    return {
      value: i,
      rest: c
    };
  };
}
var ps = /^(\d+)(th|st|nd|rd)?/i, ms = /\d+/i, vs = {
  narrow: /^(b|a)/i,
  abbreviated: /^(b\.?\s?c\.?|b\.?\s?c\.?\s?e\.?|a\.?\s?d\.?|c\.?\s?e\.?)/i,
  wide: /^(before christ|before common era|anno domini|common era)/i
}, hs = {
  any: [/^b/i, /^(a|c)/i]
}, bs = {
  narrow: /^[1234]/i,
  abbreviated: /^q[1234]/i,
  wide: /^[1234](th|st|nd|rd)? quarter/i
}, gs = {
  any: [/1/i, /2/i, /3/i, /4/i]
}, ws = {
  narrow: /^[jfmasond]/i,
  abbreviated: /^(jan|feb|mar|apr|may|jun|jul|aug|sep|oct|nov|dec)/i,
  wide: /^(january|february|march|april|may|june|july|august|september|october|november|december)/i
}, _s = {
  narrow: [/^j/i, /^f/i, /^m/i, /^a/i, /^m/i, /^j/i, /^j/i, /^a/i, /^s/i, /^o/i, /^n/i, /^d/i],
  any: [/^ja/i, /^f/i, /^mar/i, /^ap/i, /^may/i, /^jun/i, /^jul/i, /^au/i, /^s/i, /^o/i, /^n/i, /^d/i]
}, Os = {
  narrow: /^[smtwf]/i,
  short: /^(su|mo|tu|we|th|fr|sa)/i,
  abbreviated: /^(sun|mon|tue|wed|thu|fri|sat)/i,
  wide: /^(sunday|monday|tuesday|wednesday|thursday|friday|saturday)/i
}, $s = {
  narrow: [/^s/i, /^m/i, /^t/i, /^w/i, /^t/i, /^f/i, /^s/i],
  any: [/^su/i, /^m/i, /^tu/i, /^w/i, /^th/i, /^f/i, /^sa/i]
}, Ps = {
  narrow: /^(a|p|mi|n|(in the|at) (morning|afternoon|evening|night))/i,
  any: /^([ap]\.?\s?m\.?|midnight|noon|(in the|at) (morning|afternoon|evening|night))/i
}, ks = {
  any: {
    am: /^a/i,
    pm: /^p/i,
    midnight: /^mi/i,
    noon: /^no/i,
    morning: /morning/i,
    afternoon: /afternoon/i,
    evening: /evening/i,
    night: /night/i
  }
}, Ts = {
  ordinalNumber: ys({
    matchPattern: ps,
    parsePattern: ms,
    valueCallback: function(t) {
      return parseInt(t, 10);
    }
  }),
  era: Lt({
    matchPatterns: vs,
    defaultMatchWidth: "wide",
    parsePatterns: hs,
    defaultParseWidth: "any"
  }),
  quarter: Lt({
    matchPatterns: bs,
    defaultMatchWidth: "wide",
    parsePatterns: gs,
    defaultParseWidth: "any",
    valueCallback: function(t) {
      return t + 1;
    }
  }),
  month: Lt({
    matchPatterns: ws,
    defaultMatchWidth: "wide",
    parsePatterns: _s,
    defaultParseWidth: "any"
  }),
  day: Lt({
    matchPatterns: Os,
    defaultMatchWidth: "wide",
    parsePatterns: $s,
    defaultParseWidth: "any"
  }),
  dayPeriod: Lt({
    matchPatterns: Ps,
    defaultMatchWidth: "any",
    parsePatterns: ks,
    defaultParseWidth: "any"
  })
};
const Ds = Ts;
var Ss = {
  code: "en-US",
  formatDistance: ql,
  formatLong: Jl,
  formatRelative: ts,
  localize: cs,
  match: Ds,
  options: {
    weekStartsOn: 0,
    firstWeekContainsDate: 1
  }
};
const xu = Ss;
var xs = /[yYQqMLwIdDecihHKkms]o|(\w)\1*|''|'(''|[^'])+('|$)|./g, Rs = /P+p+|P+|p+|''|'(''|[^'])+('|$)|./g, Ms = /^'([^]*?)'?$/, Ns = /''/g, Cs = /[a-zA-Z]/;
function jt(e, t, n) {
  var r, a, o, i, c, s, d, b, y, f, v, A, V, q, ee, G, C, z;
  J(2, arguments);
  var te = String(t), P = vt(), $ = (r = (a = n == null ? void 0 : n.locale) !== null && a !== void 0 ? a : P.locale) !== null && r !== void 0 ? r : xu, M = re((o = (i = (c = (s = n == null ? void 0 : n.firstWeekContainsDate) !== null && s !== void 0 ? s : n == null || (d = n.locale) === null || d === void 0 || (b = d.options) === null || b === void 0 ? void 0 : b.firstWeekContainsDate) !== null && c !== void 0 ? c : P.firstWeekContainsDate) !== null && i !== void 0 ? i : (y = P.locale) === null || y === void 0 || (f = y.options) === null || f === void 0 ? void 0 : f.firstWeekContainsDate) !== null && o !== void 0 ? o : 1);
  if (!(M >= 1 && M <= 7))
    throw new RangeError("firstWeekContainsDate must be between 1 and 7 inclusively");
  var L = re((v = (A = (V = (q = n == null ? void 0 : n.weekStartsOn) !== null && q !== void 0 ? q : n == null || (ee = n.locale) === null || ee === void 0 || (G = ee.options) === null || G === void 0 ? void 0 : G.weekStartsOn) !== null && V !== void 0 ? V : P.weekStartsOn) !== null && A !== void 0 ? A : (C = P.locale) === null || C === void 0 || (z = C.options) === null || z === void 0 ? void 0 : z.weekStartsOn) !== null && v !== void 0 ? v : 0);
  if (!(L >= 0 && L <= 6))
    throw new RangeError("weekStartsOn must be between 0 and 6 inclusively");
  if (!$.localize)
    throw new RangeError("locale must contain localize property");
  if (!$.formatLong)
    throw new RangeError("locale must contain formatLong property");
  var j = ae(e);
  if (!Ht(j))
    throw new RangeError("Invalid time value");
  var Y = Qn(j), X = Ou(j, Y), O = {
    firstWeekContainsDate: M,
    weekStartsOn: L,
    locale: $,
    _originalDate: j
  }, m = te.match(Rs).map(function(k) {
    var D = k[0];
    if (D === "p" || D === "P") {
      var u = oa[D];
      return u(k, $.formatLong);
    }
    return k;
  }).join("").match(xs).map(function(k) {
    if (k === "''")
      return "'";
    var D = k[0];
    if (D === "'")
      return Bs(k);
    var u = Fl[D];
    if (u)
      return !(n != null && n.useAdditionalWeekYearTokens) && Su(k) && Xn(k, t, String(e)), !(n != null && n.useAdditionalDayOfYearTokens) && Du(k) && Xn(k, t, String(e)), u(X, k, $.localize, O);
    if (D.match(Cs))
      throw new RangeError("Format string contains an unescaped latin alphabet character `" + D + "`");
    return k;
  }).join("");
  return m;
}
function Bs(e) {
  var t = e.match(Ms);
  return t ? t[1].replace(Ns, "'") : e;
}
function As(e, t) {
  if (e == null)
    throw new TypeError("assign requires that input parameter not be null or undefined");
  for (var n in t)
    Object.prototype.hasOwnProperty.call(t, n) && (e[n] = t[n]);
  return e;
}
function Is(e) {
  J(1, arguments);
  var t = ae(e), n = t.getDay();
  return n;
}
function Es(e) {
  J(1, arguments);
  var t = ae(e), n = t.getFullYear(), r = t.getMonth(), a = new Date(0);
  return a.setFullYear(n, r + 1, 0), a.setHours(0, 0, 0, 0), a.getDate();
}
function lt(e) {
  J(1, arguments);
  var t = ae(e), n = t.getHours();
  return n;
}
var Ys = 6048e5;
function Vs(e) {
  J(1, arguments);
  var t = ae(e), n = Gn(t).getTime() - Dl(t).getTime();
  return Math.round(n / Ys) + 1;
}
function st(e) {
  J(1, arguments);
  var t = ae(e), n = t.getMinutes();
  return n;
}
function Pe(e) {
  J(1, arguments);
  var t = ae(e), n = t.getMonth();
  return n;
}
function At(e) {
  J(1, arguments);
  var t = ae(e), n = t.getSeconds();
  return n;
}
function ke(e) {
  return J(1, arguments), ae(e).getFullYear();
}
function ko(e, t) {
  J(2, arguments);
  var n = ae(e), r = ae(t);
  return n.getTime() > r.getTime();
}
function To(e, t) {
  J(2, arguments);
  var n = ae(e), r = ae(t);
  return n.getTime() < r.getTime();
}
function Ru(e, t) {
  J(2, arguments);
  var n = ae(e), r = ae(t);
  return n.getTime() === r.getTime();
}
function cn(e) {
  return typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? cn = function(n) {
    return typeof n;
  } : cn = function(n) {
    return n && typeof Symbol == "function" && n.constructor === Symbol && n !== Symbol.prototype ? "symbol" : typeof n;
  }, cn(e);
}
function Mu(e, t) {
  if (typeof t != "function" && t !== null)
    throw new TypeError("Super expression must either be null or a function");
  e.prototype = Object.create(t && t.prototype, { constructor: { value: e, writable: !0, configurable: !0 } }), t && ia(e, t);
}
function ia(e, t) {
  return ia = Object.setPrototypeOf || function(r, a) {
    return r.__proto__ = a, r;
  }, ia(e, t);
}
function Nu(e) {
  var t = Us();
  return function() {
    var r = Kn(e), a;
    if (t) {
      var o = Kn(this).constructor;
      a = Reflect.construct(r, arguments, o);
    } else
      a = r.apply(this, arguments);
    return Fs(this, a);
  };
}
function Fs(e, t) {
  return t && (cn(t) === "object" || typeof t == "function") ? t : ua(e);
}
function ua(e) {
  if (e === void 0)
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  return e;
}
function Us() {
  if (typeof Reflect > "u" || !Reflect.construct || Reflect.construct.sham)
    return !1;
  if (typeof Proxy == "function")
    return !0;
  try {
    return Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
    })), !0;
  } catch {
    return !1;
  }
}
function Kn(e) {
  return Kn = Object.setPrototypeOf ? Object.getPrototypeOf : function(n) {
    return n.__proto__ || Object.getPrototypeOf(n);
  }, Kn(e);
}
function Do(e, t) {
  if (!(e instanceof t))
    throw new TypeError("Cannot call a class as a function");
}
function Uo(e, t) {
  for (var n = 0; n < t.length; n++) {
    var r = t[n];
    r.enumerable = r.enumerable || !1, r.configurable = !0, "value" in r && (r.writable = !0), Object.defineProperty(e, r.key, r);
  }
}
function So(e, t, n) {
  return t && Uo(e.prototype, t), n && Uo(e, n), e;
}
function la(e, t, n) {
  return t in e ? Object.defineProperty(e, t, { value: n, enumerable: !0, configurable: !0, writable: !0 }) : e[t] = n, e;
}
var Ls = 10, Cu = /* @__PURE__ */ function() {
  function e() {
    Do(this, e), la(this, "subPriority", 0);
  }
  return So(e, [{
    key: "validate",
    value: function(n, r) {
      return !0;
    }
  }]), e;
}(), Ws = /* @__PURE__ */ function(e) {
  Mu(n, e);
  var t = Nu(n);
  function n(r, a, o, i, c) {
    var s;
    return Do(this, n), s = t.call(this), s.value = r, s.validateValue = a, s.setValue = o, s.priority = i, c && (s.subPriority = c), s;
  }
  return So(n, [{
    key: "validate",
    value: function(a, o) {
      return this.validateValue(a, this.value, o);
    }
  }, {
    key: "set",
    value: function(a, o, i) {
      return this.setValue(a, o, this.value, i);
    }
  }]), n;
}(Cu), zs = /* @__PURE__ */ function(e) {
  Mu(n, e);
  var t = Nu(n);
  function n() {
    var r;
    Do(this, n);
    for (var a = arguments.length, o = new Array(a), i = 0; i < a; i++)
      o[i] = arguments[i];
    return r = t.call.apply(t, [this].concat(o)), la(ua(r), "priority", Ls), la(ua(r), "subPriority", -1), r;
  }
  return So(n, [{
    key: "set",
    value: function(a, o) {
      if (o.timestampIsSet)
        return a;
      var i = new Date(0);
      return i.setFullYear(a.getUTCFullYear(), a.getUTCMonth(), a.getUTCDate()), i.setHours(a.getUTCHours(), a.getUTCMinutes(), a.getUTCSeconds(), a.getUTCMilliseconds()), i;
    }
  }]), n;
}(Cu);
function Hs(e, t) {
  if (!(e instanceof t))
    throw new TypeError("Cannot call a class as a function");
}
function Lo(e, t) {
  for (var n = 0; n < t.length; n++) {
    var r = t[n];
    r.enumerable = r.enumerable || !1, r.configurable = !0, "value" in r && (r.writable = !0), Object.defineProperty(e, r.key, r);
  }
}
function js(e, t, n) {
  return t && Lo(e.prototype, t), n && Lo(e, n), e;
}
var ge = /* @__PURE__ */ function() {
  function e() {
    Hs(this, e);
  }
  return js(e, [{
    key: "run",
    value: function(n, r, a, o) {
      var i = this.parse(n, r, a, o);
      return i ? {
        setter: new Ws(i.value, this.validate, this.set, this.priority, this.subPriority),
        rest: i.rest
      } : null;
    }
  }, {
    key: "validate",
    value: function(n, r, a) {
      return !0;
    }
  }]), e;
}();
function fn(e) {
  return typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? fn = function(n) {
    return typeof n;
  } : fn = function(n) {
    return n && typeof Symbol == "function" && n.constructor === Symbol && n !== Symbol.prototype ? "symbol" : typeof n;
  }, fn(e);
}
function qs(e, t) {
  if (!(e instanceof t))
    throw new TypeError("Cannot call a class as a function");
}
function Wo(e, t) {
  for (var n = 0; n < t.length; n++) {
    var r = t[n];
    r.enumerable = r.enumerable || !1, r.configurable = !0, "value" in r && (r.writable = !0), Object.defineProperty(e, r.key, r);
  }
}
function Gs(e, t, n) {
  return t && Wo(e.prototype, t), n && Wo(e, n), e;
}
function Qs(e, t) {
  if (typeof t != "function" && t !== null)
    throw new TypeError("Super expression must either be null or a function");
  e.prototype = Object.create(t && t.prototype, { constructor: { value: e, writable: !0, configurable: !0 } }), t && sa(e, t);
}
function sa(e, t) {
  return sa = Object.setPrototypeOf || function(r, a) {
    return r.__proto__ = a, r;
  }, sa(e, t);
}
function Xs(e) {
  var t = Js();
  return function() {
    var r = Jn(e), a;
    if (t) {
      var o = Jn(this).constructor;
      a = Reflect.construct(r, arguments, o);
    } else
      a = r.apply(this, arguments);
    return Ks(this, a);
  };
}
function Ks(e, t) {
  return t && (fn(t) === "object" || typeof t == "function") ? t : ca(e);
}
function ca(e) {
  if (e === void 0)
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  return e;
}
function Js() {
  if (typeof Reflect > "u" || !Reflect.construct || Reflect.construct.sham)
    return !1;
  if (typeof Proxy == "function")
    return !0;
  try {
    return Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
    })), !0;
  } catch {
    return !1;
  }
}
function Jn(e) {
  return Jn = Object.setPrototypeOf ? Object.getPrototypeOf : function(n) {
    return n.__proto__ || Object.getPrototypeOf(n);
  }, Jn(e);
}
function zo(e, t, n) {
  return t in e ? Object.defineProperty(e, t, { value: n, enumerable: !0, configurable: !0, writable: !0 }) : e[t] = n, e;
}
var Zs = /* @__PURE__ */ function(e) {
  Qs(n, e);
  var t = Xs(n);
  function n() {
    var r;
    qs(this, n);
    for (var a = arguments.length, o = new Array(a), i = 0; i < a; i++)
      o[i] = arguments[i];
    return r = t.call.apply(t, [this].concat(o)), zo(ca(r), "priority", 140), zo(ca(r), "incompatibleTokens", ["R", "u", "t", "T"]), r;
  }
  return Gs(n, [{
    key: "parse",
    value: function(a, o, i) {
      switch (o) {
        case "G":
        case "GG":
        case "GGG":
          return i.era(a, {
            width: "abbreviated"
          }) || i.era(a, {
            width: "narrow"
          });
        case "GGGGG":
          return i.era(a, {
            width: "narrow"
          });
        case "GGGG":
        default:
          return i.era(a, {
            width: "wide"
          }) || i.era(a, {
            width: "abbreviated"
          }) || i.era(a, {
            width: "narrow"
          });
      }
    }
  }, {
    key: "set",
    value: function(a, o, i) {
      return o.era = i, a.setUTCFullYear(i, 0, 1), a.setUTCHours(0, 0, 0, 0), a;
    }
  }]), n;
}(ge), Ce = {
  month: /^(1[0-2]|0?\d)/,
  // 0 to 12
  date: /^(3[0-1]|[0-2]?\d)/,
  // 0 to 31
  dayOfYear: /^(36[0-6]|3[0-5]\d|[0-2]?\d?\d)/,
  // 0 to 366
  week: /^(5[0-3]|[0-4]?\d)/,
  // 0 to 53
  hour23h: /^(2[0-3]|[0-1]?\d)/,
  // 0 to 23
  hour24h: /^(2[0-4]|[0-1]?\d)/,
  // 0 to 24
  hour11h: /^(1[0-1]|0?\d)/,
  // 0 to 11
  hour12h: /^(1[0-2]|0?\d)/,
  // 0 to 12
  minute: /^[0-5]?\d/,
  // 0 to 59
  second: /^[0-5]?\d/,
  // 0 to 59
  singleDigit: /^\d/,
  // 0 to 9
  twoDigits: /^\d{1,2}/,
  // 0 to 99
  threeDigits: /^\d{1,3}/,
  // 0 to 999
  fourDigits: /^\d{1,4}/,
  // 0 to 9999
  anyDigitsSigned: /^-?\d+/,
  singleDigitSigned: /^-?\d/,
  // 0 to 9, -0 to -9
  twoDigitsSigned: /^-?\d{1,2}/,
  // 0 to 99, -0 to -99
  threeDigitsSigned: /^-?\d{1,3}/,
  // 0 to 999, -0 to -999
  fourDigitsSigned: /^-?\d{1,4}/
  // 0 to 9999, -0 to -9999
}, rt = {
  basicOptionalMinutes: /^([+-])(\d{2})(\d{2})?|Z/,
  basic: /^([+-])(\d{2})(\d{2})|Z/,
  basicOptionalSeconds: /^([+-])(\d{2})(\d{2})((\d{2}))?|Z/,
  extended: /^([+-])(\d{2}):(\d{2})|Z/,
  extendedOptionalSeconds: /^([+-])(\d{2}):(\d{2})(:(\d{2}))?|Z/
};
function Be(e, t) {
  return e && {
    value: t(e.value),
    rest: e.rest
  };
}
function xe(e, t) {
  var n = t.match(e);
  return n ? {
    value: parseInt(n[0], 10),
    rest: t.slice(n[0].length)
  } : null;
}
function at(e, t) {
  var n = t.match(e);
  if (!n)
    return null;
  if (n[0] === "Z")
    return {
      value: 0,
      rest: t.slice(1)
    };
  var r = n[1] === "+" ? 1 : -1, a = n[2] ? parseInt(n[2], 10) : 0, o = n[3] ? parseInt(n[3], 10) : 0, i = n[5] ? parseInt(n[5], 10) : 0;
  return {
    value: r * (a * $o + o * Oo + i * Rl),
    rest: t.slice(n[0].length)
  };
}
function Bu(e) {
  return xe(Ce.anyDigitsSigned, e);
}
function Ne(e, t) {
  switch (e) {
    case 1:
      return xe(Ce.singleDigit, t);
    case 2:
      return xe(Ce.twoDigits, t);
    case 3:
      return xe(Ce.threeDigits, t);
    case 4:
      return xe(Ce.fourDigits, t);
    default:
      return xe(new RegExp("^\\d{1," + e + "}"), t);
  }
}
function Zn(e, t) {
  switch (e) {
    case 1:
      return xe(Ce.singleDigitSigned, t);
    case 2:
      return xe(Ce.twoDigitsSigned, t);
    case 3:
      return xe(Ce.threeDigitsSigned, t);
    case 4:
      return xe(Ce.fourDigitsSigned, t);
    default:
      return xe(new RegExp("^-?\\d{1," + e + "}"), t);
  }
}
function xo(e) {
  switch (e) {
    case "morning":
      return 4;
    case "evening":
      return 17;
    case "pm":
    case "noon":
    case "afternoon":
      return 12;
    case "am":
    case "midnight":
    case "night":
    default:
      return 0;
  }
}
function Au(e, t) {
  var n = t > 0, r = n ? t : 1 - t, a;
  if (r <= 50)
    a = e || 100;
  else {
    var o = r + 50, i = Math.floor(o / 100) * 100, c = e >= o % 100;
    a = e + i - (c ? 100 : 0);
  }
  return n ? a : 1 - a;
}
function Iu(e) {
  return e % 400 === 0 || e % 4 === 0 && e % 100 !== 0;
}
function dn(e) {
  return typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? dn = function(n) {
    return typeof n;
  } : dn = function(n) {
    return n && typeof Symbol == "function" && n.constructor === Symbol && n !== Symbol.prototype ? "symbol" : typeof n;
  }, dn(e);
}
function ec(e, t) {
  if (!(e instanceof t))
    throw new TypeError("Cannot call a class as a function");
}
function Ho(e, t) {
  for (var n = 0; n < t.length; n++) {
    var r = t[n];
    r.enumerable = r.enumerable || !1, r.configurable = !0, "value" in r && (r.writable = !0), Object.defineProperty(e, r.key, r);
  }
}
function tc(e, t, n) {
  return t && Ho(e.prototype, t), n && Ho(e, n), e;
}
function nc(e, t) {
  if (typeof t != "function" && t !== null)
    throw new TypeError("Super expression must either be null or a function");
  e.prototype = Object.create(t && t.prototype, { constructor: { value: e, writable: !0, configurable: !0 } }), t && fa(e, t);
}
function fa(e, t) {
  return fa = Object.setPrototypeOf || function(r, a) {
    return r.__proto__ = a, r;
  }, fa(e, t);
}
function rc(e) {
  var t = oc();
  return function() {
    var r = er(e), a;
    if (t) {
      var o = er(this).constructor;
      a = Reflect.construct(r, arguments, o);
    } else
      a = r.apply(this, arguments);
    return ac(this, a);
  };
}
function ac(e, t) {
  return t && (dn(t) === "object" || typeof t == "function") ? t : da(e);
}
function da(e) {
  if (e === void 0)
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  return e;
}
function oc() {
  if (typeof Reflect > "u" || !Reflect.construct || Reflect.construct.sham)
    return !1;
  if (typeof Proxy == "function")
    return !0;
  try {
    return Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
    })), !0;
  } catch {
    return !1;
  }
}
function er(e) {
  return er = Object.setPrototypeOf ? Object.getPrototypeOf : function(n) {
    return n.__proto__ || Object.getPrototypeOf(n);
  }, er(e);
}
function jo(e, t, n) {
  return t in e ? Object.defineProperty(e, t, { value: n, enumerable: !0, configurable: !0, writable: !0 }) : e[t] = n, e;
}
var ic = /* @__PURE__ */ function(e) {
  nc(n, e);
  var t = rc(n);
  function n() {
    var r;
    ec(this, n);
    for (var a = arguments.length, o = new Array(a), i = 0; i < a; i++)
      o[i] = arguments[i];
    return r = t.call.apply(t, [this].concat(o)), jo(da(r), "priority", 130), jo(da(r), "incompatibleTokens", ["Y", "R", "u", "w", "I", "i", "e", "c", "t", "T"]), r;
  }
  return tc(n, [{
    key: "parse",
    value: function(a, o, i) {
      var c = function(d) {
        return {
          year: d,
          isTwoDigitYear: o === "yy"
        };
      };
      switch (o) {
        case "y":
          return Be(Ne(4, a), c);
        case "yo":
          return Be(i.ordinalNumber(a, {
            unit: "year"
          }), c);
        default:
          return Be(Ne(o.length, a), c);
      }
    }
  }, {
    key: "validate",
    value: function(a, o) {
      return o.isTwoDigitYear || o.year > 0;
    }
  }, {
    key: "set",
    value: function(a, o, i) {
      var c = a.getUTCFullYear();
      if (i.isTwoDigitYear) {
        var s = Au(i.year, c);
        return a.setUTCFullYear(s, 0, 1), a.setUTCHours(0, 0, 0, 0), a;
      }
      var d = !("era" in o) || o.era === 1 ? i.year : 1 - i.year;
      return a.setUTCFullYear(d, 0, 1), a.setUTCHours(0, 0, 0, 0), a;
    }
  }]), n;
}(ge);
function yn(e) {
  return typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? yn = function(n) {
    return typeof n;
  } : yn = function(n) {
    return n && typeof Symbol == "function" && n.constructor === Symbol && n !== Symbol.prototype ? "symbol" : typeof n;
  }, yn(e);
}
function uc(e, t) {
  if (!(e instanceof t))
    throw new TypeError("Cannot call a class as a function");
}
function qo(e, t) {
  for (var n = 0; n < t.length; n++) {
    var r = t[n];
    r.enumerable = r.enumerable || !1, r.configurable = !0, "value" in r && (r.writable = !0), Object.defineProperty(e, r.key, r);
  }
}
function lc(e, t, n) {
  return t && qo(e.prototype, t), n && qo(e, n), e;
}
function sc(e, t) {
  if (typeof t != "function" && t !== null)
    throw new TypeError("Super expression must either be null or a function");
  e.prototype = Object.create(t && t.prototype, { constructor: { value: e, writable: !0, configurable: !0 } }), t && ya(e, t);
}
function ya(e, t) {
  return ya = Object.setPrototypeOf || function(r, a) {
    return r.__proto__ = a, r;
  }, ya(e, t);
}
function cc(e) {
  var t = dc();
  return function() {
    var r = tr(e), a;
    if (t) {
      var o = tr(this).constructor;
      a = Reflect.construct(r, arguments, o);
    } else
      a = r.apply(this, arguments);
    return fc(this, a);
  };
}
function fc(e, t) {
  return t && (yn(t) === "object" || typeof t == "function") ? t : pa(e);
}
function pa(e) {
  if (e === void 0)
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  return e;
}
function dc() {
  if (typeof Reflect > "u" || !Reflect.construct || Reflect.construct.sham)
    return !1;
  if (typeof Proxy == "function")
    return !0;
  try {
    return Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
    })), !0;
  } catch {
    return !1;
  }
}
function tr(e) {
  return tr = Object.setPrototypeOf ? Object.getPrototypeOf : function(n) {
    return n.__proto__ || Object.getPrototypeOf(n);
  }, tr(e);
}
function Go(e, t, n) {
  return t in e ? Object.defineProperty(e, t, { value: n, enumerable: !0, configurable: !0, writable: !0 }) : e[t] = n, e;
}
var yc = /* @__PURE__ */ function(e) {
  sc(n, e);
  var t = cc(n);
  function n() {
    var r;
    uc(this, n);
    for (var a = arguments.length, o = new Array(a), i = 0; i < a; i++)
      o[i] = arguments[i];
    return r = t.call.apply(t, [this].concat(o)), Go(pa(r), "priority", 130), Go(pa(r), "incompatibleTokens", ["y", "R", "u", "Q", "q", "M", "L", "I", "d", "D", "i", "t", "T"]), r;
  }
  return lc(n, [{
    key: "parse",
    value: function(a, o, i) {
      var c = function(d) {
        return {
          year: d,
          isTwoDigitYear: o === "YY"
        };
      };
      switch (o) {
        case "Y":
          return Be(Ne(4, a), c);
        case "Yo":
          return Be(i.ordinalNumber(a, {
            unit: "year"
          }), c);
        default:
          return Be(Ne(o.length, a), c);
      }
    }
  }, {
    key: "validate",
    value: function(a, o) {
      return o.isTwoDigitYear || o.year > 0;
    }
  }, {
    key: "set",
    value: function(a, o, i, c) {
      var s = Po(a, c);
      if (i.isTwoDigitYear) {
        var d = Au(i.year, s);
        return a.setUTCFullYear(d, 0, c.firstWeekContainsDate), a.setUTCHours(0, 0, 0, 0), kt(a, c);
      }
      var b = !("era" in o) || o.era === 1 ? i.year : 1 - i.year;
      return a.setUTCFullYear(b, 0, c.firstWeekContainsDate), a.setUTCHours(0, 0, 0, 0), kt(a, c);
    }
  }]), n;
}(ge);
function pn(e) {
  return typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? pn = function(n) {
    return typeof n;
  } : pn = function(n) {
    return n && typeof Symbol == "function" && n.constructor === Symbol && n !== Symbol.prototype ? "symbol" : typeof n;
  }, pn(e);
}
function pc(e, t) {
  if (!(e instanceof t))
    throw new TypeError("Cannot call a class as a function");
}
function Qo(e, t) {
  for (var n = 0; n < t.length; n++) {
    var r = t[n];
    r.enumerable = r.enumerable || !1, r.configurable = !0, "value" in r && (r.writable = !0), Object.defineProperty(e, r.key, r);
  }
}
function mc(e, t, n) {
  return t && Qo(e.prototype, t), n && Qo(e, n), e;
}
function vc(e, t) {
  if (typeof t != "function" && t !== null)
    throw new TypeError("Super expression must either be null or a function");
  e.prototype = Object.create(t && t.prototype, { constructor: { value: e, writable: !0, configurable: !0 } }), t && ma(e, t);
}
function ma(e, t) {
  return ma = Object.setPrototypeOf || function(r, a) {
    return r.__proto__ = a, r;
  }, ma(e, t);
}
function hc(e) {
  var t = gc();
  return function() {
    var r = nr(e), a;
    if (t) {
      var o = nr(this).constructor;
      a = Reflect.construct(r, arguments, o);
    } else
      a = r.apply(this, arguments);
    return bc(this, a);
  };
}
function bc(e, t) {
  return t && (pn(t) === "object" || typeof t == "function") ? t : va(e);
}
function va(e) {
  if (e === void 0)
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  return e;
}
function gc() {
  if (typeof Reflect > "u" || !Reflect.construct || Reflect.construct.sham)
    return !1;
  if (typeof Proxy == "function")
    return !0;
  try {
    return Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
    })), !0;
  } catch {
    return !1;
  }
}
function nr(e) {
  return nr = Object.setPrototypeOf ? Object.getPrototypeOf : function(n) {
    return n.__proto__ || Object.getPrototypeOf(n);
  }, nr(e);
}
function Xo(e, t, n) {
  return t in e ? Object.defineProperty(e, t, { value: n, enumerable: !0, configurable: !0, writable: !0 }) : e[t] = n, e;
}
var wc = /* @__PURE__ */ function(e) {
  vc(n, e);
  var t = hc(n);
  function n() {
    var r;
    pc(this, n);
    for (var a = arguments.length, o = new Array(a), i = 0; i < a; i++)
      o[i] = arguments[i];
    return r = t.call.apply(t, [this].concat(o)), Xo(va(r), "priority", 130), Xo(va(r), "incompatibleTokens", ["G", "y", "Y", "u", "Q", "q", "M", "L", "w", "d", "D", "e", "c", "t", "T"]), r;
  }
  return mc(n, [{
    key: "parse",
    value: function(a, o) {
      return Zn(o === "R" ? 4 : o.length, a);
    }
  }, {
    key: "set",
    value: function(a, o, i) {
      var c = new Date(0);
      return c.setUTCFullYear(i, 0, 4), c.setUTCHours(0, 0, 0, 0), Bt(c);
    }
  }]), n;
}(ge);
function mn(e) {
  return typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? mn = function(n) {
    return typeof n;
  } : mn = function(n) {
    return n && typeof Symbol == "function" && n.constructor === Symbol && n !== Symbol.prototype ? "symbol" : typeof n;
  }, mn(e);
}
function _c(e, t) {
  if (!(e instanceof t))
    throw new TypeError("Cannot call a class as a function");
}
function Ko(e, t) {
  for (var n = 0; n < t.length; n++) {
    var r = t[n];
    r.enumerable = r.enumerable || !1, r.configurable = !0, "value" in r && (r.writable = !0), Object.defineProperty(e, r.key, r);
  }
}
function Oc(e, t, n) {
  return t && Ko(e.prototype, t), n && Ko(e, n), e;
}
function $c(e, t) {
  if (typeof t != "function" && t !== null)
    throw new TypeError("Super expression must either be null or a function");
  e.prototype = Object.create(t && t.prototype, { constructor: { value: e, writable: !0, configurable: !0 } }), t && ha(e, t);
}
function ha(e, t) {
  return ha = Object.setPrototypeOf || function(r, a) {
    return r.__proto__ = a, r;
  }, ha(e, t);
}
function Pc(e) {
  var t = Tc();
  return function() {
    var r = rr(e), a;
    if (t) {
      var o = rr(this).constructor;
      a = Reflect.construct(r, arguments, o);
    } else
      a = r.apply(this, arguments);
    return kc(this, a);
  };
}
function kc(e, t) {
  return t && (mn(t) === "object" || typeof t == "function") ? t : ba(e);
}
function ba(e) {
  if (e === void 0)
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  return e;
}
function Tc() {
  if (typeof Reflect > "u" || !Reflect.construct || Reflect.construct.sham)
    return !1;
  if (typeof Proxy == "function")
    return !0;
  try {
    return Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
    })), !0;
  } catch {
    return !1;
  }
}
function rr(e) {
  return rr = Object.setPrototypeOf ? Object.getPrototypeOf : function(n) {
    return n.__proto__ || Object.getPrototypeOf(n);
  }, rr(e);
}
function Jo(e, t, n) {
  return t in e ? Object.defineProperty(e, t, { value: n, enumerable: !0, configurable: !0, writable: !0 }) : e[t] = n, e;
}
var Dc = /* @__PURE__ */ function(e) {
  $c(n, e);
  var t = Pc(n);
  function n() {
    var r;
    _c(this, n);
    for (var a = arguments.length, o = new Array(a), i = 0; i < a; i++)
      o[i] = arguments[i];
    return r = t.call.apply(t, [this].concat(o)), Jo(ba(r), "priority", 130), Jo(ba(r), "incompatibleTokens", ["G", "y", "Y", "R", "w", "I", "i", "e", "c", "t", "T"]), r;
  }
  return Oc(n, [{
    key: "parse",
    value: function(a, o) {
      return Zn(o === "u" ? 4 : o.length, a);
    }
  }, {
    key: "set",
    value: function(a, o, i) {
      return a.setUTCFullYear(i, 0, 1), a.setUTCHours(0, 0, 0, 0), a;
    }
  }]), n;
}(ge);
function vn(e) {
  return typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? vn = function(n) {
    return typeof n;
  } : vn = function(n) {
    return n && typeof Symbol == "function" && n.constructor === Symbol && n !== Symbol.prototype ? "symbol" : typeof n;
  }, vn(e);
}
function Sc(e, t) {
  if (!(e instanceof t))
    throw new TypeError("Cannot call a class as a function");
}
function Zo(e, t) {
  for (var n = 0; n < t.length; n++) {
    var r = t[n];
    r.enumerable = r.enumerable || !1, r.configurable = !0, "value" in r && (r.writable = !0), Object.defineProperty(e, r.key, r);
  }
}
function xc(e, t, n) {
  return t && Zo(e.prototype, t), n && Zo(e, n), e;
}
function Rc(e, t) {
  if (typeof t != "function" && t !== null)
    throw new TypeError("Super expression must either be null or a function");
  e.prototype = Object.create(t && t.prototype, { constructor: { value: e, writable: !0, configurable: !0 } }), t && ga(e, t);
}
function ga(e, t) {
  return ga = Object.setPrototypeOf || function(r, a) {
    return r.__proto__ = a, r;
  }, ga(e, t);
}
function Mc(e) {
  var t = Cc();
  return function() {
    var r = ar(e), a;
    if (t) {
      var o = ar(this).constructor;
      a = Reflect.construct(r, arguments, o);
    } else
      a = r.apply(this, arguments);
    return Nc(this, a);
  };
}
function Nc(e, t) {
  return t && (vn(t) === "object" || typeof t == "function") ? t : wa(e);
}
function wa(e) {
  if (e === void 0)
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  return e;
}
function Cc() {
  if (typeof Reflect > "u" || !Reflect.construct || Reflect.construct.sham)
    return !1;
  if (typeof Proxy == "function")
    return !0;
  try {
    return Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
    })), !0;
  } catch {
    return !1;
  }
}
function ar(e) {
  return ar = Object.setPrototypeOf ? Object.getPrototypeOf : function(n) {
    return n.__proto__ || Object.getPrototypeOf(n);
  }, ar(e);
}
function ei(e, t, n) {
  return t in e ? Object.defineProperty(e, t, { value: n, enumerable: !0, configurable: !0, writable: !0 }) : e[t] = n, e;
}
var Bc = /* @__PURE__ */ function(e) {
  Rc(n, e);
  var t = Mc(n);
  function n() {
    var r;
    Sc(this, n);
    for (var a = arguments.length, o = new Array(a), i = 0; i < a; i++)
      o[i] = arguments[i];
    return r = t.call.apply(t, [this].concat(o)), ei(wa(r), "priority", 120), ei(wa(r), "incompatibleTokens", ["Y", "R", "q", "M", "L", "w", "I", "d", "D", "i", "e", "c", "t", "T"]), r;
  }
  return xc(n, [{
    key: "parse",
    value: function(a, o, i) {
      switch (o) {
        case "Q":
        case "QQ":
          return Ne(o.length, a);
        case "Qo":
          return i.ordinalNumber(a, {
            unit: "quarter"
          });
        case "QQQ":
          return i.quarter(a, {
            width: "abbreviated",
            context: "formatting"
          }) || i.quarter(a, {
            width: "narrow",
            context: "formatting"
          });
        case "QQQQQ":
          return i.quarter(a, {
            width: "narrow",
            context: "formatting"
          });
        case "QQQQ":
        default:
          return i.quarter(a, {
            width: "wide",
            context: "formatting"
          }) || i.quarter(a, {
            width: "abbreviated",
            context: "formatting"
          }) || i.quarter(a, {
            width: "narrow",
            context: "formatting"
          });
      }
    }
  }, {
    key: "validate",
    value: function(a, o) {
      return o >= 1 && o <= 4;
    }
  }, {
    key: "set",
    value: function(a, o, i) {
      return a.setUTCMonth((i - 1) * 3, 1), a.setUTCHours(0, 0, 0, 0), a;
    }
  }]), n;
}(ge);
function hn(e) {
  return typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? hn = function(n) {
    return typeof n;
  } : hn = function(n) {
    return n && typeof Symbol == "function" && n.constructor === Symbol && n !== Symbol.prototype ? "symbol" : typeof n;
  }, hn(e);
}
function Ac(e, t) {
  if (!(e instanceof t))
    throw new TypeError("Cannot call a class as a function");
}
function ti(e, t) {
  for (var n = 0; n < t.length; n++) {
    var r = t[n];
    r.enumerable = r.enumerable || !1, r.configurable = !0, "value" in r && (r.writable = !0), Object.defineProperty(e, r.key, r);
  }
}
function Ic(e, t, n) {
  return t && ti(e.prototype, t), n && ti(e, n), e;
}
function Ec(e, t) {
  if (typeof t != "function" && t !== null)
    throw new TypeError("Super expression must either be null or a function");
  e.prototype = Object.create(t && t.prototype, { constructor: { value: e, writable: !0, configurable: !0 } }), t && _a(e, t);
}
function _a(e, t) {
  return _a = Object.setPrototypeOf || function(r, a) {
    return r.__proto__ = a, r;
  }, _a(e, t);
}
function Yc(e) {
  var t = Fc();
  return function() {
    var r = or(e), a;
    if (t) {
      var o = or(this).constructor;
      a = Reflect.construct(r, arguments, o);
    } else
      a = r.apply(this, arguments);
    return Vc(this, a);
  };
}
function Vc(e, t) {
  return t && (hn(t) === "object" || typeof t == "function") ? t : Oa(e);
}
function Oa(e) {
  if (e === void 0)
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  return e;
}
function Fc() {
  if (typeof Reflect > "u" || !Reflect.construct || Reflect.construct.sham)
    return !1;
  if (typeof Proxy == "function")
    return !0;
  try {
    return Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
    })), !0;
  } catch {
    return !1;
  }
}
function or(e) {
  return or = Object.setPrototypeOf ? Object.getPrototypeOf : function(n) {
    return n.__proto__ || Object.getPrototypeOf(n);
  }, or(e);
}
function ni(e, t, n) {
  return t in e ? Object.defineProperty(e, t, { value: n, enumerable: !0, configurable: !0, writable: !0 }) : e[t] = n, e;
}
var Uc = /* @__PURE__ */ function(e) {
  Ec(n, e);
  var t = Yc(n);
  function n() {
    var r;
    Ac(this, n);
    for (var a = arguments.length, o = new Array(a), i = 0; i < a; i++)
      o[i] = arguments[i];
    return r = t.call.apply(t, [this].concat(o)), ni(Oa(r), "priority", 120), ni(Oa(r), "incompatibleTokens", ["Y", "R", "Q", "M", "L", "w", "I", "d", "D", "i", "e", "c", "t", "T"]), r;
  }
  return Ic(n, [{
    key: "parse",
    value: function(a, o, i) {
      switch (o) {
        case "q":
        case "qq":
          return Ne(o.length, a);
        case "qo":
          return i.ordinalNumber(a, {
            unit: "quarter"
          });
        case "qqq":
          return i.quarter(a, {
            width: "abbreviated",
            context: "standalone"
          }) || i.quarter(a, {
            width: "narrow",
            context: "standalone"
          });
        case "qqqqq":
          return i.quarter(a, {
            width: "narrow",
            context: "standalone"
          });
        case "qqqq":
        default:
          return i.quarter(a, {
            width: "wide",
            context: "standalone"
          }) || i.quarter(a, {
            width: "abbreviated",
            context: "standalone"
          }) || i.quarter(a, {
            width: "narrow",
            context: "standalone"
          });
      }
    }
  }, {
    key: "validate",
    value: function(a, o) {
      return o >= 1 && o <= 4;
    }
  }, {
    key: "set",
    value: function(a, o, i) {
      return a.setUTCMonth((i - 1) * 3, 1), a.setUTCHours(0, 0, 0, 0), a;
    }
  }]), n;
}(ge);
function bn(e) {
  return typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? bn = function(n) {
    return typeof n;
  } : bn = function(n) {
    return n && typeof Symbol == "function" && n.constructor === Symbol && n !== Symbol.prototype ? "symbol" : typeof n;
  }, bn(e);
}
function Lc(e, t) {
  if (!(e instanceof t))
    throw new TypeError("Cannot call a class as a function");
}
function ri(e, t) {
  for (var n = 0; n < t.length; n++) {
    var r = t[n];
    r.enumerable = r.enumerable || !1, r.configurable = !0, "value" in r && (r.writable = !0), Object.defineProperty(e, r.key, r);
  }
}
function Wc(e, t, n) {
  return t && ri(e.prototype, t), n && ri(e, n), e;
}
function zc(e, t) {
  if (typeof t != "function" && t !== null)
    throw new TypeError("Super expression must either be null or a function");
  e.prototype = Object.create(t && t.prototype, { constructor: { value: e, writable: !0, configurable: !0 } }), t && $a(e, t);
}
function $a(e, t) {
  return $a = Object.setPrototypeOf || function(r, a) {
    return r.__proto__ = a, r;
  }, $a(e, t);
}
function Hc(e) {
  var t = qc();
  return function() {
    var r = ir(e), a;
    if (t) {
      var o = ir(this).constructor;
      a = Reflect.construct(r, arguments, o);
    } else
      a = r.apply(this, arguments);
    return jc(this, a);
  };
}
function jc(e, t) {
  return t && (bn(t) === "object" || typeof t == "function") ? t : Pa(e);
}
function Pa(e) {
  if (e === void 0)
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  return e;
}
function qc() {
  if (typeof Reflect > "u" || !Reflect.construct || Reflect.construct.sham)
    return !1;
  if (typeof Proxy == "function")
    return !0;
  try {
    return Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
    })), !0;
  } catch {
    return !1;
  }
}
function ir(e) {
  return ir = Object.setPrototypeOf ? Object.getPrototypeOf : function(n) {
    return n.__proto__ || Object.getPrototypeOf(n);
  }, ir(e);
}
function ai(e, t, n) {
  return t in e ? Object.defineProperty(e, t, { value: n, enumerable: !0, configurable: !0, writable: !0 }) : e[t] = n, e;
}
var Gc = /* @__PURE__ */ function(e) {
  zc(n, e);
  var t = Hc(n);
  function n() {
    var r;
    Lc(this, n);
    for (var a = arguments.length, o = new Array(a), i = 0; i < a; i++)
      o[i] = arguments[i];
    return r = t.call.apply(t, [this].concat(o)), ai(Pa(r), "incompatibleTokens", ["Y", "R", "q", "Q", "L", "w", "I", "D", "i", "e", "c", "t", "T"]), ai(Pa(r), "priority", 110), r;
  }
  return Wc(n, [{
    key: "parse",
    value: function(a, o, i) {
      var c = function(d) {
        return d - 1;
      };
      switch (o) {
        case "M":
          return Be(xe(Ce.month, a), c);
        case "MM":
          return Be(Ne(2, a), c);
        case "Mo":
          return Be(i.ordinalNumber(a, {
            unit: "month"
          }), c);
        case "MMM":
          return i.month(a, {
            width: "abbreviated",
            context: "formatting"
          }) || i.month(a, {
            width: "narrow",
            context: "formatting"
          });
        case "MMMMM":
          return i.month(a, {
            width: "narrow",
            context: "formatting"
          });
        case "MMMM":
        default:
          return i.month(a, {
            width: "wide",
            context: "formatting"
          }) || i.month(a, {
            width: "abbreviated",
            context: "formatting"
          }) || i.month(a, {
            width: "narrow",
            context: "formatting"
          });
      }
    }
  }, {
    key: "validate",
    value: function(a, o) {
      return o >= 0 && o <= 11;
    }
  }, {
    key: "set",
    value: function(a, o, i) {
      return a.setUTCMonth(i, 1), a.setUTCHours(0, 0, 0, 0), a;
    }
  }]), n;
}(ge);
function gn(e) {
  return typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? gn = function(n) {
    return typeof n;
  } : gn = function(n) {
    return n && typeof Symbol == "function" && n.constructor === Symbol && n !== Symbol.prototype ? "symbol" : typeof n;
  }, gn(e);
}
function Qc(e, t) {
  if (!(e instanceof t))
    throw new TypeError("Cannot call a class as a function");
}
function oi(e, t) {
  for (var n = 0; n < t.length; n++) {
    var r = t[n];
    r.enumerable = r.enumerable || !1, r.configurable = !0, "value" in r && (r.writable = !0), Object.defineProperty(e, r.key, r);
  }
}
function Xc(e, t, n) {
  return t && oi(e.prototype, t), n && oi(e, n), e;
}
function Kc(e, t) {
  if (typeof t != "function" && t !== null)
    throw new TypeError("Super expression must either be null or a function");
  e.prototype = Object.create(t && t.prototype, { constructor: { value: e, writable: !0, configurable: !0 } }), t && ka(e, t);
}
function ka(e, t) {
  return ka = Object.setPrototypeOf || function(r, a) {
    return r.__proto__ = a, r;
  }, ka(e, t);
}
function Jc(e) {
  var t = ef();
  return function() {
    var r = ur(e), a;
    if (t) {
      var o = ur(this).constructor;
      a = Reflect.construct(r, arguments, o);
    } else
      a = r.apply(this, arguments);
    return Zc(this, a);
  };
}
function Zc(e, t) {
  return t && (gn(t) === "object" || typeof t == "function") ? t : Ta(e);
}
function Ta(e) {
  if (e === void 0)
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  return e;
}
function ef() {
  if (typeof Reflect > "u" || !Reflect.construct || Reflect.construct.sham)
    return !1;
  if (typeof Proxy == "function")
    return !0;
  try {
    return Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
    })), !0;
  } catch {
    return !1;
  }
}
function ur(e) {
  return ur = Object.setPrototypeOf ? Object.getPrototypeOf : function(n) {
    return n.__proto__ || Object.getPrototypeOf(n);
  }, ur(e);
}
function ii(e, t, n) {
  return t in e ? Object.defineProperty(e, t, { value: n, enumerable: !0, configurable: !0, writable: !0 }) : e[t] = n, e;
}
var tf = /* @__PURE__ */ function(e) {
  Kc(n, e);
  var t = Jc(n);
  function n() {
    var r;
    Qc(this, n);
    for (var a = arguments.length, o = new Array(a), i = 0; i < a; i++)
      o[i] = arguments[i];
    return r = t.call.apply(t, [this].concat(o)), ii(Ta(r), "priority", 110), ii(Ta(r), "incompatibleTokens", ["Y", "R", "q", "Q", "M", "w", "I", "D", "i", "e", "c", "t", "T"]), r;
  }
  return Xc(n, [{
    key: "parse",
    value: function(a, o, i) {
      var c = function(d) {
        return d - 1;
      };
      switch (o) {
        case "L":
          return Be(xe(Ce.month, a), c);
        case "LL":
          return Be(Ne(2, a), c);
        case "Lo":
          return Be(i.ordinalNumber(a, {
            unit: "month"
          }), c);
        case "LLL":
          return i.month(a, {
            width: "abbreviated",
            context: "standalone"
          }) || i.month(a, {
            width: "narrow",
            context: "standalone"
          });
        case "LLLLL":
          return i.month(a, {
            width: "narrow",
            context: "standalone"
          });
        case "LLLL":
        default:
          return i.month(a, {
            width: "wide",
            context: "standalone"
          }) || i.month(a, {
            width: "abbreviated",
            context: "standalone"
          }) || i.month(a, {
            width: "narrow",
            context: "standalone"
          });
      }
    }
  }, {
    key: "validate",
    value: function(a, o) {
      return o >= 0 && o <= 11;
    }
  }, {
    key: "set",
    value: function(a, o, i) {
      return a.setUTCMonth(i, 1), a.setUTCHours(0, 0, 0, 0), a;
    }
  }]), n;
}(ge);
function nf(e, t, n) {
  J(2, arguments);
  var r = ae(e), a = re(t), o = ku(r, n) - a;
  return r.setUTCDate(r.getUTCDate() - o * 7), r;
}
function wn(e) {
  return typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? wn = function(n) {
    return typeof n;
  } : wn = function(n) {
    return n && typeof Symbol == "function" && n.constructor === Symbol && n !== Symbol.prototype ? "symbol" : typeof n;
  }, wn(e);
}
function rf(e, t) {
  if (!(e instanceof t))
    throw new TypeError("Cannot call a class as a function");
}
function ui(e, t) {
  for (var n = 0; n < t.length; n++) {
    var r = t[n];
    r.enumerable = r.enumerable || !1, r.configurable = !0, "value" in r && (r.writable = !0), Object.defineProperty(e, r.key, r);
  }
}
function af(e, t, n) {
  return t && ui(e.prototype, t), n && ui(e, n), e;
}
function of(e, t) {
  if (typeof t != "function" && t !== null)
    throw new TypeError("Super expression must either be null or a function");
  e.prototype = Object.create(t && t.prototype, { constructor: { value: e, writable: !0, configurable: !0 } }), t && Da(e, t);
}
function Da(e, t) {
  return Da = Object.setPrototypeOf || function(r, a) {
    return r.__proto__ = a, r;
  }, Da(e, t);
}
function uf(e) {
  var t = sf();
  return function() {
    var r = lr(e), a;
    if (t) {
      var o = lr(this).constructor;
      a = Reflect.construct(r, arguments, o);
    } else
      a = r.apply(this, arguments);
    return lf(this, a);
  };
}
function lf(e, t) {
  return t && (wn(t) === "object" || typeof t == "function") ? t : Sa(e);
}
function Sa(e) {
  if (e === void 0)
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  return e;
}
function sf() {
  if (typeof Reflect > "u" || !Reflect.construct || Reflect.construct.sham)
    return !1;
  if (typeof Proxy == "function")
    return !0;
  try {
    return Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
    })), !0;
  } catch {
    return !1;
  }
}
function lr(e) {
  return lr = Object.setPrototypeOf ? Object.getPrototypeOf : function(n) {
    return n.__proto__ || Object.getPrototypeOf(n);
  }, lr(e);
}
function li(e, t, n) {
  return t in e ? Object.defineProperty(e, t, { value: n, enumerable: !0, configurable: !0, writable: !0 }) : e[t] = n, e;
}
var cf = /* @__PURE__ */ function(e) {
  of(n, e);
  var t = uf(n);
  function n() {
    var r;
    rf(this, n);
    for (var a = arguments.length, o = new Array(a), i = 0; i < a; i++)
      o[i] = arguments[i];
    return r = t.call.apply(t, [this].concat(o)), li(Sa(r), "priority", 100), li(Sa(r), "incompatibleTokens", ["y", "R", "u", "q", "Q", "M", "L", "I", "d", "D", "i", "t", "T"]), r;
  }
  return af(n, [{
    key: "parse",
    value: function(a, o, i) {
      switch (o) {
        case "w":
          return xe(Ce.week, a);
        case "wo":
          return i.ordinalNumber(a, {
            unit: "week"
          });
        default:
          return Ne(o.length, a);
      }
    }
  }, {
    key: "validate",
    value: function(a, o) {
      return o >= 1 && o <= 53;
    }
  }, {
    key: "set",
    value: function(a, o, i, c) {
      return kt(nf(a, i, c), c);
    }
  }]), n;
}(ge);
function ff(e, t) {
  J(2, arguments);
  var n = ae(e), r = re(t), a = Pu(n) - r;
  return n.setUTCDate(n.getUTCDate() - a * 7), n;
}
function _n(e) {
  return typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? _n = function(n) {
    return typeof n;
  } : _n = function(n) {
    return n && typeof Symbol == "function" && n.constructor === Symbol && n !== Symbol.prototype ? "symbol" : typeof n;
  }, _n(e);
}
function df(e, t) {
  if (!(e instanceof t))
    throw new TypeError("Cannot call a class as a function");
}
function si(e, t) {
  for (var n = 0; n < t.length; n++) {
    var r = t[n];
    r.enumerable = r.enumerable || !1, r.configurable = !0, "value" in r && (r.writable = !0), Object.defineProperty(e, r.key, r);
  }
}
function yf(e, t, n) {
  return t && si(e.prototype, t), n && si(e, n), e;
}
function pf(e, t) {
  if (typeof t != "function" && t !== null)
    throw new TypeError("Super expression must either be null or a function");
  e.prototype = Object.create(t && t.prototype, { constructor: { value: e, writable: !0, configurable: !0 } }), t && xa(e, t);
}
function xa(e, t) {
  return xa = Object.setPrototypeOf || function(r, a) {
    return r.__proto__ = a, r;
  }, xa(e, t);
}
function mf(e) {
  var t = hf();
  return function() {
    var r = sr(e), a;
    if (t) {
      var o = sr(this).constructor;
      a = Reflect.construct(r, arguments, o);
    } else
      a = r.apply(this, arguments);
    return vf(this, a);
  };
}
function vf(e, t) {
  return t && (_n(t) === "object" || typeof t == "function") ? t : Ra(e);
}
function Ra(e) {
  if (e === void 0)
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  return e;
}
function hf() {
  if (typeof Reflect > "u" || !Reflect.construct || Reflect.construct.sham)
    return !1;
  if (typeof Proxy == "function")
    return !0;
  try {
    return Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
    })), !0;
  } catch {
    return !1;
  }
}
function sr(e) {
  return sr = Object.setPrototypeOf ? Object.getPrototypeOf : function(n) {
    return n.__proto__ || Object.getPrototypeOf(n);
  }, sr(e);
}
function ci(e, t, n) {
  return t in e ? Object.defineProperty(e, t, { value: n, enumerable: !0, configurable: !0, writable: !0 }) : e[t] = n, e;
}
var bf = /* @__PURE__ */ function(e) {
  pf(n, e);
  var t = mf(n);
  function n() {
    var r;
    df(this, n);
    for (var a = arguments.length, o = new Array(a), i = 0; i < a; i++)
      o[i] = arguments[i];
    return r = t.call.apply(t, [this].concat(o)), ci(Ra(r), "priority", 100), ci(Ra(r), "incompatibleTokens", ["y", "Y", "u", "q", "Q", "M", "L", "w", "d", "D", "e", "c", "t", "T"]), r;
  }
  return yf(n, [{
    key: "parse",
    value: function(a, o, i) {
      switch (o) {
        case "I":
          return xe(Ce.week, a);
        case "Io":
          return i.ordinalNumber(a, {
            unit: "week"
          });
        default:
          return Ne(o.length, a);
      }
    }
  }, {
    key: "validate",
    value: function(a, o) {
      return o >= 1 && o <= 53;
    }
  }, {
    key: "set",
    value: function(a, o, i) {
      return Bt(ff(a, i));
    }
  }]), n;
}(ge);
function On(e) {
  return typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? On = function(n) {
    return typeof n;
  } : On = function(n) {
    return n && typeof Symbol == "function" && n.constructor === Symbol && n !== Symbol.prototype ? "symbol" : typeof n;
  }, On(e);
}
function gf(e, t) {
  if (!(e instanceof t))
    throw new TypeError("Cannot call a class as a function");
}
function fi(e, t) {
  for (var n = 0; n < t.length; n++) {
    var r = t[n];
    r.enumerable = r.enumerable || !1, r.configurable = !0, "value" in r && (r.writable = !0), Object.defineProperty(e, r.key, r);
  }
}
function wf(e, t, n) {
  return t && fi(e.prototype, t), n && fi(e, n), e;
}
function _f(e, t) {
  if (typeof t != "function" && t !== null)
    throw new TypeError("Super expression must either be null or a function");
  e.prototype = Object.create(t && t.prototype, { constructor: { value: e, writable: !0, configurable: !0 } }), t && Ma(e, t);
}
function Ma(e, t) {
  return Ma = Object.setPrototypeOf || function(r, a) {
    return r.__proto__ = a, r;
  }, Ma(e, t);
}
function Of(e) {
  var t = Pf();
  return function() {
    var r = cr(e), a;
    if (t) {
      var o = cr(this).constructor;
      a = Reflect.construct(r, arguments, o);
    } else
      a = r.apply(this, arguments);
    return $f(this, a);
  };
}
function $f(e, t) {
  return t && (On(t) === "object" || typeof t == "function") ? t : $n(e);
}
function $n(e) {
  if (e === void 0)
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  return e;
}
function Pf() {
  if (typeof Reflect > "u" || !Reflect.construct || Reflect.construct.sham)
    return !1;
  if (typeof Proxy == "function")
    return !0;
  try {
    return Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
    })), !0;
  } catch {
    return !1;
  }
}
function cr(e) {
  return cr = Object.setPrototypeOf ? Object.getPrototypeOf : function(n) {
    return n.__proto__ || Object.getPrototypeOf(n);
  }, cr(e);
}
function zr(e, t, n) {
  return t in e ? Object.defineProperty(e, t, { value: n, enumerable: !0, configurable: !0, writable: !0 }) : e[t] = n, e;
}
var kf = [31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31], Tf = [31, 29, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31], Df = /* @__PURE__ */ function(e) {
  _f(n, e);
  var t = Of(n);
  function n() {
    var r;
    gf(this, n);
    for (var a = arguments.length, o = new Array(a), i = 0; i < a; i++)
      o[i] = arguments[i];
    return r = t.call.apply(t, [this].concat(o)), zr($n(r), "priority", 90), zr($n(r), "subPriority", 1), zr($n(r), "incompatibleTokens", ["Y", "R", "q", "Q", "w", "I", "D", "i", "e", "c", "t", "T"]), r;
  }
  return wf(n, [{
    key: "parse",
    value: function(a, o, i) {
      switch (o) {
        case "d":
          return xe(Ce.date, a);
        case "do":
          return i.ordinalNumber(a, {
            unit: "date"
          });
        default:
          return Ne(o.length, a);
      }
    }
  }, {
    key: "validate",
    value: function(a, o) {
      var i = a.getUTCFullYear(), c = Iu(i), s = a.getUTCMonth();
      return c ? o >= 1 && o <= Tf[s] : o >= 1 && o <= kf[s];
    }
  }, {
    key: "set",
    value: function(a, o, i) {
      return a.setUTCDate(i), a.setUTCHours(0, 0, 0, 0), a;
    }
  }]), n;
}(ge);
function Pn(e) {
  return typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? Pn = function(n) {
    return typeof n;
  } : Pn = function(n) {
    return n && typeof Symbol == "function" && n.constructor === Symbol && n !== Symbol.prototype ? "symbol" : typeof n;
  }, Pn(e);
}
function Sf(e, t) {
  if (!(e instanceof t))
    throw new TypeError("Cannot call a class as a function");
}
function di(e, t) {
  for (var n = 0; n < t.length; n++) {
    var r = t[n];
    r.enumerable = r.enumerable || !1, r.configurable = !0, "value" in r && (r.writable = !0), Object.defineProperty(e, r.key, r);
  }
}
function xf(e, t, n) {
  return t && di(e.prototype, t), n && di(e, n), e;
}
function Rf(e, t) {
  if (typeof t != "function" && t !== null)
    throw new TypeError("Super expression must either be null or a function");
  e.prototype = Object.create(t && t.prototype, { constructor: { value: e, writable: !0, configurable: !0 } }), t && Na(e, t);
}
function Na(e, t) {
  return Na = Object.setPrototypeOf || function(r, a) {
    return r.__proto__ = a, r;
  }, Na(e, t);
}
function Mf(e) {
  var t = Cf();
  return function() {
    var r = fr(e), a;
    if (t) {
      var o = fr(this).constructor;
      a = Reflect.construct(r, arguments, o);
    } else
      a = r.apply(this, arguments);
    return Nf(this, a);
  };
}
function Nf(e, t) {
  return t && (Pn(t) === "object" || typeof t == "function") ? t : kn(e);
}
function kn(e) {
  if (e === void 0)
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  return e;
}
function Cf() {
  if (typeof Reflect > "u" || !Reflect.construct || Reflect.construct.sham)
    return !1;
  if (typeof Proxy == "function")
    return !0;
  try {
    return Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
    })), !0;
  } catch {
    return !1;
  }
}
function fr(e) {
  return fr = Object.setPrototypeOf ? Object.getPrototypeOf : function(n) {
    return n.__proto__ || Object.getPrototypeOf(n);
  }, fr(e);
}
function Hr(e, t, n) {
  return t in e ? Object.defineProperty(e, t, { value: n, enumerable: !0, configurable: !0, writable: !0 }) : e[t] = n, e;
}
var Bf = /* @__PURE__ */ function(e) {
  Rf(n, e);
  var t = Mf(n);
  function n() {
    var r;
    Sf(this, n);
    for (var a = arguments.length, o = new Array(a), i = 0; i < a; i++)
      o[i] = arguments[i];
    return r = t.call.apply(t, [this].concat(o)), Hr(kn(r), "priority", 90), Hr(kn(r), "subpriority", 1), Hr(kn(r), "incompatibleTokens", ["Y", "R", "q", "Q", "M", "L", "w", "I", "d", "E", "i", "e", "c", "t", "T"]), r;
  }
  return xf(n, [{
    key: "parse",
    value: function(a, o, i) {
      switch (o) {
        case "D":
        case "DD":
          return xe(Ce.dayOfYear, a);
        case "Do":
          return i.ordinalNumber(a, {
            unit: "date"
          });
        default:
          return Ne(o.length, a);
      }
    }
  }, {
    key: "validate",
    value: function(a, o) {
      var i = a.getUTCFullYear(), c = Iu(i);
      return c ? o >= 1 && o <= 366 : o >= 1 && o <= 365;
    }
  }, {
    key: "set",
    value: function(a, o, i) {
      return a.setUTCMonth(0, i), a.setUTCHours(0, 0, 0, 0), a;
    }
  }]), n;
}(ge);
function Ro(e, t, n) {
  var r, a, o, i, c, s, d, b;
  J(2, arguments);
  var y = vt(), f = re((r = (a = (o = (i = n == null ? void 0 : n.weekStartsOn) !== null && i !== void 0 ? i : n == null || (c = n.locale) === null || c === void 0 || (s = c.options) === null || s === void 0 ? void 0 : s.weekStartsOn) !== null && o !== void 0 ? o : y.weekStartsOn) !== null && a !== void 0 ? a : (d = y.locale) === null || d === void 0 || (b = d.options) === null || b === void 0 ? void 0 : b.weekStartsOn) !== null && r !== void 0 ? r : 0);
  if (!(f >= 0 && f <= 6))
    throw new RangeError("weekStartsOn must be between 0 and 6 inclusively");
  var v = ae(e), A = re(t), V = v.getUTCDay(), q = A % 7, ee = (q + 7) % 7, G = (ee < f ? 7 : 0) + A - V;
  return v.setUTCDate(v.getUTCDate() + G), v;
}
function Tn(e) {
  return typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? Tn = function(n) {
    return typeof n;
  } : Tn = function(n) {
    return n && typeof Symbol == "function" && n.constructor === Symbol && n !== Symbol.prototype ? "symbol" : typeof n;
  }, Tn(e);
}
function Af(e, t) {
  if (!(e instanceof t))
    throw new TypeError("Cannot call a class as a function");
}
function yi(e, t) {
  for (var n = 0; n < t.length; n++) {
    var r = t[n];
    r.enumerable = r.enumerable || !1, r.configurable = !0, "value" in r && (r.writable = !0), Object.defineProperty(e, r.key, r);
  }
}
function If(e, t, n) {
  return t && yi(e.prototype, t), n && yi(e, n), e;
}
function Ef(e, t) {
  if (typeof t != "function" && t !== null)
    throw new TypeError("Super expression must either be null or a function");
  e.prototype = Object.create(t && t.prototype, { constructor: { value: e, writable: !0, configurable: !0 } }), t && Ca(e, t);
}
function Ca(e, t) {
  return Ca = Object.setPrototypeOf || function(r, a) {
    return r.__proto__ = a, r;
  }, Ca(e, t);
}
function Yf(e) {
  var t = Ff();
  return function() {
    var r = dr(e), a;
    if (t) {
      var o = dr(this).constructor;
      a = Reflect.construct(r, arguments, o);
    } else
      a = r.apply(this, arguments);
    return Vf(this, a);
  };
}
function Vf(e, t) {
  return t && (Tn(t) === "object" || typeof t == "function") ? t : Ba(e);
}
function Ba(e) {
  if (e === void 0)
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  return e;
}
function Ff() {
  if (typeof Reflect > "u" || !Reflect.construct || Reflect.construct.sham)
    return !1;
  if (typeof Proxy == "function")
    return !0;
  try {
    return Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
    })), !0;
  } catch {
    return !1;
  }
}
function dr(e) {
  return dr = Object.setPrototypeOf ? Object.getPrototypeOf : function(n) {
    return n.__proto__ || Object.getPrototypeOf(n);
  }, dr(e);
}
function pi(e, t, n) {
  return t in e ? Object.defineProperty(e, t, { value: n, enumerable: !0, configurable: !0, writable: !0 }) : e[t] = n, e;
}
var Uf = /* @__PURE__ */ function(e) {
  Ef(n, e);
  var t = Yf(n);
  function n() {
    var r;
    Af(this, n);
    for (var a = arguments.length, o = new Array(a), i = 0; i < a; i++)
      o[i] = arguments[i];
    return r = t.call.apply(t, [this].concat(o)), pi(Ba(r), "priority", 90), pi(Ba(r), "incompatibleTokens", ["D", "i", "e", "c", "t", "T"]), r;
  }
  return If(n, [{
    key: "parse",
    value: function(a, o, i) {
      switch (o) {
        case "E":
        case "EE":
        case "EEE":
          return i.day(a, {
            width: "abbreviated",
            context: "formatting"
          }) || i.day(a, {
            width: "short",
            context: "formatting"
          }) || i.day(a, {
            width: "narrow",
            context: "formatting"
          });
        case "EEEEE":
          return i.day(a, {
            width: "narrow",
            context: "formatting"
          });
        case "EEEEEE":
          return i.day(a, {
            width: "short",
            context: "formatting"
          }) || i.day(a, {
            width: "narrow",
            context: "formatting"
          });
        case "EEEE":
        default:
          return i.day(a, {
            width: "wide",
            context: "formatting"
          }) || i.day(a, {
            width: "abbreviated",
            context: "formatting"
          }) || i.day(a, {
            width: "short",
            context: "formatting"
          }) || i.day(a, {
            width: "narrow",
            context: "formatting"
          });
      }
    }
  }, {
    key: "validate",
    value: function(a, o) {
      return o >= 0 && o <= 6;
    }
  }, {
    key: "set",
    value: function(a, o, i, c) {
      return a = Ro(a, i, c), a.setUTCHours(0, 0, 0, 0), a;
    }
  }]), n;
}(ge);
function Dn(e) {
  return typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? Dn = function(n) {
    return typeof n;
  } : Dn = function(n) {
    return n && typeof Symbol == "function" && n.constructor === Symbol && n !== Symbol.prototype ? "symbol" : typeof n;
  }, Dn(e);
}
function Lf(e, t) {
  if (!(e instanceof t))
    throw new TypeError("Cannot call a class as a function");
}
function mi(e, t) {
  for (var n = 0; n < t.length; n++) {
    var r = t[n];
    r.enumerable = r.enumerable || !1, r.configurable = !0, "value" in r && (r.writable = !0), Object.defineProperty(e, r.key, r);
  }
}
function Wf(e, t, n) {
  return t && mi(e.prototype, t), n && mi(e, n), e;
}
function zf(e, t) {
  if (typeof t != "function" && t !== null)
    throw new TypeError("Super expression must either be null or a function");
  e.prototype = Object.create(t && t.prototype, { constructor: { value: e, writable: !0, configurable: !0 } }), t && Aa(e, t);
}
function Aa(e, t) {
  return Aa = Object.setPrototypeOf || function(r, a) {
    return r.__proto__ = a, r;
  }, Aa(e, t);
}
function Hf(e) {
  var t = qf();
  return function() {
    var r = yr(e), a;
    if (t) {
      var o = yr(this).constructor;
      a = Reflect.construct(r, arguments, o);
    } else
      a = r.apply(this, arguments);
    return jf(this, a);
  };
}
function jf(e, t) {
  return t && (Dn(t) === "object" || typeof t == "function") ? t : Ia(e);
}
function Ia(e) {
  if (e === void 0)
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  return e;
}
function qf() {
  if (typeof Reflect > "u" || !Reflect.construct || Reflect.construct.sham)
    return !1;
  if (typeof Proxy == "function")
    return !0;
  try {
    return Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
    })), !0;
  } catch {
    return !1;
  }
}
function yr(e) {
  return yr = Object.setPrototypeOf ? Object.getPrototypeOf : function(n) {
    return n.__proto__ || Object.getPrototypeOf(n);
  }, yr(e);
}
function vi(e, t, n) {
  return t in e ? Object.defineProperty(e, t, { value: n, enumerable: !0, configurable: !0, writable: !0 }) : e[t] = n, e;
}
var Gf = /* @__PURE__ */ function(e) {
  zf(n, e);
  var t = Hf(n);
  function n() {
    var r;
    Lf(this, n);
    for (var a = arguments.length, o = new Array(a), i = 0; i < a; i++)
      o[i] = arguments[i];
    return r = t.call.apply(t, [this].concat(o)), vi(Ia(r), "priority", 90), vi(Ia(r), "incompatibleTokens", ["y", "R", "u", "q", "Q", "M", "L", "I", "d", "D", "E", "i", "c", "t", "T"]), r;
  }
  return Wf(n, [{
    key: "parse",
    value: function(a, o, i, c) {
      var s = function(b) {
        var y = Math.floor((b - 1) / 7) * 7;
        return (b + c.weekStartsOn + 6) % 7 + y;
      };
      switch (o) {
        case "e":
        case "ee":
          return Be(Ne(o.length, a), s);
        case "eo":
          return Be(i.ordinalNumber(a, {
            unit: "day"
          }), s);
        case "eee":
          return i.day(a, {
            width: "abbreviated",
            context: "formatting"
          }) || i.day(a, {
            width: "short",
            context: "formatting"
          }) || i.day(a, {
            width: "narrow",
            context: "formatting"
          });
        case "eeeee":
          return i.day(a, {
            width: "narrow",
            context: "formatting"
          });
        case "eeeeee":
          return i.day(a, {
            width: "short",
            context: "formatting"
          }) || i.day(a, {
            width: "narrow",
            context: "formatting"
          });
        case "eeee":
        default:
          return i.day(a, {
            width: "wide",
            context: "formatting"
          }) || i.day(a, {
            width: "abbreviated",
            context: "formatting"
          }) || i.day(a, {
            width: "short",
            context: "formatting"
          }) || i.day(a, {
            width: "narrow",
            context: "formatting"
          });
      }
    }
  }, {
    key: "validate",
    value: function(a, o) {
      return o >= 0 && o <= 6;
    }
  }, {
    key: "set",
    value: function(a, o, i, c) {
      return a = Ro(a, i, c), a.setUTCHours(0, 0, 0, 0), a;
    }
  }]), n;
}(ge);
function Sn(e) {
  return typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? Sn = function(n) {
    return typeof n;
  } : Sn = function(n) {
    return n && typeof Symbol == "function" && n.constructor === Symbol && n !== Symbol.prototype ? "symbol" : typeof n;
  }, Sn(e);
}
function Qf(e, t) {
  if (!(e instanceof t))
    throw new TypeError("Cannot call a class as a function");
}
function hi(e, t) {
  for (var n = 0; n < t.length; n++) {
    var r = t[n];
    r.enumerable = r.enumerable || !1, r.configurable = !0, "value" in r && (r.writable = !0), Object.defineProperty(e, r.key, r);
  }
}
function Xf(e, t, n) {
  return t && hi(e.prototype, t), n && hi(e, n), e;
}
function Kf(e, t) {
  if (typeof t != "function" && t !== null)
    throw new TypeError("Super expression must either be null or a function");
  e.prototype = Object.create(t && t.prototype, { constructor: { value: e, writable: !0, configurable: !0 } }), t && Ea(e, t);
}
function Ea(e, t) {
  return Ea = Object.setPrototypeOf || function(r, a) {
    return r.__proto__ = a, r;
  }, Ea(e, t);
}
function Jf(e) {
  var t = ed();
  return function() {
    var r = pr(e), a;
    if (t) {
      var o = pr(this).constructor;
      a = Reflect.construct(r, arguments, o);
    } else
      a = r.apply(this, arguments);
    return Zf(this, a);
  };
}
function Zf(e, t) {
  return t && (Sn(t) === "object" || typeof t == "function") ? t : Ya(e);
}
function Ya(e) {
  if (e === void 0)
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  return e;
}
function ed() {
  if (typeof Reflect > "u" || !Reflect.construct || Reflect.construct.sham)
    return !1;
  if (typeof Proxy == "function")
    return !0;
  try {
    return Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
    })), !0;
  } catch {
    return !1;
  }
}
function pr(e) {
  return pr = Object.setPrototypeOf ? Object.getPrototypeOf : function(n) {
    return n.__proto__ || Object.getPrototypeOf(n);
  }, pr(e);
}
function bi(e, t, n) {
  return t in e ? Object.defineProperty(e, t, { value: n, enumerable: !0, configurable: !0, writable: !0 }) : e[t] = n, e;
}
var td = /* @__PURE__ */ function(e) {
  Kf(n, e);
  var t = Jf(n);
  function n() {
    var r;
    Qf(this, n);
    for (var a = arguments.length, o = new Array(a), i = 0; i < a; i++)
      o[i] = arguments[i];
    return r = t.call.apply(t, [this].concat(o)), bi(Ya(r), "priority", 90), bi(Ya(r), "incompatibleTokens", ["y", "R", "u", "q", "Q", "M", "L", "I", "d", "D", "E", "i", "e", "t", "T"]), r;
  }
  return Xf(n, [{
    key: "parse",
    value: function(a, o, i, c) {
      var s = function(b) {
        var y = Math.floor((b - 1) / 7) * 7;
        return (b + c.weekStartsOn + 6) % 7 + y;
      };
      switch (o) {
        case "c":
        case "cc":
          return Be(Ne(o.length, a), s);
        case "co":
          return Be(i.ordinalNumber(a, {
            unit: "day"
          }), s);
        case "ccc":
          return i.day(a, {
            width: "abbreviated",
            context: "standalone"
          }) || i.day(a, {
            width: "short",
            context: "standalone"
          }) || i.day(a, {
            width: "narrow",
            context: "standalone"
          });
        case "ccccc":
          return i.day(a, {
            width: "narrow",
            context: "standalone"
          });
        case "cccccc":
          return i.day(a, {
            width: "short",
            context: "standalone"
          }) || i.day(a, {
            width: "narrow",
            context: "standalone"
          });
        case "cccc":
        default:
          return i.day(a, {
            width: "wide",
            context: "standalone"
          }) || i.day(a, {
            width: "abbreviated",
            context: "standalone"
          }) || i.day(a, {
            width: "short",
            context: "standalone"
          }) || i.day(a, {
            width: "narrow",
            context: "standalone"
          });
      }
    }
  }, {
    key: "validate",
    value: function(a, o) {
      return o >= 0 && o <= 6;
    }
  }, {
    key: "set",
    value: function(a, o, i, c) {
      return a = Ro(a, i, c), a.setUTCHours(0, 0, 0, 0), a;
    }
  }]), n;
}(ge);
function nd(e, t) {
  J(2, arguments);
  var n = re(t);
  n % 7 === 0 && (n = n - 7);
  var r = 1, a = ae(e), o = a.getUTCDay(), i = n % 7, c = (i + 7) % 7, s = (c < r ? 7 : 0) + n - o;
  return a.setUTCDate(a.getUTCDate() + s), a;
}
function xn(e) {
  return typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? xn = function(n) {
    return typeof n;
  } : xn = function(n) {
    return n && typeof Symbol == "function" && n.constructor === Symbol && n !== Symbol.prototype ? "symbol" : typeof n;
  }, xn(e);
}
function rd(e, t) {
  if (!(e instanceof t))
    throw new TypeError("Cannot call a class as a function");
}
function gi(e, t) {
  for (var n = 0; n < t.length; n++) {
    var r = t[n];
    r.enumerable = r.enumerable || !1, r.configurable = !0, "value" in r && (r.writable = !0), Object.defineProperty(e, r.key, r);
  }
}
function ad(e, t, n) {
  return t && gi(e.prototype, t), n && gi(e, n), e;
}
function od(e, t) {
  if (typeof t != "function" && t !== null)
    throw new TypeError("Super expression must either be null or a function");
  e.prototype = Object.create(t && t.prototype, { constructor: { value: e, writable: !0, configurable: !0 } }), t && Va(e, t);
}
function Va(e, t) {
  return Va = Object.setPrototypeOf || function(r, a) {
    return r.__proto__ = a, r;
  }, Va(e, t);
}
function id(e) {
  var t = ld();
  return function() {
    var r = mr(e), a;
    if (t) {
      var o = mr(this).constructor;
      a = Reflect.construct(r, arguments, o);
    } else
      a = r.apply(this, arguments);
    return ud(this, a);
  };
}
function ud(e, t) {
  return t && (xn(t) === "object" || typeof t == "function") ? t : Fa(e);
}
function Fa(e) {
  if (e === void 0)
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  return e;
}
function ld() {
  if (typeof Reflect > "u" || !Reflect.construct || Reflect.construct.sham)
    return !1;
  if (typeof Proxy == "function")
    return !0;
  try {
    return Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
    })), !0;
  } catch {
    return !1;
  }
}
function mr(e) {
  return mr = Object.setPrototypeOf ? Object.getPrototypeOf : function(n) {
    return n.__proto__ || Object.getPrototypeOf(n);
  }, mr(e);
}
function wi(e, t, n) {
  return t in e ? Object.defineProperty(e, t, { value: n, enumerable: !0, configurable: !0, writable: !0 }) : e[t] = n, e;
}
var sd = /* @__PURE__ */ function(e) {
  od(n, e);
  var t = id(n);
  function n() {
    var r;
    rd(this, n);
    for (var a = arguments.length, o = new Array(a), i = 0; i < a; i++)
      o[i] = arguments[i];
    return r = t.call.apply(t, [this].concat(o)), wi(Fa(r), "priority", 90), wi(Fa(r), "incompatibleTokens", ["y", "Y", "u", "q", "Q", "M", "L", "w", "d", "D", "E", "e", "c", "t", "T"]), r;
  }
  return ad(n, [{
    key: "parse",
    value: function(a, o, i) {
      var c = function(d) {
        return d === 0 ? 7 : d;
      };
      switch (o) {
        case "i":
        case "ii":
          return Ne(o.length, a);
        case "io":
          return i.ordinalNumber(a, {
            unit: "day"
          });
        case "iii":
          return Be(i.day(a, {
            width: "abbreviated",
            context: "formatting"
          }) || i.day(a, {
            width: "short",
            context: "formatting"
          }) || i.day(a, {
            width: "narrow",
            context: "formatting"
          }), c);
        case "iiiii":
          return Be(i.day(a, {
            width: "narrow",
            context: "formatting"
          }), c);
        case "iiiiii":
          return Be(i.day(a, {
            width: "short",
            context: "formatting"
          }) || i.day(a, {
            width: "narrow",
            context: "formatting"
          }), c);
        case "iiii":
        default:
          return Be(i.day(a, {
            width: "wide",
            context: "formatting"
          }) || i.day(a, {
            width: "abbreviated",
            context: "formatting"
          }) || i.day(a, {
            width: "short",
            context: "formatting"
          }) || i.day(a, {
            width: "narrow",
            context: "formatting"
          }), c);
      }
    }
  }, {
    key: "validate",
    value: function(a, o) {
      return o >= 1 && o <= 7;
    }
  }, {
    key: "set",
    value: function(a, o, i) {
      return a = nd(a, i), a.setUTCHours(0, 0, 0, 0), a;
    }
  }]), n;
}(ge);
function Rn(e) {
  return typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? Rn = function(n) {
    return typeof n;
  } : Rn = function(n) {
    return n && typeof Symbol == "function" && n.constructor === Symbol && n !== Symbol.prototype ? "symbol" : typeof n;
  }, Rn(e);
}
function cd(e, t) {
  if (!(e instanceof t))
    throw new TypeError("Cannot call a class as a function");
}
function _i(e, t) {
  for (var n = 0; n < t.length; n++) {
    var r = t[n];
    r.enumerable = r.enumerable || !1, r.configurable = !0, "value" in r && (r.writable = !0), Object.defineProperty(e, r.key, r);
  }
}
function fd(e, t, n) {
  return t && _i(e.prototype, t), n && _i(e, n), e;
}
function dd(e, t) {
  if (typeof t != "function" && t !== null)
    throw new TypeError("Super expression must either be null or a function");
  e.prototype = Object.create(t && t.prototype, { constructor: { value: e, writable: !0, configurable: !0 } }), t && Ua(e, t);
}
function Ua(e, t) {
  return Ua = Object.setPrototypeOf || function(r, a) {
    return r.__proto__ = a, r;
  }, Ua(e, t);
}
function yd(e) {
  var t = md();
  return function() {
    var r = vr(e), a;
    if (t) {
      var o = vr(this).constructor;
      a = Reflect.construct(r, arguments, o);
    } else
      a = r.apply(this, arguments);
    return pd(this, a);
  };
}
function pd(e, t) {
  return t && (Rn(t) === "object" || typeof t == "function") ? t : La(e);
}
function La(e) {
  if (e === void 0)
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  return e;
}
function md() {
  if (typeof Reflect > "u" || !Reflect.construct || Reflect.construct.sham)
    return !1;
  if (typeof Proxy == "function")
    return !0;
  try {
    return Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
    })), !0;
  } catch {
    return !1;
  }
}
function vr(e) {
  return vr = Object.setPrototypeOf ? Object.getPrototypeOf : function(n) {
    return n.__proto__ || Object.getPrototypeOf(n);
  }, vr(e);
}
function Oi(e, t, n) {
  return t in e ? Object.defineProperty(e, t, { value: n, enumerable: !0, configurable: !0, writable: !0 }) : e[t] = n, e;
}
var vd = /* @__PURE__ */ function(e) {
  dd(n, e);
  var t = yd(n);
  function n() {
    var r;
    cd(this, n);
    for (var a = arguments.length, o = new Array(a), i = 0; i < a; i++)
      o[i] = arguments[i];
    return r = t.call.apply(t, [this].concat(o)), Oi(La(r), "priority", 80), Oi(La(r), "incompatibleTokens", ["b", "B", "H", "k", "t", "T"]), r;
  }
  return fd(n, [{
    key: "parse",
    value: function(a, o, i) {
      switch (o) {
        case "a":
        case "aa":
        case "aaa":
          return i.dayPeriod(a, {
            width: "abbreviated",
            context: "formatting"
          }) || i.dayPeriod(a, {
            width: "narrow",
            context: "formatting"
          });
        case "aaaaa":
          return i.dayPeriod(a, {
            width: "narrow",
            context: "formatting"
          });
        case "aaaa":
        default:
          return i.dayPeriod(a, {
            width: "wide",
            context: "formatting"
          }) || i.dayPeriod(a, {
            width: "abbreviated",
            context: "formatting"
          }) || i.dayPeriod(a, {
            width: "narrow",
            context: "formatting"
          });
      }
    }
  }, {
    key: "set",
    value: function(a, o, i) {
      return a.setUTCHours(xo(i), 0, 0, 0), a;
    }
  }]), n;
}(ge);
function Mn(e) {
  return typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? Mn = function(n) {
    return typeof n;
  } : Mn = function(n) {
    return n && typeof Symbol == "function" && n.constructor === Symbol && n !== Symbol.prototype ? "symbol" : typeof n;
  }, Mn(e);
}
function hd(e, t) {
  if (!(e instanceof t))
    throw new TypeError("Cannot call a class as a function");
}
function $i(e, t) {
  for (var n = 0; n < t.length; n++) {
    var r = t[n];
    r.enumerable = r.enumerable || !1, r.configurable = !0, "value" in r && (r.writable = !0), Object.defineProperty(e, r.key, r);
  }
}
function bd(e, t, n) {
  return t && $i(e.prototype, t), n && $i(e, n), e;
}
function gd(e, t) {
  if (typeof t != "function" && t !== null)
    throw new TypeError("Super expression must either be null or a function");
  e.prototype = Object.create(t && t.prototype, { constructor: { value: e, writable: !0, configurable: !0 } }), t && Wa(e, t);
}
function Wa(e, t) {
  return Wa = Object.setPrototypeOf || function(r, a) {
    return r.__proto__ = a, r;
  }, Wa(e, t);
}
function wd(e) {
  var t = Od();
  return function() {
    var r = hr(e), a;
    if (t) {
      var o = hr(this).constructor;
      a = Reflect.construct(r, arguments, o);
    } else
      a = r.apply(this, arguments);
    return _d(this, a);
  };
}
function _d(e, t) {
  return t && (Mn(t) === "object" || typeof t == "function") ? t : za(e);
}
function za(e) {
  if (e === void 0)
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  return e;
}
function Od() {
  if (typeof Reflect > "u" || !Reflect.construct || Reflect.construct.sham)
    return !1;
  if (typeof Proxy == "function")
    return !0;
  try {
    return Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
    })), !0;
  } catch {
    return !1;
  }
}
function hr(e) {
  return hr = Object.setPrototypeOf ? Object.getPrototypeOf : function(n) {
    return n.__proto__ || Object.getPrototypeOf(n);
  }, hr(e);
}
function Pi(e, t, n) {
  return t in e ? Object.defineProperty(e, t, { value: n, enumerable: !0, configurable: !0, writable: !0 }) : e[t] = n, e;
}
var $d = /* @__PURE__ */ function(e) {
  gd(n, e);
  var t = wd(n);
  function n() {
    var r;
    hd(this, n);
    for (var a = arguments.length, o = new Array(a), i = 0; i < a; i++)
      o[i] = arguments[i];
    return r = t.call.apply(t, [this].concat(o)), Pi(za(r), "priority", 80), Pi(za(r), "incompatibleTokens", ["a", "B", "H", "k", "t", "T"]), r;
  }
  return bd(n, [{
    key: "parse",
    value: function(a, o, i) {
      switch (o) {
        case "b":
        case "bb":
        case "bbb":
          return i.dayPeriod(a, {
            width: "abbreviated",
            context: "formatting"
          }) || i.dayPeriod(a, {
            width: "narrow",
            context: "formatting"
          });
        case "bbbbb":
          return i.dayPeriod(a, {
            width: "narrow",
            context: "formatting"
          });
        case "bbbb":
        default:
          return i.dayPeriod(a, {
            width: "wide",
            context: "formatting"
          }) || i.dayPeriod(a, {
            width: "abbreviated",
            context: "formatting"
          }) || i.dayPeriod(a, {
            width: "narrow",
            context: "formatting"
          });
      }
    }
  }, {
    key: "set",
    value: function(a, o, i) {
      return a.setUTCHours(xo(i), 0, 0, 0), a;
    }
  }]), n;
}(ge);
function Nn(e) {
  return typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? Nn = function(n) {
    return typeof n;
  } : Nn = function(n) {
    return n && typeof Symbol == "function" && n.constructor === Symbol && n !== Symbol.prototype ? "symbol" : typeof n;
  }, Nn(e);
}
function Pd(e, t) {
  if (!(e instanceof t))
    throw new TypeError("Cannot call a class as a function");
}
function ki(e, t) {
  for (var n = 0; n < t.length; n++) {
    var r = t[n];
    r.enumerable = r.enumerable || !1, r.configurable = !0, "value" in r && (r.writable = !0), Object.defineProperty(e, r.key, r);
  }
}
function kd(e, t, n) {
  return t && ki(e.prototype, t), n && ki(e, n), e;
}
function Td(e, t) {
  if (typeof t != "function" && t !== null)
    throw new TypeError("Super expression must either be null or a function");
  e.prototype = Object.create(t && t.prototype, { constructor: { value: e, writable: !0, configurable: !0 } }), t && Ha(e, t);
}
function Ha(e, t) {
  return Ha = Object.setPrototypeOf || function(r, a) {
    return r.__proto__ = a, r;
  }, Ha(e, t);
}
function Dd(e) {
  var t = xd();
  return function() {
    var r = br(e), a;
    if (t) {
      var o = br(this).constructor;
      a = Reflect.construct(r, arguments, o);
    } else
      a = r.apply(this, arguments);
    return Sd(this, a);
  };
}
function Sd(e, t) {
  return t && (Nn(t) === "object" || typeof t == "function") ? t : ja(e);
}
function ja(e) {
  if (e === void 0)
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  return e;
}
function xd() {
  if (typeof Reflect > "u" || !Reflect.construct || Reflect.construct.sham)
    return !1;
  if (typeof Proxy == "function")
    return !0;
  try {
    return Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
    })), !0;
  } catch {
    return !1;
  }
}
function br(e) {
  return br = Object.setPrototypeOf ? Object.getPrototypeOf : function(n) {
    return n.__proto__ || Object.getPrototypeOf(n);
  }, br(e);
}
function Ti(e, t, n) {
  return t in e ? Object.defineProperty(e, t, { value: n, enumerable: !0, configurable: !0, writable: !0 }) : e[t] = n, e;
}
var Rd = /* @__PURE__ */ function(e) {
  Td(n, e);
  var t = Dd(n);
  function n() {
    var r;
    Pd(this, n);
    for (var a = arguments.length, o = new Array(a), i = 0; i < a; i++)
      o[i] = arguments[i];
    return r = t.call.apply(t, [this].concat(o)), Ti(ja(r), "priority", 80), Ti(ja(r), "incompatibleTokens", ["a", "b", "t", "T"]), r;
  }
  return kd(n, [{
    key: "parse",
    value: function(a, o, i) {
      switch (o) {
        case "B":
        case "BB":
        case "BBB":
          return i.dayPeriod(a, {
            width: "abbreviated",
            context: "formatting"
          }) || i.dayPeriod(a, {
            width: "narrow",
            context: "formatting"
          });
        case "BBBBB":
          return i.dayPeriod(a, {
            width: "narrow",
            context: "formatting"
          });
        case "BBBB":
        default:
          return i.dayPeriod(a, {
            width: "wide",
            context: "formatting"
          }) || i.dayPeriod(a, {
            width: "abbreviated",
            context: "formatting"
          }) || i.dayPeriod(a, {
            width: "narrow",
            context: "formatting"
          });
      }
    }
  }, {
    key: "set",
    value: function(a, o, i) {
      return a.setUTCHours(xo(i), 0, 0, 0), a;
    }
  }]), n;
}(ge);
function Cn(e) {
  return typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? Cn = function(n) {
    return typeof n;
  } : Cn = function(n) {
    return n && typeof Symbol == "function" && n.constructor === Symbol && n !== Symbol.prototype ? "symbol" : typeof n;
  }, Cn(e);
}
function Md(e, t) {
  if (!(e instanceof t))
    throw new TypeError("Cannot call a class as a function");
}
function Di(e, t) {
  for (var n = 0; n < t.length; n++) {
    var r = t[n];
    r.enumerable = r.enumerable || !1, r.configurable = !0, "value" in r && (r.writable = !0), Object.defineProperty(e, r.key, r);
  }
}
function Nd(e, t, n) {
  return t && Di(e.prototype, t), n && Di(e, n), e;
}
function Cd(e, t) {
  if (typeof t != "function" && t !== null)
    throw new TypeError("Super expression must either be null or a function");
  e.prototype = Object.create(t && t.prototype, { constructor: { value: e, writable: !0, configurable: !0 } }), t && qa(e, t);
}
function qa(e, t) {
  return qa = Object.setPrototypeOf || function(r, a) {
    return r.__proto__ = a, r;
  }, qa(e, t);
}
function Bd(e) {
  var t = Id();
  return function() {
    var r = gr(e), a;
    if (t) {
      var o = gr(this).constructor;
      a = Reflect.construct(r, arguments, o);
    } else
      a = r.apply(this, arguments);
    return Ad(this, a);
  };
}
function Ad(e, t) {
  return t && (Cn(t) === "object" || typeof t == "function") ? t : Ga(e);
}
function Ga(e) {
  if (e === void 0)
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  return e;
}
function Id() {
  if (typeof Reflect > "u" || !Reflect.construct || Reflect.construct.sham)
    return !1;
  if (typeof Proxy == "function")
    return !0;
  try {
    return Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
    })), !0;
  } catch {
    return !1;
  }
}
function gr(e) {
  return gr = Object.setPrototypeOf ? Object.getPrototypeOf : function(n) {
    return n.__proto__ || Object.getPrototypeOf(n);
  }, gr(e);
}
function Si(e, t, n) {
  return t in e ? Object.defineProperty(e, t, { value: n, enumerable: !0, configurable: !0, writable: !0 }) : e[t] = n, e;
}
var Ed = /* @__PURE__ */ function(e) {
  Cd(n, e);
  var t = Bd(n);
  function n() {
    var r;
    Md(this, n);
    for (var a = arguments.length, o = new Array(a), i = 0; i < a; i++)
      o[i] = arguments[i];
    return r = t.call.apply(t, [this].concat(o)), Si(Ga(r), "priority", 70), Si(Ga(r), "incompatibleTokens", ["H", "K", "k", "t", "T"]), r;
  }
  return Nd(n, [{
    key: "parse",
    value: function(a, o, i) {
      switch (o) {
        case "h":
          return xe(Ce.hour12h, a);
        case "ho":
          return i.ordinalNumber(a, {
            unit: "hour"
          });
        default:
          return Ne(o.length, a);
      }
    }
  }, {
    key: "validate",
    value: function(a, o) {
      return o >= 1 && o <= 12;
    }
  }, {
    key: "set",
    value: function(a, o, i) {
      var c = a.getUTCHours() >= 12;
      return c && i < 12 ? a.setUTCHours(i + 12, 0, 0, 0) : !c && i === 12 ? a.setUTCHours(0, 0, 0, 0) : a.setUTCHours(i, 0, 0, 0), a;
    }
  }]), n;
}(ge);
function Bn(e) {
  return typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? Bn = function(n) {
    return typeof n;
  } : Bn = function(n) {
    return n && typeof Symbol == "function" && n.constructor === Symbol && n !== Symbol.prototype ? "symbol" : typeof n;
  }, Bn(e);
}
function Yd(e, t) {
  if (!(e instanceof t))
    throw new TypeError("Cannot call a class as a function");
}
function xi(e, t) {
  for (var n = 0; n < t.length; n++) {
    var r = t[n];
    r.enumerable = r.enumerable || !1, r.configurable = !0, "value" in r && (r.writable = !0), Object.defineProperty(e, r.key, r);
  }
}
function Vd(e, t, n) {
  return t && xi(e.prototype, t), n && xi(e, n), e;
}
function Fd(e, t) {
  if (typeof t != "function" && t !== null)
    throw new TypeError("Super expression must either be null or a function");
  e.prototype = Object.create(t && t.prototype, { constructor: { value: e, writable: !0, configurable: !0 } }), t && Qa(e, t);
}
function Qa(e, t) {
  return Qa = Object.setPrototypeOf || function(r, a) {
    return r.__proto__ = a, r;
  }, Qa(e, t);
}
function Ud(e) {
  var t = Wd();
  return function() {
    var r = wr(e), a;
    if (t) {
      var o = wr(this).constructor;
      a = Reflect.construct(r, arguments, o);
    } else
      a = r.apply(this, arguments);
    return Ld(this, a);
  };
}
function Ld(e, t) {
  return t && (Bn(t) === "object" || typeof t == "function") ? t : Xa(e);
}
function Xa(e) {
  if (e === void 0)
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  return e;
}
function Wd() {
  if (typeof Reflect > "u" || !Reflect.construct || Reflect.construct.sham)
    return !1;
  if (typeof Proxy == "function")
    return !0;
  try {
    return Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
    })), !0;
  } catch {
    return !1;
  }
}
function wr(e) {
  return wr = Object.setPrototypeOf ? Object.getPrototypeOf : function(n) {
    return n.__proto__ || Object.getPrototypeOf(n);
  }, wr(e);
}
function Ri(e, t, n) {
  return t in e ? Object.defineProperty(e, t, { value: n, enumerable: !0, configurable: !0, writable: !0 }) : e[t] = n, e;
}
var zd = /* @__PURE__ */ function(e) {
  Fd(n, e);
  var t = Ud(n);
  function n() {
    var r;
    Yd(this, n);
    for (var a = arguments.length, o = new Array(a), i = 0; i < a; i++)
      o[i] = arguments[i];
    return r = t.call.apply(t, [this].concat(o)), Ri(Xa(r), "priority", 70), Ri(Xa(r), "incompatibleTokens", ["a", "b", "h", "K", "k", "t", "T"]), r;
  }
  return Vd(n, [{
    key: "parse",
    value: function(a, o, i) {
      switch (o) {
        case "H":
          return xe(Ce.hour23h, a);
        case "Ho":
          return i.ordinalNumber(a, {
            unit: "hour"
          });
        default:
          return Ne(o.length, a);
      }
    }
  }, {
    key: "validate",
    value: function(a, o) {
      return o >= 0 && o <= 23;
    }
  }, {
    key: "set",
    value: function(a, o, i) {
      return a.setUTCHours(i, 0, 0, 0), a;
    }
  }]), n;
}(ge);
function An(e) {
  return typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? An = function(n) {
    return typeof n;
  } : An = function(n) {
    return n && typeof Symbol == "function" && n.constructor === Symbol && n !== Symbol.prototype ? "symbol" : typeof n;
  }, An(e);
}
function Hd(e, t) {
  if (!(e instanceof t))
    throw new TypeError("Cannot call a class as a function");
}
function Mi(e, t) {
  for (var n = 0; n < t.length; n++) {
    var r = t[n];
    r.enumerable = r.enumerable || !1, r.configurable = !0, "value" in r && (r.writable = !0), Object.defineProperty(e, r.key, r);
  }
}
function jd(e, t, n) {
  return t && Mi(e.prototype, t), n && Mi(e, n), e;
}
function qd(e, t) {
  if (typeof t != "function" && t !== null)
    throw new TypeError("Super expression must either be null or a function");
  e.prototype = Object.create(t && t.prototype, { constructor: { value: e, writable: !0, configurable: !0 } }), t && Ka(e, t);
}
function Ka(e, t) {
  return Ka = Object.setPrototypeOf || function(r, a) {
    return r.__proto__ = a, r;
  }, Ka(e, t);
}
function Gd(e) {
  var t = Xd();
  return function() {
    var r = _r(e), a;
    if (t) {
      var o = _r(this).constructor;
      a = Reflect.construct(r, arguments, o);
    } else
      a = r.apply(this, arguments);
    return Qd(this, a);
  };
}
function Qd(e, t) {
  return t && (An(t) === "object" || typeof t == "function") ? t : Ja(e);
}
function Ja(e) {
  if (e === void 0)
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  return e;
}
function Xd() {
  if (typeof Reflect > "u" || !Reflect.construct || Reflect.construct.sham)
    return !1;
  if (typeof Proxy == "function")
    return !0;
  try {
    return Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
    })), !0;
  } catch {
    return !1;
  }
}
function _r(e) {
  return _r = Object.setPrototypeOf ? Object.getPrototypeOf : function(n) {
    return n.__proto__ || Object.getPrototypeOf(n);
  }, _r(e);
}
function Ni(e, t, n) {
  return t in e ? Object.defineProperty(e, t, { value: n, enumerable: !0, configurable: !0, writable: !0 }) : e[t] = n, e;
}
var Kd = /* @__PURE__ */ function(e) {
  qd(n, e);
  var t = Gd(n);
  function n() {
    var r;
    Hd(this, n);
    for (var a = arguments.length, o = new Array(a), i = 0; i < a; i++)
      o[i] = arguments[i];
    return r = t.call.apply(t, [this].concat(o)), Ni(Ja(r), "priority", 70), Ni(Ja(r), "incompatibleTokens", ["h", "H", "k", "t", "T"]), r;
  }
  return jd(n, [{
    key: "parse",
    value: function(a, o, i) {
      switch (o) {
        case "K":
          return xe(Ce.hour11h, a);
        case "Ko":
          return i.ordinalNumber(a, {
            unit: "hour"
          });
        default:
          return Ne(o.length, a);
      }
    }
  }, {
    key: "validate",
    value: function(a, o) {
      return o >= 0 && o <= 11;
    }
  }, {
    key: "set",
    value: function(a, o, i) {
      var c = a.getUTCHours() >= 12;
      return c && i < 12 ? a.setUTCHours(i + 12, 0, 0, 0) : a.setUTCHours(i, 0, 0, 0), a;
    }
  }]), n;
}(ge);
function In(e) {
  return typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? In = function(n) {
    return typeof n;
  } : In = function(n) {
    return n && typeof Symbol == "function" && n.constructor === Symbol && n !== Symbol.prototype ? "symbol" : typeof n;
  }, In(e);
}
function Jd(e, t) {
  if (!(e instanceof t))
    throw new TypeError("Cannot call a class as a function");
}
function Ci(e, t) {
  for (var n = 0; n < t.length; n++) {
    var r = t[n];
    r.enumerable = r.enumerable || !1, r.configurable = !0, "value" in r && (r.writable = !0), Object.defineProperty(e, r.key, r);
  }
}
function Zd(e, t, n) {
  return t && Ci(e.prototype, t), n && Ci(e, n), e;
}
function ey(e, t) {
  if (typeof t != "function" && t !== null)
    throw new TypeError("Super expression must either be null or a function");
  e.prototype = Object.create(t && t.prototype, { constructor: { value: e, writable: !0, configurable: !0 } }), t && Za(e, t);
}
function Za(e, t) {
  return Za = Object.setPrototypeOf || function(r, a) {
    return r.__proto__ = a, r;
  }, Za(e, t);
}
function ty(e) {
  var t = ry();
  return function() {
    var r = Or(e), a;
    if (t) {
      var o = Or(this).constructor;
      a = Reflect.construct(r, arguments, o);
    } else
      a = r.apply(this, arguments);
    return ny(this, a);
  };
}
function ny(e, t) {
  return t && (In(t) === "object" || typeof t == "function") ? t : eo(e);
}
function eo(e) {
  if (e === void 0)
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  return e;
}
function ry() {
  if (typeof Reflect > "u" || !Reflect.construct || Reflect.construct.sham)
    return !1;
  if (typeof Proxy == "function")
    return !0;
  try {
    return Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
    })), !0;
  } catch {
    return !1;
  }
}
function Or(e) {
  return Or = Object.setPrototypeOf ? Object.getPrototypeOf : function(n) {
    return n.__proto__ || Object.getPrototypeOf(n);
  }, Or(e);
}
function Bi(e, t, n) {
  return t in e ? Object.defineProperty(e, t, { value: n, enumerable: !0, configurable: !0, writable: !0 }) : e[t] = n, e;
}
var ay = /* @__PURE__ */ function(e) {
  ey(n, e);
  var t = ty(n);
  function n() {
    var r;
    Jd(this, n);
    for (var a = arguments.length, o = new Array(a), i = 0; i < a; i++)
      o[i] = arguments[i];
    return r = t.call.apply(t, [this].concat(o)), Bi(eo(r), "priority", 70), Bi(eo(r), "incompatibleTokens", ["a", "b", "h", "H", "K", "t", "T"]), r;
  }
  return Zd(n, [{
    key: "parse",
    value: function(a, o, i) {
      switch (o) {
        case "k":
          return xe(Ce.hour24h, a);
        case "ko":
          return i.ordinalNumber(a, {
            unit: "hour"
          });
        default:
          return Ne(o.length, a);
      }
    }
  }, {
    key: "validate",
    value: function(a, o) {
      return o >= 1 && o <= 24;
    }
  }, {
    key: "set",
    value: function(a, o, i) {
      var c = i <= 24 ? i % 24 : i;
      return a.setUTCHours(c, 0, 0, 0), a;
    }
  }]), n;
}(ge);
function En(e) {
  return typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? En = function(n) {
    return typeof n;
  } : En = function(n) {
    return n && typeof Symbol == "function" && n.constructor === Symbol && n !== Symbol.prototype ? "symbol" : typeof n;
  }, En(e);
}
function oy(e, t) {
  if (!(e instanceof t))
    throw new TypeError("Cannot call a class as a function");
}
function Ai(e, t) {
  for (var n = 0; n < t.length; n++) {
    var r = t[n];
    r.enumerable = r.enumerable || !1, r.configurable = !0, "value" in r && (r.writable = !0), Object.defineProperty(e, r.key, r);
  }
}
function iy(e, t, n) {
  return t && Ai(e.prototype, t), n && Ai(e, n), e;
}
function uy(e, t) {
  if (typeof t != "function" && t !== null)
    throw new TypeError("Super expression must either be null or a function");
  e.prototype = Object.create(t && t.prototype, { constructor: { value: e, writable: !0, configurable: !0 } }), t && to(e, t);
}
function to(e, t) {
  return to = Object.setPrototypeOf || function(r, a) {
    return r.__proto__ = a, r;
  }, to(e, t);
}
function ly(e) {
  var t = cy();
  return function() {
    var r = $r(e), a;
    if (t) {
      var o = $r(this).constructor;
      a = Reflect.construct(r, arguments, o);
    } else
      a = r.apply(this, arguments);
    return sy(this, a);
  };
}
function sy(e, t) {
  return t && (En(t) === "object" || typeof t == "function") ? t : no(e);
}
function no(e) {
  if (e === void 0)
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  return e;
}
function cy() {
  if (typeof Reflect > "u" || !Reflect.construct || Reflect.construct.sham)
    return !1;
  if (typeof Proxy == "function")
    return !0;
  try {
    return Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
    })), !0;
  } catch {
    return !1;
  }
}
function $r(e) {
  return $r = Object.setPrototypeOf ? Object.getPrototypeOf : function(n) {
    return n.__proto__ || Object.getPrototypeOf(n);
  }, $r(e);
}
function Ii(e, t, n) {
  return t in e ? Object.defineProperty(e, t, { value: n, enumerable: !0, configurable: !0, writable: !0 }) : e[t] = n, e;
}
var fy = /* @__PURE__ */ function(e) {
  uy(n, e);
  var t = ly(n);
  function n() {
    var r;
    oy(this, n);
    for (var a = arguments.length, o = new Array(a), i = 0; i < a; i++)
      o[i] = arguments[i];
    return r = t.call.apply(t, [this].concat(o)), Ii(no(r), "priority", 60), Ii(no(r), "incompatibleTokens", ["t", "T"]), r;
  }
  return iy(n, [{
    key: "parse",
    value: function(a, o, i) {
      switch (o) {
        case "m":
          return xe(Ce.minute, a);
        case "mo":
          return i.ordinalNumber(a, {
            unit: "minute"
          });
        default:
          return Ne(o.length, a);
      }
    }
  }, {
    key: "validate",
    value: function(a, o) {
      return o >= 0 && o <= 59;
    }
  }, {
    key: "set",
    value: function(a, o, i) {
      return a.setUTCMinutes(i, 0, 0), a;
    }
  }]), n;
}(ge);
function Yn(e) {
  return typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? Yn = function(n) {
    return typeof n;
  } : Yn = function(n) {
    return n && typeof Symbol == "function" && n.constructor === Symbol && n !== Symbol.prototype ? "symbol" : typeof n;
  }, Yn(e);
}
function dy(e, t) {
  if (!(e instanceof t))
    throw new TypeError("Cannot call a class as a function");
}
function Ei(e, t) {
  for (var n = 0; n < t.length; n++) {
    var r = t[n];
    r.enumerable = r.enumerable || !1, r.configurable = !0, "value" in r && (r.writable = !0), Object.defineProperty(e, r.key, r);
  }
}
function yy(e, t, n) {
  return t && Ei(e.prototype, t), n && Ei(e, n), e;
}
function py(e, t) {
  if (typeof t != "function" && t !== null)
    throw new TypeError("Super expression must either be null or a function");
  e.prototype = Object.create(t && t.prototype, { constructor: { value: e, writable: !0, configurable: !0 } }), t && ro(e, t);
}
function ro(e, t) {
  return ro = Object.setPrototypeOf || function(r, a) {
    return r.__proto__ = a, r;
  }, ro(e, t);
}
function my(e) {
  var t = hy();
  return function() {
    var r = Pr(e), a;
    if (t) {
      var o = Pr(this).constructor;
      a = Reflect.construct(r, arguments, o);
    } else
      a = r.apply(this, arguments);
    return vy(this, a);
  };
}
function vy(e, t) {
  return t && (Yn(t) === "object" || typeof t == "function") ? t : ao(e);
}
function ao(e) {
  if (e === void 0)
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  return e;
}
function hy() {
  if (typeof Reflect > "u" || !Reflect.construct || Reflect.construct.sham)
    return !1;
  if (typeof Proxy == "function")
    return !0;
  try {
    return Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
    })), !0;
  } catch {
    return !1;
  }
}
function Pr(e) {
  return Pr = Object.setPrototypeOf ? Object.getPrototypeOf : function(n) {
    return n.__proto__ || Object.getPrototypeOf(n);
  }, Pr(e);
}
function Yi(e, t, n) {
  return t in e ? Object.defineProperty(e, t, { value: n, enumerable: !0, configurable: !0, writable: !0 }) : e[t] = n, e;
}
var by = /* @__PURE__ */ function(e) {
  py(n, e);
  var t = my(n);
  function n() {
    var r;
    dy(this, n);
    for (var a = arguments.length, o = new Array(a), i = 0; i < a; i++)
      o[i] = arguments[i];
    return r = t.call.apply(t, [this].concat(o)), Yi(ao(r), "priority", 50), Yi(ao(r), "incompatibleTokens", ["t", "T"]), r;
  }
  return yy(n, [{
    key: "parse",
    value: function(a, o, i) {
      switch (o) {
        case "s":
          return xe(Ce.second, a);
        case "so":
          return i.ordinalNumber(a, {
            unit: "second"
          });
        default:
          return Ne(o.length, a);
      }
    }
  }, {
    key: "validate",
    value: function(a, o) {
      return o >= 0 && o <= 59;
    }
  }, {
    key: "set",
    value: function(a, o, i) {
      return a.setUTCSeconds(i, 0), a;
    }
  }]), n;
}(ge);
function Vn(e) {
  return typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? Vn = function(n) {
    return typeof n;
  } : Vn = function(n) {
    return n && typeof Symbol == "function" && n.constructor === Symbol && n !== Symbol.prototype ? "symbol" : typeof n;
  }, Vn(e);
}
function gy(e, t) {
  if (!(e instanceof t))
    throw new TypeError("Cannot call a class as a function");
}
function Vi(e, t) {
  for (var n = 0; n < t.length; n++) {
    var r = t[n];
    r.enumerable = r.enumerable || !1, r.configurable = !0, "value" in r && (r.writable = !0), Object.defineProperty(e, r.key, r);
  }
}
function wy(e, t, n) {
  return t && Vi(e.prototype, t), n && Vi(e, n), e;
}
function _y(e, t) {
  if (typeof t != "function" && t !== null)
    throw new TypeError("Super expression must either be null or a function");
  e.prototype = Object.create(t && t.prototype, { constructor: { value: e, writable: !0, configurable: !0 } }), t && oo(e, t);
}
function oo(e, t) {
  return oo = Object.setPrototypeOf || function(r, a) {
    return r.__proto__ = a, r;
  }, oo(e, t);
}
function Oy(e) {
  var t = Py();
  return function() {
    var r = kr(e), a;
    if (t) {
      var o = kr(this).constructor;
      a = Reflect.construct(r, arguments, o);
    } else
      a = r.apply(this, arguments);
    return $y(this, a);
  };
}
function $y(e, t) {
  return t && (Vn(t) === "object" || typeof t == "function") ? t : io(e);
}
function io(e) {
  if (e === void 0)
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  return e;
}
function Py() {
  if (typeof Reflect > "u" || !Reflect.construct || Reflect.construct.sham)
    return !1;
  if (typeof Proxy == "function")
    return !0;
  try {
    return Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
    })), !0;
  } catch {
    return !1;
  }
}
function kr(e) {
  return kr = Object.setPrototypeOf ? Object.getPrototypeOf : function(n) {
    return n.__proto__ || Object.getPrototypeOf(n);
  }, kr(e);
}
function Fi(e, t, n) {
  return t in e ? Object.defineProperty(e, t, { value: n, enumerable: !0, configurable: !0, writable: !0 }) : e[t] = n, e;
}
var ky = /* @__PURE__ */ function(e) {
  _y(n, e);
  var t = Oy(n);
  function n() {
    var r;
    gy(this, n);
    for (var a = arguments.length, o = new Array(a), i = 0; i < a; i++)
      o[i] = arguments[i];
    return r = t.call.apply(t, [this].concat(o)), Fi(io(r), "priority", 30), Fi(io(r), "incompatibleTokens", ["t", "T"]), r;
  }
  return wy(n, [{
    key: "parse",
    value: function(a, o) {
      var i = function(s) {
        return Math.floor(s * Math.pow(10, -o.length + 3));
      };
      return Be(Ne(o.length, a), i);
    }
  }, {
    key: "set",
    value: function(a, o, i) {
      return a.setUTCMilliseconds(i), a;
    }
  }]), n;
}(ge);
function Fn(e) {
  return typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? Fn = function(n) {
    return typeof n;
  } : Fn = function(n) {
    return n && typeof Symbol == "function" && n.constructor === Symbol && n !== Symbol.prototype ? "symbol" : typeof n;
  }, Fn(e);
}
function Ty(e, t) {
  if (!(e instanceof t))
    throw new TypeError("Cannot call a class as a function");
}
function Ui(e, t) {
  for (var n = 0; n < t.length; n++) {
    var r = t[n];
    r.enumerable = r.enumerable || !1, r.configurable = !0, "value" in r && (r.writable = !0), Object.defineProperty(e, r.key, r);
  }
}
function Dy(e, t, n) {
  return t && Ui(e.prototype, t), n && Ui(e, n), e;
}
function Sy(e, t) {
  if (typeof t != "function" && t !== null)
    throw new TypeError("Super expression must either be null or a function");
  e.prototype = Object.create(t && t.prototype, { constructor: { value: e, writable: !0, configurable: !0 } }), t && uo(e, t);
}
function uo(e, t) {
  return uo = Object.setPrototypeOf || function(r, a) {
    return r.__proto__ = a, r;
  }, uo(e, t);
}
function xy(e) {
  var t = My();
  return function() {
    var r = Tr(e), a;
    if (t) {
      var o = Tr(this).constructor;
      a = Reflect.construct(r, arguments, o);
    } else
      a = r.apply(this, arguments);
    return Ry(this, a);
  };
}
function Ry(e, t) {
  return t && (Fn(t) === "object" || typeof t == "function") ? t : lo(e);
}
function lo(e) {
  if (e === void 0)
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  return e;
}
function My() {
  if (typeof Reflect > "u" || !Reflect.construct || Reflect.construct.sham)
    return !1;
  if (typeof Proxy == "function")
    return !0;
  try {
    return Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
    })), !0;
  } catch {
    return !1;
  }
}
function Tr(e) {
  return Tr = Object.setPrototypeOf ? Object.getPrototypeOf : function(n) {
    return n.__proto__ || Object.getPrototypeOf(n);
  }, Tr(e);
}
function Li(e, t, n) {
  return t in e ? Object.defineProperty(e, t, { value: n, enumerable: !0, configurable: !0, writable: !0 }) : e[t] = n, e;
}
var Ny = /* @__PURE__ */ function(e) {
  Sy(n, e);
  var t = xy(n);
  function n() {
    var r;
    Ty(this, n);
    for (var a = arguments.length, o = new Array(a), i = 0; i < a; i++)
      o[i] = arguments[i];
    return r = t.call.apply(t, [this].concat(o)), Li(lo(r), "priority", 10), Li(lo(r), "incompatibleTokens", ["t", "T", "x"]), r;
  }
  return Dy(n, [{
    key: "parse",
    value: function(a, o) {
      switch (o) {
        case "X":
          return at(rt.basicOptionalMinutes, a);
        case "XX":
          return at(rt.basic, a);
        case "XXXX":
          return at(rt.basicOptionalSeconds, a);
        case "XXXXX":
          return at(rt.extendedOptionalSeconds, a);
        case "XXX":
        default:
          return at(rt.extended, a);
      }
    }
  }, {
    key: "set",
    value: function(a, o, i) {
      return o.timestampIsSet ? a : new Date(a.getTime() - i);
    }
  }]), n;
}(ge);
function Un(e) {
  return typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? Un = function(n) {
    return typeof n;
  } : Un = function(n) {
    return n && typeof Symbol == "function" && n.constructor === Symbol && n !== Symbol.prototype ? "symbol" : typeof n;
  }, Un(e);
}
function Cy(e, t) {
  if (!(e instanceof t))
    throw new TypeError("Cannot call a class as a function");
}
function Wi(e, t) {
  for (var n = 0; n < t.length; n++) {
    var r = t[n];
    r.enumerable = r.enumerable || !1, r.configurable = !0, "value" in r && (r.writable = !0), Object.defineProperty(e, r.key, r);
  }
}
function By(e, t, n) {
  return t && Wi(e.prototype, t), n && Wi(e, n), e;
}
function Ay(e, t) {
  if (typeof t != "function" && t !== null)
    throw new TypeError("Super expression must either be null or a function");
  e.prototype = Object.create(t && t.prototype, { constructor: { value: e, writable: !0, configurable: !0 } }), t && so(e, t);
}
function so(e, t) {
  return so = Object.setPrototypeOf || function(r, a) {
    return r.__proto__ = a, r;
  }, so(e, t);
}
function Iy(e) {
  var t = Yy();
  return function() {
    var r = Dr(e), a;
    if (t) {
      var o = Dr(this).constructor;
      a = Reflect.construct(r, arguments, o);
    } else
      a = r.apply(this, arguments);
    return Ey(this, a);
  };
}
function Ey(e, t) {
  return t && (Un(t) === "object" || typeof t == "function") ? t : co(e);
}
function co(e) {
  if (e === void 0)
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  return e;
}
function Yy() {
  if (typeof Reflect > "u" || !Reflect.construct || Reflect.construct.sham)
    return !1;
  if (typeof Proxy == "function")
    return !0;
  try {
    return Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
    })), !0;
  } catch {
    return !1;
  }
}
function Dr(e) {
  return Dr = Object.setPrototypeOf ? Object.getPrototypeOf : function(n) {
    return n.__proto__ || Object.getPrototypeOf(n);
  }, Dr(e);
}
function zi(e, t, n) {
  return t in e ? Object.defineProperty(e, t, { value: n, enumerable: !0, configurable: !0, writable: !0 }) : e[t] = n, e;
}
var Vy = /* @__PURE__ */ function(e) {
  Ay(n, e);
  var t = Iy(n);
  function n() {
    var r;
    Cy(this, n);
    for (var a = arguments.length, o = new Array(a), i = 0; i < a; i++)
      o[i] = arguments[i];
    return r = t.call.apply(t, [this].concat(o)), zi(co(r), "priority", 10), zi(co(r), "incompatibleTokens", ["t", "T", "X"]), r;
  }
  return By(n, [{
    key: "parse",
    value: function(a, o) {
      switch (o) {
        case "x":
          return at(rt.basicOptionalMinutes, a);
        case "xx":
          return at(rt.basic, a);
        case "xxxx":
          return at(rt.basicOptionalSeconds, a);
        case "xxxxx":
          return at(rt.extendedOptionalSeconds, a);
        case "xxx":
        default:
          return at(rt.extended, a);
      }
    }
  }, {
    key: "set",
    value: function(a, o, i) {
      return o.timestampIsSet ? a : new Date(a.getTime() - i);
    }
  }]), n;
}(ge);
function Ln(e) {
  return typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? Ln = function(n) {
    return typeof n;
  } : Ln = function(n) {
    return n && typeof Symbol == "function" && n.constructor === Symbol && n !== Symbol.prototype ? "symbol" : typeof n;
  }, Ln(e);
}
function Fy(e, t) {
  if (!(e instanceof t))
    throw new TypeError("Cannot call a class as a function");
}
function Hi(e, t) {
  for (var n = 0; n < t.length; n++) {
    var r = t[n];
    r.enumerable = r.enumerable || !1, r.configurable = !0, "value" in r && (r.writable = !0), Object.defineProperty(e, r.key, r);
  }
}
function Uy(e, t, n) {
  return t && Hi(e.prototype, t), n && Hi(e, n), e;
}
function Ly(e, t) {
  if (typeof t != "function" && t !== null)
    throw new TypeError("Super expression must either be null or a function");
  e.prototype = Object.create(t && t.prototype, { constructor: { value: e, writable: !0, configurable: !0 } }), t && fo(e, t);
}
function fo(e, t) {
  return fo = Object.setPrototypeOf || function(r, a) {
    return r.__proto__ = a, r;
  }, fo(e, t);
}
function Wy(e) {
  var t = Hy();
  return function() {
    var r = Sr(e), a;
    if (t) {
      var o = Sr(this).constructor;
      a = Reflect.construct(r, arguments, o);
    } else
      a = r.apply(this, arguments);
    return zy(this, a);
  };
}
function zy(e, t) {
  return t && (Ln(t) === "object" || typeof t == "function") ? t : yo(e);
}
function yo(e) {
  if (e === void 0)
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  return e;
}
function Hy() {
  if (typeof Reflect > "u" || !Reflect.construct || Reflect.construct.sham)
    return !1;
  if (typeof Proxy == "function")
    return !0;
  try {
    return Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
    })), !0;
  } catch {
    return !1;
  }
}
function Sr(e) {
  return Sr = Object.setPrototypeOf ? Object.getPrototypeOf : function(n) {
    return n.__proto__ || Object.getPrototypeOf(n);
  }, Sr(e);
}
function ji(e, t, n) {
  return t in e ? Object.defineProperty(e, t, { value: n, enumerable: !0, configurable: !0, writable: !0 }) : e[t] = n, e;
}
var jy = /* @__PURE__ */ function(e) {
  Ly(n, e);
  var t = Wy(n);
  function n() {
    var r;
    Fy(this, n);
    for (var a = arguments.length, o = new Array(a), i = 0; i < a; i++)
      o[i] = arguments[i];
    return r = t.call.apply(t, [this].concat(o)), ji(yo(r), "priority", 40), ji(yo(r), "incompatibleTokens", "*"), r;
  }
  return Uy(n, [{
    key: "parse",
    value: function(a) {
      return Bu(a);
    }
  }, {
    key: "set",
    value: function(a, o, i) {
      return [new Date(i * 1e3), {
        timestampIsSet: !0
      }];
    }
  }]), n;
}(ge);
function Wn(e) {
  return typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? Wn = function(n) {
    return typeof n;
  } : Wn = function(n) {
    return n && typeof Symbol == "function" && n.constructor === Symbol && n !== Symbol.prototype ? "symbol" : typeof n;
  }, Wn(e);
}
function qy(e, t) {
  if (!(e instanceof t))
    throw new TypeError("Cannot call a class as a function");
}
function qi(e, t) {
  for (var n = 0; n < t.length; n++) {
    var r = t[n];
    r.enumerable = r.enumerable || !1, r.configurable = !0, "value" in r && (r.writable = !0), Object.defineProperty(e, r.key, r);
  }
}
function Gy(e, t, n) {
  return t && qi(e.prototype, t), n && qi(e, n), e;
}
function Qy(e, t) {
  if (typeof t != "function" && t !== null)
    throw new TypeError("Super expression must either be null or a function");
  e.prototype = Object.create(t && t.prototype, { constructor: { value: e, writable: !0, configurable: !0 } }), t && po(e, t);
}
function po(e, t) {
  return po = Object.setPrototypeOf || function(r, a) {
    return r.__proto__ = a, r;
  }, po(e, t);
}
function Xy(e) {
  var t = Jy();
  return function() {
    var r = xr(e), a;
    if (t) {
      var o = xr(this).constructor;
      a = Reflect.construct(r, arguments, o);
    } else
      a = r.apply(this, arguments);
    return Ky(this, a);
  };
}
function Ky(e, t) {
  return t && (Wn(t) === "object" || typeof t == "function") ? t : mo(e);
}
function mo(e) {
  if (e === void 0)
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  return e;
}
function Jy() {
  if (typeof Reflect > "u" || !Reflect.construct || Reflect.construct.sham)
    return !1;
  if (typeof Proxy == "function")
    return !0;
  try {
    return Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
    })), !0;
  } catch {
    return !1;
  }
}
function xr(e) {
  return xr = Object.setPrototypeOf ? Object.getPrototypeOf : function(n) {
    return n.__proto__ || Object.getPrototypeOf(n);
  }, xr(e);
}
function Gi(e, t, n) {
  return t in e ? Object.defineProperty(e, t, { value: n, enumerable: !0, configurable: !0, writable: !0 }) : e[t] = n, e;
}
var Zy = /* @__PURE__ */ function(e) {
  Qy(n, e);
  var t = Xy(n);
  function n() {
    var r;
    qy(this, n);
    for (var a = arguments.length, o = new Array(a), i = 0; i < a; i++)
      o[i] = arguments[i];
    return r = t.call.apply(t, [this].concat(o)), Gi(mo(r), "priority", 20), Gi(mo(r), "incompatibleTokens", "*"), r;
  }
  return Gy(n, [{
    key: "parse",
    value: function(a) {
      return Bu(a);
    }
  }, {
    key: "set",
    value: function(a, o, i) {
      return [new Date(i), {
        timestampIsSet: !0
      }];
    }
  }]), n;
}(ge), ep = {
  G: new Zs(),
  y: new ic(),
  Y: new yc(),
  R: new wc(),
  u: new Dc(),
  Q: new Bc(),
  q: new Uc(),
  M: new Gc(),
  L: new tf(),
  w: new cf(),
  I: new bf(),
  d: new Df(),
  D: new Bf(),
  E: new Uf(),
  e: new Gf(),
  c: new td(),
  i: new sd(),
  a: new vd(),
  b: new $d(),
  B: new Rd(),
  h: new Ed(),
  H: new zd(),
  K: new Kd(),
  k: new ay(),
  m: new fy(),
  s: new by(),
  S: new ky(),
  X: new Ny(),
  x: new Vy(),
  t: new jy(),
  T: new Zy()
};
function zn(e) {
  return typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? zn = function(n) {
    return typeof n;
  } : zn = function(n) {
    return n && typeof Symbol == "function" && n.constructor === Symbol && n !== Symbol.prototype ? "symbol" : typeof n;
  }, zn(e);
}
function Qi(e, t) {
  var n;
  if (typeof Symbol > "u" || e[Symbol.iterator] == null) {
    if (Array.isArray(e) || (n = tp(e)) || t && e && typeof e.length == "number") {
      n && (e = n);
      var r = 0, a = function() {
      };
      return { s: a, n: function() {
        return r >= e.length ? { done: !0 } : { done: !1, value: e[r++] };
      }, e: function(d) {
        throw d;
      }, f: a };
    }
    throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`);
  }
  var o = !0, i = !1, c;
  return { s: function() {
    n = e[Symbol.iterator]();
  }, n: function() {
    var d = n.next();
    return o = d.done, d;
  }, e: function(d) {
    i = !0, c = d;
  }, f: function() {
    try {
      !o && n.return != null && n.return();
    } finally {
      if (i)
        throw c;
    }
  } };
}
function tp(e, t) {
  if (e) {
    if (typeof e == "string")
      return Xi(e, t);
    var n = Object.prototype.toString.call(e).slice(8, -1);
    if (n === "Object" && e.constructor && (n = e.constructor.name), n === "Map" || n === "Set")
      return Array.from(e);
    if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))
      return Xi(e, t);
  }
}
function Xi(e, t) {
  (t == null || t > e.length) && (t = e.length);
  for (var n = 0, r = new Array(t); n < t; n++)
    r[n] = e[n];
  return r;
}
var np = /[yYQqMLwIdDecihHKkms]o|(\w)\1*|''|'(''|[^'])+('|$)|./g, rp = /P+p+|P+|p+|''|'(''|[^'])+('|$)|./g, ap = /^'([^]*?)'?$/, op = /''/g, ip = /\S/, up = /[a-zA-Z]/;
function vo(e, t, n, r) {
  var a, o, i, c, s, d, b, y, f, v, A, V, q, ee, G, C, z, te;
  J(3, arguments);
  var P = String(e), $ = String(t), M = vt(), L = (a = (o = r == null ? void 0 : r.locale) !== null && o !== void 0 ? o : M.locale) !== null && a !== void 0 ? a : xu;
  if (!L.match)
    throw new RangeError("locale must contain match property");
  var j = re((i = (c = (s = (d = r == null ? void 0 : r.firstWeekContainsDate) !== null && d !== void 0 ? d : r == null || (b = r.locale) === null || b === void 0 || (y = b.options) === null || y === void 0 ? void 0 : y.firstWeekContainsDate) !== null && s !== void 0 ? s : M.firstWeekContainsDate) !== null && c !== void 0 ? c : (f = M.locale) === null || f === void 0 || (v = f.options) === null || v === void 0 ? void 0 : v.firstWeekContainsDate) !== null && i !== void 0 ? i : 1);
  if (!(j >= 1 && j <= 7))
    throw new RangeError("firstWeekContainsDate must be between 1 and 7 inclusively");
  var Y = re((A = (V = (q = (ee = r == null ? void 0 : r.weekStartsOn) !== null && ee !== void 0 ? ee : r == null || (G = r.locale) === null || G === void 0 || (C = G.options) === null || C === void 0 ? void 0 : C.weekStartsOn) !== null && q !== void 0 ? q : M.weekStartsOn) !== null && V !== void 0 ? V : (z = M.locale) === null || z === void 0 || (te = z.options) === null || te === void 0 ? void 0 : te.weekStartsOn) !== null && A !== void 0 ? A : 0);
  if (!(Y >= 0 && Y <= 6))
    throw new RangeError("weekStartsOn must be between 0 and 6 inclusively");
  if ($ === "")
    return P === "" ? ae(n) : new Date(NaN);
  var X = {
    firstWeekContainsDate: j,
    weekStartsOn: Y,
    locale: L
  }, O = [new zs()], m = $.match(rp).map(function(me) {
    var ue = me[0];
    if (ue in oa) {
      var De = oa[ue];
      return De(me, L.formatLong);
    }
    return me;
  }).join("").match(np), k = [], D = Qi(m), u;
  try {
    var w = function() {
      var ue = u.value;
      !(r != null && r.useAdditionalWeekYearTokens) && Su(ue) && Xn(ue, $, e), !(r != null && r.useAdditionalDayOfYearTokens) && Du(ue) && Xn(ue, $, e);
      var De = ue[0], Ke = ep[De];
      if (Ke) {
        var se = Ke.incompatibleTokens;
        if (Array.isArray(se)) {
          var fe = k.find(function(be) {
            return se.includes(be.token) || be.token === De;
          });
          if (fe)
            throw new RangeError("The format string mustn't contain `".concat(fe.fullToken, "` and `").concat(ue, "` at the same time"));
        } else if (Ke.incompatibleTokens === "*" && k.length > 0)
          throw new RangeError("The format string mustn't contain `".concat(ue, "` and any other token at the same time"));
        k.push({
          token: De,
          fullToken: ue
        });
        var _e = Ke.run(P, ue, L.match, X);
        if (!_e)
          return {
            v: new Date(NaN)
          };
        O.push(_e.setter), P = _e.rest;
      } else {
        if (De.match(up))
          throw new RangeError("Format string contains an unescaped latin alphabet character `" + De + "`");
        if (ue === "''" ? ue = "'" : De === "'" && (ue = lp(ue)), P.indexOf(ue) === 0)
          P = P.slice(ue.length);
        else
          return {
            v: new Date(NaN)
          };
      }
    };
    for (D.s(); !(u = D.n()).done; ) {
      var S = w();
      if (zn(S) === "object")
        return S.v;
    }
  } catch (me) {
    D.e(me);
  } finally {
    D.f();
  }
  if (P.length > 0 && ip.test(P))
    return new Date(NaN);
  var I = O.map(function(me) {
    return me.priority;
  }).sort(function(me, ue) {
    return ue - me;
  }).filter(function(me, ue, De) {
    return De.indexOf(me) === ue;
  }).map(function(me) {
    return O.filter(function(ue) {
      return ue.priority === me;
    }).sort(function(ue, De) {
      return De.subPriority - ue.subPriority;
    });
  }).map(function(me) {
    return me[0];
  }), U = ae(n);
  if (isNaN(U.getTime()))
    return new Date(NaN);
  var _ = Ou(U, Qn(U)), le = {}, de = Qi(I), h;
  try {
    for (de.s(); !(h = de.n()).done; ) {
      var E = h.value;
      if (!E.validate(_, X))
        return new Date(NaN);
      var Me = E.set(_, le, X);
      Array.isArray(Me) ? (_ = Me[0], As(le, Me[1])) : _ = Me;
    }
  } catch (me) {
    de.e(me);
  } finally {
    de.f();
  }
  return _;
}
function lp(e) {
  return e.match(ap)[1].replace(op, "'");
}
function sp(e, t) {
  J(2, arguments);
  var n = re(t);
  return yt(e, -n);
}
function cp(e, t) {
  var n;
  J(1, arguments);
  var r = re((n = t == null ? void 0 : t.additionalDigits) !== null && n !== void 0 ? n : 2);
  if (r !== 2 && r !== 1 && r !== 0)
    throw new RangeError("additionalDigits must be 0, 1 or 2");
  if (!(typeof e == "string" || Object.prototype.toString.call(e) === "[object String]"))
    return new Date(NaN);
  var a = pp(e), o;
  if (a.date) {
    var i = mp(a.date, r);
    o = vp(i.restDateString, i.year);
  }
  if (!o || isNaN(o.getTime()))
    return new Date(NaN);
  var c = o.getTime(), s = 0, d;
  if (a.time && (s = hp(a.time), isNaN(s)))
    return new Date(NaN);
  if (a.timezone) {
    if (d = bp(a.timezone), isNaN(d))
      return new Date(NaN);
  } else {
    var b = new Date(c + s), y = new Date(0);
    return y.setFullYear(b.getUTCFullYear(), b.getUTCMonth(), b.getUTCDate()), y.setHours(b.getUTCHours(), b.getUTCMinutes(), b.getUTCSeconds(), b.getUTCMilliseconds()), y;
  }
  return new Date(c + s + d);
}
var tn = {
  dateTimeDelimiter: /[T ]/,
  timeZoneDelimiter: /[Z ]/i,
  timezone: /([Z+-].*)$/
}, fp = /^-?(?:(\d{3})|(\d{2})(?:-?(\d{2}))?|W(\d{2})(?:-?(\d{1}))?|)$/, dp = /^(\d{2}(?:[.,]\d*)?)(?::?(\d{2}(?:[.,]\d*)?))?(?::?(\d{2}(?:[.,]\d*)?))?$/, yp = /^([+-])(\d{2})(?::?(\d{2}))?$/;
function pp(e) {
  var t = {}, n = e.split(tn.dateTimeDelimiter), r;
  if (n.length > 2)
    return t;
  if (/:/.test(n[0]) ? r = n[0] : (t.date = n[0], r = n[1], tn.timeZoneDelimiter.test(t.date) && (t.date = e.split(tn.timeZoneDelimiter)[0], r = e.substr(t.date.length, e.length))), r) {
    var a = tn.timezone.exec(r);
    a ? (t.time = r.replace(a[1], ""), t.timezone = a[1]) : t.time = r;
  }
  return t;
}
function mp(e, t) {
  var n = new RegExp("^(?:(\\d{4}|[+-]\\d{" + (4 + t) + "})|(\\d{2}|[+-]\\d{" + (2 + t) + "})$)"), r = e.match(n);
  if (!r)
    return {
      year: NaN,
      restDateString: ""
    };
  var a = r[1] ? parseInt(r[1]) : null, o = r[2] ? parseInt(r[2]) : null;
  return {
    year: o === null ? a : o * 100,
    restDateString: e.slice((r[1] || r[2]).length)
  };
}
function vp(e, t) {
  if (t === null)
    return new Date(NaN);
  var n = e.match(fp);
  if (!n)
    return new Date(NaN);
  var r = !!n[4], a = Wt(n[1]), o = Wt(n[2]) - 1, i = Wt(n[3]), c = Wt(n[4]), s = Wt(n[5]) - 1;
  if (r)
    return $p(t, c, s) ? gp(t, c, s) : new Date(NaN);
  var d = new Date(0);
  return !_p(t, o, i) || !Op(t, a) ? new Date(NaN) : (d.setUTCFullYear(t, o, Math.max(a, i)), d);
}
function Wt(e) {
  return e ? parseInt(e) : 1;
}
function hp(e) {
  var t = e.match(dp);
  if (!t)
    return NaN;
  var n = jr(t[1]), r = jr(t[2]), a = jr(t[3]);
  return Pp(n, r, a) ? n * $o + r * Oo + a * 1e3 : NaN;
}
function jr(e) {
  return e && parseFloat(e.replace(",", ".")) || 0;
}
function bp(e) {
  if (e === "Z")
    return 0;
  var t = e.match(yp);
  if (!t)
    return 0;
  var n = t[1] === "+" ? -1 : 1, r = parseInt(t[2]), a = t[3] && parseInt(t[3]) || 0;
  return kp(r, a) ? n * (r * $o + a * Oo) : NaN;
}
function gp(e, t, n) {
  var r = new Date(0);
  r.setUTCFullYear(e, 0, 4);
  var a = r.getUTCDay() || 7, o = (t - 1) * 7 + n + 1 - a;
  return r.setUTCDate(r.getUTCDate() + o), r;
}
var wp = [31, null, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31];
function Eu(e) {
  return e % 400 === 0 || e % 4 === 0 && e % 100 !== 0;
}
function _p(e, t, n) {
  return t >= 0 && t <= 11 && n >= 1 && n <= (wp[t] || (Eu(e) ? 29 : 28));
}
function Op(e, t) {
  return t >= 1 && t <= (Eu(e) ? 366 : 365);
}
function $p(e, t, n) {
  return t >= 1 && t <= 53 && n >= 0 && n <= 6;
}
function Pp(e, t, n) {
  return e === 24 ? t === 0 && n === 0 : n >= 0 && n < 60 && t >= 0 && t < 60 && e >= 0 && e < 25;
}
function kp(e, t) {
  return t >= 0 && t <= 59;
}
function qt(e, t) {
  J(2, arguments);
  var n = ae(e), r = re(t), a = n.getFullYear(), o = n.getDate(), i = new Date(0);
  i.setFullYear(a, r, 15), i.setHours(0, 0, 0, 0);
  var c = Es(i);
  return n.setMonth(r, Math.min(o, c)), n;
}
function Hn(e) {
  return typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? Hn = function(n) {
    return typeof n;
  } : Hn = function(n) {
    return n && typeof Symbol == "function" && n.constructor === Symbol && n !== Symbol.prototype ? "symbol" : typeof n;
  }, Hn(e);
}
function je(e, t) {
  if (J(2, arguments), Hn(t) !== "object" || t === null)
    throw new RangeError("values parameter must be an object");
  var n = ae(e);
  return isNaN(n.getTime()) ? new Date(NaN) : (t.year != null && n.setFullYear(t.year), t.month != null && (n = qt(n, t.month)), t.date != null && n.setDate(re(t.date)), t.hours != null && n.setHours(re(t.hours)), t.minutes != null && n.setMinutes(re(t.minutes)), t.seconds != null && n.setSeconds(re(t.seconds)), t.milliseconds != null && n.setMilliseconds(re(t.milliseconds)), n);
}
function Yu(e, t) {
  J(2, arguments);
  var n = ae(e), r = re(t);
  return n.setHours(r), n;
}
function Mo(e, t) {
  J(2, arguments);
  var n = ae(e), r = re(t);
  return n.setMilliseconds(r), n;
}
function Vu(e, t) {
  J(2, arguments);
  var n = ae(e), r = re(t);
  return n.setMinutes(r), n;
}
function Fu(e, t) {
  J(2, arguments);
  var n = ae(e), r = re(t);
  return n.setSeconds(r), n;
}
function Pt(e, t) {
  J(2, arguments);
  var n = ae(e), r = re(t);
  return isNaN(n.getTime()) ? new Date(NaN) : (n.setFullYear(r), n);
}
function Ct(e, t) {
  J(2, arguments);
  var n = re(t);
  return ot(e, -n);
}
function jn(e) {
  return typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? jn = function(n) {
    return typeof n;
  } : jn = function(n) {
    return n && typeof Symbol == "function" && n.constructor === Symbol && n !== Symbol.prototype ? "symbol" : typeof n;
  }, jn(e);
}
function Tp(e, t) {
  if (J(2, arguments), !t || jn(t) !== "object")
    return new Date(NaN);
  var n = t.years ? re(t.years) : 0, r = t.months ? re(t.months) : 0, a = t.weeks ? re(t.weeks) : 0, o = t.days ? re(t.days) : 0, i = t.hours ? re(t.hours) : 0, c = t.minutes ? re(t.minutes) : 0, s = t.seconds ? re(t.seconds) : 0, d = Ct(e, r + n * 12), b = sp(d, o + a * 7), y = c + i * 60, f = s + y * 60, v = f * 1e3, A = new Date(b.getTime() - v);
  return A;
}
function Dp(e, t) {
  J(2, arguments);
  var n = re(t);
  return wu(e, -n);
}
const St = (e, t) => {
  const n = e.__vccOpts || e;
  for (const [r, a] of t)
    n[r] = a;
  return n;
}, Sp = {}, xp = {
  version: "1.1",
  xmlns: "http://www.w3.org/2000/svg",
  width: "32",
  height: "32",
  viewBox: "0 0 32 32",
  class: "dp__icon"
}, Rp = /* @__PURE__ */ ie("path", { d: "M29.333 8c0-2.208-1.792-4-4-4h-18.667c-2.208 0-4 1.792-4 4v18.667c0 2.208 1.792 4 4 4h18.667c2.208 0 4-1.792 4-4v-18.667zM26.667 8v18.667c0 0.736-0.597 1.333-1.333 1.333 0 0-18.667 0-18.667 0-0.736 0-1.333-0.597-1.333-1.333 0 0 0-18.667 0-18.667 0-0.736 0.597-1.333 1.333-1.333 0 0 18.667 0 18.667 0 0.736 0 1.333 0.597 1.333 1.333z" }, null, -1), Mp = /* @__PURE__ */ ie("path", { d: "M20 2.667v5.333c0 0.736 0.597 1.333 1.333 1.333s1.333-0.597 1.333-1.333v-5.333c0-0.736-0.597-1.333-1.333-1.333s-1.333 0.597-1.333 1.333z" }, null, -1), Np = /* @__PURE__ */ ie("path", { d: "M9.333 2.667v5.333c0 0.736 0.597 1.333 1.333 1.333s1.333-0.597 1.333-1.333v-5.333c0-0.736-0.597-1.333-1.333-1.333s-1.333 0.597-1.333 1.333z" }, null, -1), Cp = /* @__PURE__ */ ie("path", { d: "M4 14.667h24c0.736 0 1.333-0.597 1.333-1.333s-0.597-1.333-1.333-1.333h-24c-0.736 0-1.333 0.597-1.333 1.333s0.597 1.333 1.333 1.333z" }, null, -1), Bp = [
  Rp,
  Mp,
  Np,
  Cp
];
function Ap(e, t) {
  return g(), B("svg", xp, Bp);
}
const Ar = /* @__PURE__ */ St(Sp, [["render", Ap]]), Ip = {}, Ep = {
  version: "1.1",
  xmlns: "http://www.w3.org/2000/svg",
  width: "32",
  height: "32",
  viewBox: "0 0 32 32",
  class: "dp__icon"
}, Yp = /* @__PURE__ */ ie("path", { d: "M23.057 7.057l-16 16c-0.52 0.52-0.52 1.365 0 1.885s1.365 0.52 1.885 0l16-16c0.52-0.52 0.52-1.365 0-1.885s-1.365-0.52-1.885 0z" }, null, -1), Vp = /* @__PURE__ */ ie("path", { d: "M7.057 8.943l16 16c0.52 0.52 1.365 0.52 1.885 0s0.52-1.365 0-1.885l-16-16c-0.52-0.52-1.365-0.52-1.885 0s-0.52 1.365 0 1.885z" }, null, -1), Fp = [
  Yp,
  Vp
];
function Up(e, t) {
  return g(), B("svg", Ep, Fp);
}
const Lp = /* @__PURE__ */ St(Ip, [["render", Up]]), Wp = {}, zp = {
  version: "1.1",
  xmlns: "http://www.w3.org/2000/svg",
  width: "32",
  height: "32",
  viewBox: "0 0 32 32",
  class: "dp__icon"
}, Hp = /* @__PURE__ */ ie("path", { d: "M20.943 23.057l-7.057-7.057c0 0 7.057-7.057 7.057-7.057 0.52-0.52 0.52-1.365 0-1.885s-1.365-0.52-1.885 0l-8 8c-0.521 0.521-0.521 1.365 0 1.885l8 8c0.52 0.52 1.365 0.52 1.885 0s0.52-1.365 0-1.885z" }, null, -1), jp = [
  Hp
];
function qp(e, t) {
  return g(), B("svg", zp, jp);
}
const Ki = /* @__PURE__ */ St(Wp, [["render", qp]]), Gp = {}, Qp = {
  version: "1.1",
  xmlns: "http://www.w3.org/2000/svg",
  width: "32",
  height: "32",
  viewBox: "0 0 32 32",
  class: "dp__icon"
}, Xp = /* @__PURE__ */ ie("path", { d: "M12.943 24.943l8-8c0.521-0.521 0.521-1.365 0-1.885l-8-8c-0.52-0.52-1.365-0.52-1.885 0s-0.52 1.365 0 1.885l7.057 7.057c0 0-7.057 7.057-7.057 7.057-0.52 0.52-0.52 1.365 0 1.885s1.365 0.52 1.885 0z" }, null, -1), Kp = [
  Xp
];
function Jp(e, t) {
  return g(), B("svg", Qp, Kp);
}
const Ji = /* @__PURE__ */ St(Gp, [["render", Jp]]), Zp = {}, em = {
  version: "1.1",
  xmlns: "http://www.w3.org/2000/svg",
  width: "32",
  height: "32",
  viewBox: "0 0 32 32",
  class: "dp__icon"
}, tm = /* @__PURE__ */ ie("path", { d: "M16 1.333c-8.095 0-14.667 6.572-14.667 14.667s6.572 14.667 14.667 14.667c8.095 0 14.667-6.572 14.667-14.667s-6.572-14.667-14.667-14.667zM16 4c6.623 0 12 5.377 12 12s-5.377 12-12 12c-6.623 0-12-5.377-12-12s5.377-12 12-12z" }, null, -1), nm = /* @__PURE__ */ ie("path", { d: "M14.667 8v8c0 0.505 0.285 0.967 0.737 1.193l5.333 2.667c0.658 0.329 1.46 0.062 1.789-0.596s0.062-1.46-0.596-1.789l-4.596-2.298c0 0 0-7.176 0-7.176 0-0.736-0.597-1.333-1.333-1.333s-1.333 0.597-1.333 1.333z" }, null, -1), rm = [
  tm,
  nm
];
function am(e, t) {
  return g(), B("svg", em, rm);
}
const Uu = /* @__PURE__ */ St(Zp, [["render", am]]), om = {}, im = {
  version: "1.1",
  xmlns: "http://www.w3.org/2000/svg",
  width: "32",
  height: "32",
  viewBox: "0 0 32 32",
  class: "dp__icon"
}, um = /* @__PURE__ */ ie("path", { d: "M24.943 19.057l-8-8c-0.521-0.521-1.365-0.521-1.885 0l-8 8c-0.52 0.52-0.52 1.365 0 1.885s1.365 0.52 1.885 0l7.057-7.057c0 0 7.057 7.057 7.057 7.057 0.52 0.52 1.365 0.52 1.885 0s0.52-1.365 0-1.885z" }, null, -1), lm = [
  um
];
function sm(e, t) {
  return g(), B("svg", im, lm);
}
const Lu = /* @__PURE__ */ St(om, [["render", sm]]), cm = {}, fm = {
  version: "1.1",
  xmlns: "http://www.w3.org/2000/svg",
  width: "32",
  height: "32",
  viewBox: "0 0 32 32",
  class: "dp__icon"
}, dm = /* @__PURE__ */ ie("path", { d: "M7.057 12.943l8 8c0.521 0.521 1.365 0.521 1.885 0l8-8c0.52-0.52 0.52-1.365 0-1.885s-1.365-0.52-1.885 0l-7.057 7.057c0 0-7.057-7.057-7.057-7.057-0.52-0.52-1.365-0.52-1.885 0s-0.52 1.365 0 1.885z" }, null, -1), ym = [
  dm
];
function pm(e, t) {
  return g(), B("svg", fm, ym);
}
const Wu = /* @__PURE__ */ St(cm, [["render", pm]]), Zi = (e, t) => {
  const n = vo(e, t.slice(0, e.length), new Date());
  return Ht(n) && _u(n) ? n : null;
}, mm = (e, t) => {
  if (typeof t == "string")
    return Zi(e, t);
  if (Array.isArray(t)) {
    let n = null;
    for (const r of t)
      if (n = Zi(e, r), n)
        break;
    return n;
  }
  return typeof t == "function" ? t(e) : null;
}, R = (e) => e ? new Date(e) : new Date(), vm = (e, t) => {
  if (t) {
    const r = (e.getMonth() + 1).toString().padStart(2, "0"), a = e.getDate().toString().padStart(2, "0"), o = e.getHours().toString().padStart(2, "0"), i = e.getMinutes().toString().padStart(2, "0");
    return `${e.getFullYear()}-${r}-${a}T${o}:${i}:00.000Z`;
  }
  const n = Date.UTC(
    e.getUTCFullYear(),
    e.getUTCMonth(),
    e.getUTCDate(),
    e.getUTCHours(),
    e.getUTCMinutes(),
    e.getUTCSeconds()
  );
  return new Date(n).toISOString();
}, it = (e) => {
  let t = R(JSON.parse(JSON.stringify(e)));
  return t = Yu(t, 0), t = Vu(t, 0), t = Fu(t, 0), t = Mo(t, 0), t;
}, et = (e, t, n, r) => {
  let a = e ? R(e) : R();
  return (t || t === 0) && (a = Yu(a, +t)), (n || n === 0) && (a = Vu(a, +n)), (r || r === 0) && (a = Fu(a, +r)), Mo(a, 0);
}, We = (e, t) => !e || !t ? !1 : To(it(e), it(t)), Te = (e, t) => !e || !t ? !1 : Ru(it(e), it(t)), Ge = (e, t) => !e || !t ? !1 : ko(it(e), it(t)), zu = (e, t, n) => e && e[0] && e[1] ? Ge(n, e[0]) && We(n, e[1]) : e && e[0] && t ? Ge(n, e[0]) && We(n, t) || We(n, e[0]) && Ge(n, t) : !1, zt = Qt({
  menuFocused: !1,
  shiftKeyInMenu: !1
}), Hu = () => {
  const e = (n) => {
    zt.menuFocused = n;
  }, t = (n) => {
    zt.shiftKeyInMenu !== n && (zt.shiftKeyInMenu = n);
  };
  return {
    control: F(() => ({ shiftKeyInMenu: zt.shiftKeyInMenu, menuFocused: zt.menuFocused })),
    setMenuFocused: e,
    setShiftKey: t
  };
};
function No(e) {
  return e && e.__esModule && Object.prototype.hasOwnProperty.call(e, "default") ? e.default : e;
}
var Rr = {}, hm = {
  get exports() {
    return Rr;
  },
  set exports(e) {
    Rr = e;
  }
};
(function(e, t) {
  Object.defineProperty(t, "__esModule", {
    value: !0
  }), t.default = n;
  function n(r) {
    if (r === null || r === !0 || r === !1)
      return NaN;
    var a = Number(r);
    return isNaN(a) ? a : a < 0 ? Math.ceil(a) : Math.floor(a);
  }
  e.exports = t.default;
})(hm, Rr);
const bm = /* @__PURE__ */ No(Rr);
var Mr = {}, gm = {
  get exports() {
    return Mr;
  },
  set exports(e) {
    Mr = e;
  }
};
(function(e, t) {
  Object.defineProperty(t, "__esModule", {
    value: !0
  }), t.default = n;
  function n(r) {
    var a = new Date(Date.UTC(r.getFullYear(), r.getMonth(), r.getDate(), r.getHours(), r.getMinutes(), r.getSeconds(), r.getMilliseconds()));
    return a.setUTCFullYear(r.getFullYear()), r.getTime() - a.getTime();
  }
  e.exports = t.default;
})(gm, Mr);
const eu = /* @__PURE__ */ No(Mr);
function wm(e, t) {
  var n = Pm(t);
  return n.formatToParts ? Om(n, e) : $m(n, e);
}
var _m = {
  year: 0,
  month: 1,
  day: 2,
  hour: 3,
  minute: 4,
  second: 5
};
function Om(e, t) {
  try {
    for (var n = e.formatToParts(t), r = [], a = 0; a < n.length; a++) {
      var o = _m[n[a].type];
      o >= 0 && (r[o] = parseInt(n[a].value, 10));
    }
    return r;
  } catch (i) {
    if (i instanceof RangeError)
      return [NaN];
    throw i;
  }
}
function $m(e, t) {
  var n = e.format(t).replace(/\u200E/g, ""), r = /(\d+)\/(\d+)\/(\d+),? (\d+):(\d+):(\d+)/.exec(n);
  return [r[3], r[1], r[2], r[4], r[5], r[6]];
}
var qr = {};
function Pm(e) {
  if (!qr[e]) {
    var t = new Intl.DateTimeFormat("en-US", {
      hour12: !1,
      timeZone: "America/New_York",
      year: "numeric",
      month: "numeric",
      day: "2-digit",
      hour: "2-digit",
      minute: "2-digit",
      second: "2-digit"
    }).format(new Date("2014-06-25T04:00:00.123Z")), n = t === "06/25/2014, 00:00:00" || t === "‎06‎/‎25‎/‎2014‎ ‎00‎:‎00‎:‎00";
    qr[e] = n ? new Intl.DateTimeFormat("en-US", {
      hour12: !1,
      timeZone: e,
      year: "numeric",
      month: "numeric",
      day: "2-digit",
      hour: "2-digit",
      minute: "2-digit",
      second: "2-digit"
    }) : new Intl.DateTimeFormat("en-US", {
      hourCycle: "h23",
      timeZone: e,
      year: "numeric",
      month: "numeric",
      day: "2-digit",
      hour: "2-digit",
      minute: "2-digit",
      second: "2-digit"
    });
  }
  return qr[e];
}
function Co(e, t, n, r, a, o, i) {
  var c = new Date(0);
  return c.setUTCFullYear(e, t, n), c.setUTCHours(r, a, o, i), c;
}
var tu = 36e5, km = 6e4, Gr = {
  timezone: /([Z+-].*)$/,
  timezoneZ: /^(Z)$/,
  timezoneHH: /^([+-]\d{2})$/,
  timezoneHHMM: /^([+-]\d{2}):?(\d{2})$/
};
function Bo(e, t, n) {
  var r, a;
  if (e === "" || (r = Gr.timezoneZ.exec(e), r))
    return 0;
  var o;
  if (r = Gr.timezoneHH.exec(e), r)
    return o = parseInt(r[1], 10), nu(o) ? -(o * tu) : NaN;
  if (r = Gr.timezoneHHMM.exec(e), r) {
    o = parseInt(r[1], 10);
    var i = parseInt(r[2], 10);
    return nu(o, i) ? (a = Math.abs(o) * tu + i * km, o > 0 ? -a : a) : NaN;
  }
  if (Sm(e)) {
    t = new Date(t || Date.now());
    var c = n ? t : Tm(t), s = ho(c, e), d = n ? s : Dm(t, s, e);
    return -d;
  }
  return NaN;
}
function Tm(e) {
  return Co(
    e.getFullYear(),
    e.getMonth(),
    e.getDate(),
    e.getHours(),
    e.getMinutes(),
    e.getSeconds(),
    e.getMilliseconds()
  );
}
function ho(e, t) {
  var n = wm(e, t), r = Co(
    n[0],
    n[1] - 1,
    n[2],
    n[3] % 24,
    n[4],
    n[5],
    0
  ).getTime(), a = e.getTime(), o = a % 1e3;
  return a -= o >= 0 ? o : 1e3 + o, r - a;
}
function Dm(e, t, n) {
  var r = e.getTime(), a = r - t, o = ho(new Date(a), n);
  if (t === o)
    return t;
  a -= o - t;
  var i = ho(new Date(a), n);
  return o === i ? o : Math.max(o, i);
}
function nu(e, t) {
  return -23 <= e && e <= 23 && (t == null || 0 <= t && t <= 59);
}
var ru = {};
function Sm(e) {
  if (ru[e])
    return !0;
  try {
    return new Intl.DateTimeFormat(void 0, { timeZone: e }), ru[e] = !0, !0;
  } catch {
    return !1;
  }
}
var ju = /(Z|[+-]\d{2}(?::?\d{2})?| UTC| [a-zA-Z]+\/[a-zA-Z_]+(?:\/[a-zA-Z_]+)?)$/, Qr = 36e5, au = 6e4, xm = 2, qe = {
  dateTimePattern: /^([0-9W+-]+)(T| )(.*)/,
  datePattern: /^([0-9W+-]+)(.*)/,
  plainTime: /:/,
  YY: /^(\d{2})$/,
  YYY: [
    /^([+-]\d{2})$/,
    /^([+-]\d{3})$/,
    /^([+-]\d{4})$/
  ],
  YYYY: /^(\d{4})/,
  YYYYY: [
    /^([+-]\d{4})/,
    /^([+-]\d{5})/,
    /^([+-]\d{6})/
  ],
  MM: /^-(\d{2})$/,
  DDD: /^-?(\d{3})$/,
  MMDD: /^-?(\d{2})-?(\d{2})$/,
  Www: /^-?W(\d{2})$/,
  WwwD: /^-?W(\d{2})-?(\d{1})$/,
  HH: /^(\d{2}([.,]\d*)?)$/,
  HHMM: /^(\d{2}):?(\d{2}([.,]\d*)?)$/,
  HHMMSS: /^(\d{2}):?(\d{2}):?(\d{2}([.,]\d*)?)$/,
  timeZone: ju
};
function bo(e, t) {
  if (arguments.length < 1)
    throw new TypeError("1 argument required, but only " + arguments.length + " present");
  if (e === null)
    return new Date(NaN);
  var n = t || {}, r = n.additionalDigits == null ? xm : bm(n.additionalDigits);
  if (r !== 2 && r !== 1 && r !== 0)
    throw new RangeError("additionalDigits must be 0, 1 or 2");
  if (e instanceof Date || typeof e == "object" && Object.prototype.toString.call(e) === "[object Date]")
    return new Date(e.getTime());
  if (typeof e == "number" || Object.prototype.toString.call(e) === "[object Number]")
    return new Date(e);
  if (!(typeof e == "string" || Object.prototype.toString.call(e) === "[object String]"))
    return new Date(NaN);
  var a = Rm(e), o = Mm(a.date, r), i = o.year, c = o.restDateString, s = Nm(c, i);
  if (isNaN(s))
    return new Date(NaN);
  if (s) {
    var d = s.getTime(), b = 0, y;
    if (a.time && (b = Cm(a.time), isNaN(b)))
      return new Date(NaN);
    if (a.timeZone || n.timeZone) {
      if (y = Bo(a.timeZone || n.timeZone, new Date(d + b)), isNaN(y))
        return new Date(NaN);
    } else
      y = eu(new Date(d + b)), y = eu(new Date(d + b + y));
    return new Date(d + b + y);
  } else
    return new Date(NaN);
}
function Rm(e) {
  var t = {}, n = qe.dateTimePattern.exec(e), r;
  if (n ? (t.date = n[1], r = n[3]) : (n = qe.datePattern.exec(e), n ? (t.date = n[1], r = n[2]) : (t.date = null, r = e)), r) {
    var a = qe.timeZone.exec(r);
    a ? (t.time = r.replace(a[1], ""), t.timeZone = a[1].trim()) : t.time = r;
  }
  return t;
}
function Mm(e, t) {
  var n = qe.YYY[t], r = qe.YYYYY[t], a;
  if (a = qe.YYYY.exec(e) || r.exec(e), a) {
    var o = a[1];
    return {
      year: parseInt(o, 10),
      restDateString: e.slice(o.length)
    };
  }
  if (a = qe.YY.exec(e) || n.exec(e), a) {
    var i = a[1];
    return {
      year: parseInt(i, 10) * 100,
      restDateString: e.slice(i.length)
    };
  }
  return {
    year: null
  };
}
function Nm(e, t) {
  if (t === null)
    return null;
  var n, r, a, o;
  if (e.length === 0)
    return r = new Date(0), r.setUTCFullYear(t), r;
  if (n = qe.MM.exec(e), n)
    return r = new Date(0), a = parseInt(n[1], 10) - 1, iu(t, a) ? (r.setUTCFullYear(t, a), r) : new Date(NaN);
  if (n = qe.DDD.exec(e), n) {
    r = new Date(0);
    var i = parseInt(n[1], 10);
    return Im(t, i) ? (r.setUTCFullYear(t, 0, i), r) : new Date(NaN);
  }
  if (n = qe.MMDD.exec(e), n) {
    r = new Date(0), a = parseInt(n[1], 10) - 1;
    var c = parseInt(n[2], 10);
    return iu(t, a, c) ? (r.setUTCFullYear(t, a, c), r) : new Date(NaN);
  }
  if (n = qe.Www.exec(e), n)
    return o = parseInt(n[1], 10) - 1, uu(t, o) ? ou(t, o) : new Date(NaN);
  if (n = qe.WwwD.exec(e), n) {
    o = parseInt(n[1], 10) - 1;
    var s = parseInt(n[2], 10) - 1;
    return uu(t, o, s) ? ou(t, o, s) : new Date(NaN);
  }
  return null;
}
function Cm(e) {
  var t, n, r;
  if (t = qe.HH.exec(e), t)
    return n = parseFloat(t[1].replace(",", ".")), Xr(n) ? n % 24 * Qr : NaN;
  if (t = qe.HHMM.exec(e), t)
    return n = parseInt(t[1], 10), r = parseFloat(t[2].replace(",", ".")), Xr(n, r) ? n % 24 * Qr + r * au : NaN;
  if (t = qe.HHMMSS.exec(e), t) {
    n = parseInt(t[1], 10), r = parseInt(t[2], 10);
    var a = parseFloat(t[3].replace(",", "."));
    return Xr(n, r, a) ? n % 24 * Qr + r * au + a * 1e3 : NaN;
  }
  return null;
}
function ou(e, t, n) {
  t = t || 0, n = n || 0;
  var r = new Date(0);
  r.setUTCFullYear(e, 0, 4);
  var a = r.getUTCDay() || 7, o = t * 7 + n + 1 - a;
  return r.setUTCDate(r.getUTCDate() + o), r;
}
var Bm = [31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31], Am = [31, 29, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31];
function qu(e) {
  return e % 400 === 0 || e % 4 === 0 && e % 100 !== 0;
}
function iu(e, t, n) {
  if (t < 0 || t > 11)
    return !1;
  if (n != null) {
    if (n < 1)
      return !1;
    var r = qu(e);
    if (r && n > Am[t] || !r && n > Bm[t])
      return !1;
  }
  return !0;
}
function Im(e, t) {
  if (t < 1)
    return !1;
  var n = qu(e);
  return !(n && t > 366 || !n && t > 365);
}
function uu(e, t, n) {
  return !(t < 0 || t > 52 || n != null && (n < 0 || n > 6));
}
function Xr(e, t, n) {
  return !(e != null && (e < 0 || e >= 25) || t != null && (t < 0 || t >= 60) || n != null && (n < 0 || n >= 60));
}
var Nr = {}, Em = {
  get exports() {
    return Nr;
  },
  set exports(e) {
    Nr = e;
  }
}, Cr = {}, Ym = {
  get exports() {
    return Cr;
  },
  set exports(e) {
    Cr = e;
  }
};
(function(e, t) {
  Object.defineProperty(t, "__esModule", {
    value: !0
  }), t.default = n;
  function n(r, a) {
    if (r == null)
      throw new TypeError("assign requires that input parameter not be null or undefined");
    for (var o in a)
      Object.prototype.hasOwnProperty.call(a, o) && (r[o] = a[o]);
    return r;
  }
  e.exports = t.default;
})(Ym, Cr);
(function(e, t) {
  Object.defineProperty(t, "__esModule", {
    value: !0
  }), t.default = a;
  var n = r(Cr);
  function r(o) {
    return o && o.__esModule ? o : { default: o };
  }
  function a(o) {
    return (0, n.default)({}, o);
  }
  e.exports = t.default;
})(Em, Nr);
const Vm = /* @__PURE__ */ No(Nr);
function Fm(e, t, n) {
  var r = bo(e, n), a = Bo(t, r, !0), o = new Date(r.getTime() - a), i = new Date(0);
  return i.setFullYear(o.getUTCFullYear(), o.getUTCMonth(), o.getUTCDate()), i.setHours(o.getUTCHours(), o.getUTCMinutes(), o.getUTCSeconds(), o.getUTCMilliseconds()), i;
}
function Um(e, t, n) {
  if (typeof e == "string" && !e.match(ju)) {
    var r = Vm(n);
    return r.timeZone = t, bo(e, r);
  }
  var a = bo(e, n), o = Co(
    a.getFullYear(),
    a.getMonth(),
    a.getDate(),
    a.getHours(),
    a.getMinutes(),
    a.getSeconds(),
    a.getMilliseconds()
  ).getTime(), i = Bo(t, new Date(o));
  return new Date(o + i);
}
const Lm = (e, t = 3) => {
  const n = [];
  for (let r = 0; r < e.length; r += t)
    n.push([e[r], e[r + 1], e[r + 2]]);
  return n;
}, Wm = (e, t) => {
  const n = [1, 2, 3, 4, 5, 6, 7].map((o) => new Intl.DateTimeFormat(e, { weekday: "short", timeZone: "UTC" }).format(new Date(`2017-01-0${o}T00:00:00+00:00`)).slice(0, 2)), r = n.slice(0, t), a = n.slice(t + 1, n.length);
  return [n[t]].concat(...a).concat(...r);
}, zm = (e) => {
  const t = [];
  for (let n = +e[0]; n <= +e[1]; n++)
    t.push({ value: +n, text: `${n}` });
  return t;
}, Hm = (e, t) => {
  const n = new Intl.DateTimeFormat(e, { month: t, timeZone: "UTC" });
  return [1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12].map((r) => {
    const a = r < 10 ? `0${r}` : r;
    return new Date(`2017-${a}-01T00:00:00+00:00`);
  }).map((r, a) => ({
    text: n.format(r),
    value: a
  }));
}, jm = (e) => [12, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11][e], Ve = (e) => {
  const t = l(e);
  return (t == null ? void 0 : t.$el) ?? t;
}, qm = (e) => Object.assign({ type: "dot" }, e), Gu = (e) => Array.isArray(e) ? !!e[0] && !!e[1] : !1, Br = {
  prop: (e) => `"${e}" prop must be enabled!`,
  dateArr: (e) => `You need to use array as "model-value" binding in order to support "${e}"`
}, Ue = (e) => e, lu = (e) => e === 0 ? e : !e || isNaN(+e) ? null : +e, su = (e) => Object.assign(
  {
    menuAppear: "dp-menu-appear",
    open: "dp-slide-down",
    close: "dp-slide-up",
    next: "calendar-next",
    previous: "calendar-prev",
    vNext: "dp-slide-up",
    vPrevious: "dp-slide-down"
  },
  e
), Gm = (e) => Object.assign(
  {
    toggleOverlay: "Toggle overlay",
    menu: "Datepicker menu",
    input: "Datepicker input",
    calendarWrap: "Calendar wrapper",
    calendarDays: "Calendar days",
    openTimePicker: "Open time picker",
    closeTimePicker: "Close time Picker",
    incrementValue: (t) => `Increment ${t}`,
    decrementValue: (t) => `Decrement ${t}`,
    openTpOverlay: (t) => `Open ${t} overlay`,
    amPmButton: "Switch AM/PM mode",
    openYearsOverlay: "Open years overlay",
    openMonthsOverlay: "Open months overlay",
    nextMonth: "Next month",
    prevMonth: "Previous month",
    day: () => ""
  },
  e
), Qm = (e) => e === null ? 0 : typeof e == "boolean" ? e ? 2 : 0 : +e >= 2 ? +e : 2, Xm = (e, t, n) => e || (typeof n == "string" ? n : t), Km = (e) => typeof e == "boolean" ? e ? su({}) : !1 : su(e), Jm = () => ({
  enterSubmit: !0,
  tabSubmit: !0,
  openMenu: !0,
  rangeSeparator: " - "
}), Zm = (e) => Object.assign({ months: [], years: [], times: { hours: [], minutes: [], seconds: [] } }, e), Ze = (e) => {
  const t = () => {
    if (e.partialRange)
      return null;
    throw new Error(Br.prop("partial-range"));
  }, n = F(() => ({
    ariaLabels: Gm(e.ariaLabels),
    textInputOptions: Object.assign(Jm(), e.textInputOptions),
    multiCalendars: Qm(e.multiCalendars),
    previewFormat: Xm(e.previewFormat, e.format, o()),
    filters: Zm(e.filters),
    transitions: Km(e.transitions),
    startTime: f()
  })), r = (u) => {
    if (e.range)
      return u();
    throw new Error(Br.prop("range"));
  }, a = () => {
    const u = e.enableSeconds ? ":ss" : "";
    return e.is24 ? `HH:mm${u}` : `hh:mm${u} aa`;
  }, o = () => e.format ? e.format : e.monthPicker ? "MM/yyyy" : e.timePicker ? a() : e.weekPicker ? "MM/dd/yyyy" : e.yearPicker ? "yyyy" : e.enableTimePicker ? `MM/dd/yyyy, ${a()}` : "MM/dd/yyyy", i = (u, w) => {
    if (typeof e.format == "function")
      return e.format(u);
    const S = w || o(), I = e.formatLocale ? { locale: e.formatLocale } : void 0;
    return Array.isArray(u) ? `${jt(u[0], S, I)} ${e.modelAuto && !u[1] ? "" : n.value.textInputOptions.rangeSeparator || "-"} ${u[1] ? jt(u[1], S, I) : ""}` : jt(u, S, I);
  }, c = (u) => e.timezone ? Fm(u, e.timezone) : u, s = (u) => e.timezone ? Um(u, e.timezone) : u, d = F(() => (u) => {
    var w;
    return (w = e.hideNavigation) == null ? void 0 : w.includes(u);
  }), b = (u) => {
    const w = e.maxDate ? Ge(c(u), c(R(e.maxDate))) : !1, S = e.minDate ? We(c(u), c(R(e.minDate))) : !1, I = ee(u, e.disabledDates), U = n.value.filters.months.map((E) => +E).includes(Pe(u)), _ = e.disabledWeekDays.length ? e.disabledWeekDays.some((E) => +E === Is(u)) : !1, le = e.allowedDates.length ? !e.allowedDates.some((E) => Te(c(R(E)), c(u))) : !1, de = ke(u), h = de < +e.yearRange[0] || de > +e.yearRange[1];
    return !(w || S || I || U || h || _ || le);
  }, y = (u) => {
    const w = {
      hours: lt(R()),
      minutes: st(R()),
      seconds: At(R())
    };
    return Object.assign(w, u);
  }, f = () => e.range ? e.startTime && Array.isArray(e.startTime) ? [y(e.startTime[0]), y(e.startTime[1])] : null : e.startTime && !Array.isArray(e.startTime) ? y(e.startTime) : null, v = (u) => !b(u), A = (u) => Array.isArray(u) ? Ht(u[0]) && (u[1] ? Ht(u[1]) : !0) : u ? Ht(u) : !1, V = (u) => u instanceof Date ? u : cp(u), q = (u) => {
    const w = aa(c(u), { weekStartsOn: +e.weekStart }), S = Ml(c(u), { weekStartsOn: +e.weekStart });
    return [w, S];
  }, ee = (u, w) => Array.isArray(w) ? w.some((S) => Te(c(R(S)), c(u))) : w(u), G = (u, w, S) => {
    let I = u ? R(u) : R();
    return (w || w === 0) && (I = qt(I, w)), S && (I = Pt(I, S)), I;
  }, C = (u) => je(R(), { hours: lt(u), minutes: st(u), seconds: At(u) }), z = (u) => je(R(), {
    hours: +u.hours || 0,
    minutes: +u.minutes || 0,
    seconds: +u.seconds || 0
  }), te = (u, w, S, I) => {
    if (!u)
      return !0;
    if (I) {
      const U = S === "max" ? To(u, w) : ko(u, w), _ = { seconds: 0, milliseconds: 0 };
      return U || Ru(je(u, _), je(w, _));
    }
    return S === "max" ? u.getTime() <= w.getTime() : u.getTime() >= w.getTime();
  }, P = () => !e.enableTimePicker || e.monthPicker || e.yearPicker || e.ignoreTimeValidation, $ = (u) => Array.isArray(u) ? [u[0] ? C(u[0]) : null, u[1] ? C(u[1]) : null] : C(u), M = (u) => {
    const w = e.maxTime ? z(e.maxTime) : R(e.maxDate);
    return Array.isArray(u) ? te(u[0], w, "max", !!e.maxDate) && te(u[1], w, "max", !!e.maxDate) : te(u, w, "max", !!e.maxDate);
  }, L = (u, w) => {
    const S = e.minTime ? z(e.minTime) : R(e.minDate);
    return Array.isArray(u) ? te(u[0], S, "min", !!e.minDate) && te(u[1], S, "min", !!e.minDate) && w : te(u, S, "min", !!e.minDate) && w;
  }, j = (u) => {
    let w = !0;
    if (!u || P())
      return !0;
    const S = !e.minDate && !e.maxDate ? $(u) : u;
    return (e.maxTime || e.maxDate) && (w = M(Ue(S))), (e.minTime || e.minDate) && (w = L(Ue(S), w)), w;
  }, Y = (u, w) => {
    const S = R(JSON.parse(JSON.stringify(u))), I = [];
    for (let U = 0; U < 7; U++) {
      const _ = yt(S, U), le = Pe(_) !== w;
      I.push({
        text: e.hideOffsetDates && le ? "" : _.getDate(),
        value: _,
        current: !le,
        classData: {}
      });
    }
    return I;
  }, X = (u, w) => {
    const S = [], I = R(c(new Date(w, u))), U = R(c(new Date(w, u + 1, 0))), _ = aa(I, { weekStartsOn: e.weekStart }), le = (de) => {
      const h = Y(de, u);
      if (S.push({ days: h }), !S[S.length - 1].days.some(
        (E) => Te(it(E.value), it(U))
      )) {
        const E = yt(de, 7);
        le(E);
      }
    };
    if (le(_), e.sixWeeks && S.length < 6) {
      const de = 6 - S.length;
      for (let h = 1; h <= de; h++) {
        const E = S[S.length - 1], Me = E.days[E.days.length - 1], me = Y(yt(Me.value, 1), Pe(I));
        S.push({ days: me });
      }
    }
    return S;
  }, O = (u, w, S) => [je(R(u), { date: 1 }), je(R(), { month: w, year: S, date: 1 })], m = (u, w) => We(...O(e.minDate, u, w)) || Te(...O(e.minDate, u, w)), k = (u, w) => Ge(...O(e.maxDate, u, w)) || Te(...O(e.maxDate, u, w)), D = (u, w, S) => {
    let I = !1;
    return e.maxDate && S && k(u, w) && (I = !0), e.minDate && !S && m(u, w) && (I = !0), I;
  };
  return {
    checkPartialRangeValue: t,
    checkRangeEnabled: r,
    getZonedDate: c,
    getZonedToUtc: s,
    formatDate: i,
    getDefaultPattern: o,
    validateDate: b,
    getDefaultStartTime: f,
    isDisabled: v,
    isValidDate: A,
    sanitizeDate: V,
    getWeekFromDate: q,
    matchDate: ee,
    setDateMonthOrYear: G,
    isValidTime: j,
    getCalendarDays: X,
    validateMonthYearInRange: (u, w, S, I) => {
      let U = !1;
      return I ? e.minDate && e.maxDate ? U = D(u, w, S) : (e.minDate && m(u, w) || e.maxDate && k(u, w)) && (U = !0) : U = !0, U;
    },
    validateMaxDate: k,
    validateMinDate: m,
    defaults: n,
    hideNavigationButtons: d
  };
}, Oe = Qt({
  monthYear: [],
  calendar: [],
  time: [],
  actionRow: [],
  selectionGrid: [],
  timePicker: {
    0: [],
    1: []
  },
  monthPicker: []
}), Kr = H(null), nn = H(!1), Jr = H(!1), Zr = H(!1), ea = H(!1), He = H(0), Ee = H(0), ht = () => {
  const e = F(() => nn.value ? [...Oe.selectionGrid, Oe.actionRow].filter((y) => y.length) : Jr.value ? [
    ...Oe.timePicker[0],
    ...Oe.timePicker[1],
    ea.value ? [] : [Kr.value],
    Oe.actionRow
  ].filter((y) => y.length) : Zr.value ? [...Oe.monthPicker, Oe.actionRow] : [Oe.monthYear, ...Oe.calendar, Oe.time, Oe.actionRow].filter((y) => y.length)), t = (y) => {
    He.value = y ? He.value + 1 : He.value - 1;
    let f = null;
    e.value[Ee.value] && (f = e.value[Ee.value][He.value]), f || (He.value = y ? He.value - 1 : He.value + 1);
  }, n = (y) => {
    Ee.value === 0 && !y || Ee.value === e.value.length && y || (Ee.value = y ? Ee.value + 1 : Ee.value - 1, e.value[Ee.value] ? e.value[Ee.value] && !e.value[Ee.value][He.value] && He.value !== 0 && (He.value = e.value[Ee.value].length - 1) : Ee.value = y ? Ee.value - 1 : Ee.value + 1);
  }, r = (y) => {
    let f = null;
    e.value[Ee.value] && (f = e.value[Ee.value][He.value]), f ? f.focus({ preventScroll: !nn.value }) : He.value = y ? He.value - 1 : He.value + 1;
  }, a = () => {
    t(!0), r(!0);
  }, o = () => {
    t(!1), r(!1);
  }, i = () => {
    n(!1), r(!0);
  }, c = () => {
    n(!0), r(!0);
  }, s = (y, f) => {
    Oe[f] = y;
  }, d = (y, f) => {
    Oe[f] = y;
  }, b = () => {
    He.value = 0, Ee.value = 0;
  };
  return {
    buildMatrix: s,
    buildMultiLevelMatrix: d,
    setTimePickerBackRef: (y) => {
      Kr.value = y;
    },
    setSelectionGrid: (y) => {
      nn.value = y, b(), y || (Oe.selectionGrid = []);
    },
    setTimePicker: (y, f = !1) => {
      Jr.value = y, ea.value = f, b(), y || (Oe.timePicker[0] = [], Oe.timePicker[1] = []);
    },
    setTimePickerElements: (y, f = 0) => {
      Oe.timePicker[f] = y;
    },
    arrowRight: a,
    arrowLeft: o,
    arrowUp: i,
    arrowDown: c,
    clearArrowNav: () => {
      Oe.monthYear = [], Oe.calendar = [], Oe.time = [], Oe.actionRow = [], Oe.selectionGrid = [], Oe.timePicker[0] = [], Oe.timePicker[1] = [], nn.value = !1, Jr.value = !1, ea.value = !1, Zr.value = !1, b(), Kr.value = null;
    },
    setMonthPicker: (y) => {
      Zr.value = y, b();
    },
    refSets: Oe
  };
}, cu = (e) => Array.isArray(e), _t = (e) => Array.isArray(e), fu = (e) => Array.isArray(e) && e.length === 2, ev = (e, t, n, r, a) => {
  const {
    getDefaultStartTime: o,
    isDisabled: i,
    sanitizeDate: c,
    getWeekFromDate: s,
    setDateMonthOrYear: d,
    validateMonthYearInRange: b,
    defaults: y
  } = Ze(e), f = F({
    get: () => e.internalModelValue,
    set: (p) => {
      !e.readonly && !e.disabled && t("update:internal-model-value", p);
    }
  }), v = H([]), A = H([{ month: Pe(R()), year: ke(R()) }]), V = Qt({
    hours: e.range ? [lt(R()), lt(R())] : lt(R()),
    minutes: e.range ? [st(R()), st(R())] : st(R()),
    seconds: e.range ? [0, 0] : 0
  }), q = F(
    () => (p) => A.value[p] ? A.value[p].month : 0
  ), ee = F(
    () => (p) => A.value[p] ? A.value[p].year : 0
  ), G = F(() => e.flow ? a.value === e.flow.length : !0), C = (p, N, Z) => {
    A.value[p].month = N === null ? A.value[p].month : N, A.value[p].year = Z === null ? A.value[p].year : Z;
  }, z = (p, N) => {
    V[p] = N;
  };
  tt(() => {
    f.value || (e.startDate && (C(0, Pe(R(e.startDate)), ke(R(e.startDate))), y.value.multiCalendars && Yt(0)), y.value.startTime && k()), te(!0);
  });
  const te = (p = !1) => {
    if (f.value)
      return Array.isArray(f.value) ? j(p) : $(f.value);
    if (e.timePicker)
      return Y();
    if (e.monthPicker && !e.range)
      return X();
    if (e.yearPicker && !e.range)
      return O();
    if (y.value.multiCalendars)
      return P(R(), p);
  }, P = (p, N = !1) => {
    if ((!y.value.multiCalendars || !e.multiStatic || N) && C(0, Pe(p), ke(p)), y.value.multiCalendars)
      for (let Z = 1; Z < y.value.multiCalendars; Z++) {
        const ce = je(R(), { month: q.value(Z - 1), year: ee.value(Z - 1) }), Se = gu(ce, { months: 1 });
        A.value[Z] = { month: Pe(Se), year: ke(Se) };
      }
  }, $ = (p) => {
    P(p), z("hours", lt(p)), z("minutes", st(p)), z("seconds", At(p));
  }, M = (p, N) => {
    P(p[0], N);
    const Z = (ce, Se) => [
      ce(p[0]),
      p[1] ? ce(p[1]) : V[Se][1]
    ];
    z("hours", Z(lt, "hours")), z("minutes", Z(st, "minutes")), z("seconds", Z(At, "seconds"));
  }, L = (p, N) => {
    if (e.range && !e.multiDates)
      return M(p, N);
    if (e.multiDates) {
      const Z = p[p.length - 1];
      return $(Z);
    }
  }, j = (p) => {
    const N = f.value;
    L(N, p), y.value.multiCalendars && e.multiCalendarsSolo && u();
  }, Y = () => {
    if (k(), !e.range)
      f.value = et(R(), V.hours, V.minutes, m());
    else {
      const p = V.hours, N = V.minutes;
      f.value = [
        et(R(), p[0], N[0], m()),
        et(R(), p[1], N[1], m(!1))
      ];
    }
  }, X = () => {
    f.value = d(R(), q.value(0), ee.value(0));
  }, O = () => {
    f.value = R();
  }, m = (p = !0) => e.enableSeconds ? Array.isArray(V.seconds) ? p ? V.seconds[0] : V.seconds[1] : V.seconds : 0, k = () => {
    const p = o();
    if (p) {
      const N = Array.isArray(p), Z = N ? [+p[0].hours, +p[1].hours] : +p.hours, ce = N ? [+p[0].minutes, +p[1].minutes] : +p.minutes, Se = N ? [+p[0].seconds, +p[1].seconds] : +p.seconds;
      z("hours", Z), z("minutes", ce), e.enableSeconds && z("seconds", Se);
    }
  }, D = () => Array.isArray(f.value) && f.value.length ? f.value[f.value.length - 1] : null, u = () => {
    if (Array.isArray(f.value) && f.value.length === 2) {
      const p = R(
        R(f.value[1] ? f.value[1] : ot(f.value[0], 1))
      ), [N, Z] = [Pe(f.value[0]), ke(f.value[0])], [ce, Se] = [Pe(f.value[1]), ke(f.value[1])];
      (N !== ce || N === ce && Z !== Se) && e.multiCalendarsSolo && C(1, Pe(p), ke(p));
    }
  }, w = (p) => {
    const N = ot(p, 1);
    return { month: Pe(N), year: ke(N) };
  }, S = (p) => {
    const N = Pe(R(p)), Z = ke(R(p));
    if (C(0, N, Z), y.value.multiCalendars > 0)
      for (let ce = 1; ce < y.value.multiCalendars; ce++) {
        const Se = w(
          je(R(p), { year: q.value(ce - 1), month: ee.value(ce - 1) })
        );
        C(ce, Se.month, Se.year);
      }
  }, I = (p) => {
    if (f.value && Array.isArray(f.value))
      if (f.value.some((N) => Te(p, N))) {
        const N = f.value.filter((Z) => !Te(Z, p));
        f.value = N.length ? N : null;
      } else
        (e.multiDatesLimit && +e.multiDatesLimit > f.value.length || !e.multiDatesLimit) && f.value.push(p);
    else
      f.value = [p];
  }, U = (p, N) => {
    const Z = Ge(p, N) ? N : p, ce = Ge(N, p) ? N : p;
    return Eo({ start: Z, end: ce });
  }, _ = (p) => {
    if (Array.isArray(f.value) && f.value[0]) {
      const N = xl(p, f.value[0]), Z = U(f.value[0], p), ce = Z.length === 1 ? 0 : Z.filter((nt) => i(nt)).length, Se = Math.abs(N) - ce;
      if (e.minRange && e.maxRange)
        return Se >= +e.minRange && Se <= +e.maxRange;
      if (e.minRange)
        return Se >= +e.minRange;
      if (e.maxRange)
        return Se <= +e.maxRange;
    }
    return !0;
  }, le = (p) => Array.isArray(f.value) && f.value.length === 2 ? e.fixedStart && (Ge(p, f.value[0]) || Te(p, f.value[0])) ? [f.value[0], p] : e.fixedEnd && (We(p, f.value[1]) || Te(p, f.value[1])) ? [p, f.value[1]] : f.value : [], de = () => {
    e.autoApply && G.value && t("auto-apply");
  }, h = () => {
    e.autoApply && t("select-date");
  }, E = (p) => !Eo({ start: p[0], end: p[1] }).some((N) => i(N)), Me = (p) => (f.value = s(R(p.value)), de()), me = (p) => {
    const N = et(R(p.value), V.hours, V.minutes, m());
    e.multiDates ? I(N) : f.value = N, n(), de();
  }, ue = () => {
    v.value = f.value ? f.value.slice() : [], v.value.length === 2 && !(e.fixedStart || e.fixedEnd) && (v.value = []);
  }, De = (p, N) => {
    const Z = [R(p.value), yt(R(p.value), +e.autoRange)];
    E(Z) && (N && S(p.value), v.value = Z);
  }, Ke = (p) => {
    v.value = le(R(p.value));
  }, se = (p) => e.noDisabledRange ? U(v.value[0], p).some((N) => i(N)) : !1, fe = (p, N) => {
    if (ue(), e.autoRange)
      return De(p, N);
    if (e.fixedStart || e.fixedEnd)
      return Ke(p);
    v.value[0] ? _(R(p.value)) && !se(p.value) && (We(R(p.value), R(v.value[0])) ? v.value.unshift(R(p.value)) : v.value[1] = R(p.value)) : v.value[0] = R(p.value);
  }, _e = (p) => {
    v.value[p] = et(
      v.value[p],
      V.hours[p],
      V.minutes[p],
      m(p !== 1)
    );
  }, be = () => {
    v.value.length && (v.value[0] && !v.value[1] ? _e(0) : (_e(0), _e(1), n()), f.value = v.value.slice(), v.value[0] && v.value[1] && e.autoApply && t("auto-apply"), v.value[0] && !v.value[1] && e.modelAuto && e.autoApply && t("auto-apply"));
  }, Et = (p, N = !1) => {
    if (!(i(p.value) || !p.current && e.hideOffsetDates)) {
      if (e.weekPicker)
        return Me(p);
      if (!e.range)
        return me(p);
      _t(V.hours) && _t(V.minutes) && !e.multiDates && (fe(p, N), be());
    }
  }, ut = (p) => {
    const N = p.find((Z) => Z.current);
    return N ? Vs(N.value) : "";
  }, Yt = (p) => {
    for (let N = p - 1; N >= 0; N--) {
      const Z = Ct(je(R(), { month: q.value(N + 1), year: ee.value(N + 1) }), 1);
      C(N, Pe(Z), ke(Z));
    }
    for (let N = p + 1; N <= y.value.multiCalendars - 1; N++) {
      const Z = ot(je(R(), { month: q.value(N - 1), year: ee.value(N - 1) }), 1);
      C(N, Pe(Z), ke(Z));
    }
  }, gt = (p) => d(R(), q.value(p), ee.value(p)), Vt = (p) => et(p, V.hours, V.minutes, m()), Er = (p, N) => {
    const Z = e.monthPicker ? q.value(p) !== N.month || !N.fromNav : ee.value(p) !== N.year;
    if (C(p, N.month, N.year), y.value.multiCalendars && !e.multiCalendarsSolo && Yt(p), e.monthPicker || e.yearPicker)
      if (e.range) {
        if (Z) {
          let ce = f.value ? f.value.slice() : [];
          ce.length === 2 && ce[1] !== null && (ce = []), ce.length ? We(gt(p), ce[0]) ? ce.unshift(gt(p)) : ce[1] = gt(p) : ce = [gt(p)], f.value = ce;
        }
      } else
        f.value = gt(p);
    t("update-month-year", { instance: p, month: N.month, year: N.year }), r(e.multiCalendarsSolo ? p : void 0);
  }, Yr = async (p = !1) => {
    if (e.autoApply && (e.monthPicker || e.yearPicker)) {
      await Kt();
      const N = e.monthPicker ? p : !1;
      e.range ? t("auto-apply", N || !f.value || f.value.length === 1) : t("auto-apply", N);
    }
    n();
  }, Jt = (p, N) => {
    const Z = je(R(), { month: q.value(N), year: ee.value(N) }), ce = p < 0 ? ot(Z, 1) : Ct(Z, 1);
    b(Pe(ce), ke(ce), p < 0, e.preventMinMaxNavigation) && (C(N, Pe(ce), ke(ce)), y.value.multiCalendars && !e.multiCalendarsSolo && Yt(N), r());
  }, Ft = (p) => {
    cu(p) && cu(f.value) && _t(V.hours) && _t(V.minutes) ? (p[0] && f.value[0] && (f.value[0] = et(p[0], V.hours[0], V.minutes[0], m())), p[1] && f.value[1] && (f.value[1] = et(p[1], V.hours[1], V.minutes[1], m(!1)))) : e.multiDates && Array.isArray(f.value) ? f.value[f.value.length - 1] = Vt(p) : !e.range && !fu(p) && (f.value = Vt(p)), t("time-update");
  }, Vr = (p, N = !0, Z = !1) => {
    const ce = N ? p : V.hours, Se = !N && !Z ? p : V.minutes, nt = Z ? p : V.seconds;
    if (e.range && fu(f.value) && _t(ce) && _t(Se) && _t(nt) && !e.disableTimeRangeValidation) {
      const wt = (K) => et(f.value[K], ce[K], Se[K], nt[K]), T = (K) => Mo(f.value[K], 0);
      if (Te(f.value[0], f.value[1]) && (ko(wt(0), T(1)) || To(wt(1), T(0))))
        return;
    }
    if (z("hours", ce), z("minutes", Se), z("seconds", nt), f.value)
      if (e.multiDates) {
        const wt = D();
        wt && Ft(wt);
      } else
        Ft(f.value);
    else
      e.timePicker && Ft(e.range ? [R(), R()] : R());
    n();
  }, Fr = (p, N) => {
    e.monthChangeOnScroll && Jt(e.monthChangeOnScroll !== "inverse" ? -p.deltaY : p.deltaY, N);
  }, Ur = (p, N, Z = !1) => {
    e.monthChangeOnArrows && e.vertical === Z && Zt(p, N);
  }, Zt = (p, N) => {
    Jt(p === "right" ? -1 : 1, N);
  };
  return {
    time: V,
    month: q,
    year: ee,
    modelValue: f,
    calendars: A,
    monthYearSelect: Yr,
    isDisabled: i,
    updateTime: Vr,
    getWeekNum: ut,
    selectDate: Et,
    updateMonthYear: Er,
    handleScroll: Fr,
    getMarker: (p) => e.markers.find((N) => Te(c(p.value), c(N.date))),
    handleArrow: Ur,
    handleSwipe: Zt,
    selectCurrentDate: () => {
      e.range ? f.value && Array.isArray(f.value) && f.value[0] ? f.value = We(R(), f.value[0]) ? [R(), f.value[0]] : [f.value[0], R()] : f.value = [R()] : f.value = R(), h();
    },
    presetDateRange: (p, N) => {
      N || p.length && p.length <= 2 && e.range && (f.value = p.map((Z) => R(Z)), h());
    }
  };
}, tv = (e, t, n) => {
  const r = H(), {
    getZonedToUtc: a,
    getZonedDate: o,
    formatDate: i,
    getDefaultPattern: c,
    checkRangeEnabled: s,
    checkPartialRangeValue: d,
    isValidDate: b,
    setDateMonthOrYear: y,
    defaults: f
  } = Ze(t), v = H("");
  Xt(r, () => {
    e("internal-model-change", r.value);
  });
  const A = (_) => {
    const le = _ || R();
    return {
      hours: lt(le),
      minutes: st(le),
      seconds: t.enableSeconds ? At(le) : 0
    };
  }, V = (_) => ({ month: Pe(_), year: ke(_) }), q = (_) => Array.isArray(_) ? s(() => [
    Pt(R(), _[0]),
    _[1] ? Pt(R(), _[1]) : d()
  ]) : Pt(R(), +_), ee = (_) => Array.isArray(_) ? [
    et(null, +_[0].hours, +_[0].minutes, _[0].seconds),
    et(null, +_[1].hours, +_[1].minutes, _[1].seconds)
  ] : et(null, _.hours, _.minutes, _ == null ? void 0 : _.seconds), G = (_) => Array.isArray(_) ? s(() => [
    y(null, +_[0].month, +_[0].year),
    _[1] ? y(null, +_[1].month, +_[1].year) : d()
  ]) : y(null, +_.month, +_.year), C = (_) => {
    if (Array.isArray(_))
      return _.map((le) => u(le));
    throw new Error(Br.dateArr("multi-dates"));
  }, z = (_) => {
    if (Array.isArray(_))
      return [R(_[0]), R(_[1])];
    throw new Error(Br.dateArr("week-picker"));
  }, te = (_) => t.modelAuto ? Array.isArray(_) ? [u(_[0]), u(_[1])] : t.autoApply ? [u(_)] : [u(_), null] : Array.isArray(_) ? s(() => [
    u(_[0]),
    _[1] ? u(_[1]) : d()
  ]) : u(_), P = () => {
    Array.isArray(r.value) && t.range && r.value.length === 1 && r.value.push(d());
  }, $ = () => {
    const _ = r.value;
    return [
      w(_[0]),
      _[1] ? w(_[1]) : d()
    ];
  }, M = () => r.value[1] ? $() : w(Ue(r.value[0])), L = () => (r.value || []).map((_) => w(_)), j = () => (P(), t.modelAuto ? M() : t.multiDates ? L() : Array.isArray(r.value) ? s(() => $()) : w(Ue(r.value))), Y = (_) => _ ? t.timePicker ? ee(Ue(_)) : t.monthPicker ? G(Ue(_)) : t.yearPicker ? q(Ue(_)) : t.multiDates ? C(Ue(_)) : t.weekPicker ? z(Ue(_)) : te(Ue(_)) : null, X = (_) => {
    const le = Y(_);
    b(Ue(le)) ? (r.value = Ue(le), D()) : (r.value = null, v.value = "");
  }, O = () => {
    var _;
    const le = (de) => {
      var h;
      return jt(de, (h = f.value.textInputOptions) == null ? void 0 : h.format);
    };
    return `${le(r.value[0])} ${(_ = f.value.textInputOptions) == null ? void 0 : _.rangeSeparator} ${r.value[1] ? le(r.value[1]) : ""}`;
  }, m = () => {
    var _;
    return n.value && r.value ? Array.isArray(r.value) ? O() : jt(r.value, (_ = f.value.textInputOptions) == null ? void 0 : _.format) : i(r.value);
  }, k = () => {
    var _;
    return r.value ? t.multiDates ? r.value.map((le) => i(le)).join("; ") : t.textInput && typeof ((_ = f.value.textInputOptions) == null ? void 0 : _.format) == "string" ? m() : i(r.value) : "";
  }, D = () => {
    !t.format || typeof t.format == "string" ? v.value = k() : v.value = t.format(r.value);
  }, u = (_) => {
    if (t.utc) {
      const le = new Date(_);
      return t.utc === "preserve" ? new Date(le.getTime() + le.getTimezoneOffset() * 6e4) : le;
    }
    return t.modelType ? t.modelType === "date" || t.modelType === "timestamp" ? o(new Date(_)) : t.modelType === "format" && (typeof t.format == "string" || !t.format) ? vo(_, c(), new Date()) : o(vo(_, t.modelType, new Date())) : o(new Date(_));
  }, w = (_) => t.utc ? vm(_, t.utc === "preserve") : t.modelType ? t.modelType === "timestamp" ? +a(_) : t.modelType === "format" && (typeof t.format == "string" || !t.format) ? i(a(_)) : i(a(_), t.modelType) : a(_), S = (_) => {
    e("update:model-value", _);
  }, I = (_) => Array.isArray(r.value) ? [
    _(r.value[0]),
    r.value[1] ? _(r.value[1]) : d()
  ] : _(Ue(r.value)), U = (_) => S(Ue(I(_)));
  return {
    inputValue: v,
    internalModelValue: r,
    checkBeforeEmit: () => r.value ? t.range ? t.partialRange ? r.value.length >= 1 : r.value.length === 2 : !!r.value : !1,
    parseExternalModelValue: X,
    formatInputValue: D,
    emitModelValue: () => (D(), t.monthPicker ? U(V) : t.timePicker ? U(A) : t.yearPicker ? U(ke) : t.weekPicker ? S(r.value) : S(j()))
  };
}, nv = (e, t) => {
  const { validateMonthYearInRange: n, validateMaxDate: r, validateMinDate: a, defaults: o } = Ze(e), i = (y, f) => {
    let v = y;
    return o.value.filters.months.includes(Pe(v)) ? (v = f ? ot(y, 1) : Ct(y, 1), i(v, f)) : v;
  }, c = (y, f) => {
    let v = y;
    return o.value.filters.years.includes(ke(v)) ? (v = f ? wu(y, 1) : Dp(y, 1), c(v, f)) : v;
  }, s = (y) => {
    const f = je(new Date(), { month: e.month, year: e.year });
    let v = y ? ot(f, 1) : Ct(f, 1), A = Pe(v), V = ke(v);
    o.value.filters.months.includes(A) && (v = i(v, y), A = Pe(v), V = ke(v)), o.value.filters.years.includes(V) && (v = c(v, y), V = ke(v)), n(A, V, y, e.preventMinMaxNavigation) && d(A, V);
  }, d = (y, f) => {
    t("update-month-year", { month: y, year: f });
  }, b = F(() => (y) => {
    if (!e.preventMinMaxNavigation || y && !e.maxDate || !y && !e.minDate)
      return !1;
    const f = je(new Date(), { month: e.month, year: e.year }), v = y ? ot(f, 1) : Ct(f, 1), A = [Pe(v), ke(v)];
    return y ? !r(...A) : !a(...A);
  });
  return { handleMonthYearChange: s, isDisabled: b, updateMonthYear: d };
};
var qn = /* @__PURE__ */ ((e) => (e.center = "center", e.left = "left", e.right = "right", e))(qn || {});
const rv = (e, t, n, r) => {
  const a = H({
    top: "0",
    left: "0",
    transform: "none"
  }), o = H(!1), i = ra(r, "teleportCenter");
  Xt(i, () => {
    q();
  });
  const c = ($) => {
    const M = $.getBoundingClientRect();
    return {
      left: M.left + window.scrollX,
      top: M.top + window.scrollY
    };
  }, s = ($) => {
    const M = $.getBoundingClientRect();
    let L = 0, j = 0;
    for (; $ && !isNaN($.offsetLeft) && !isNaN($.offsetTop); )
      L += $.offsetLeft - $.scrollLeft, j = M.top + $.scrollTop, $ = $.offsetParent;
    return { top: j, left: L };
  }, d = ($, M) => {
    a.value.left = `${$ + M}px`, a.value.transform = "translateX(-100%)";
  }, b = ($) => {
    a.value.left = `${$}px`, a.value.transform = "translateX(0)";
  }, y = ($, M, L = !1) => {
    r.position === qn.left && b($), r.position === qn.right && d($, M), r.position === qn.center && (a.value.left = `${$ + M / 2}px`, a.value.transform = L ? "translate(-50%, -50%)" : "translateX(-50%)");
  }, f = ($) => {
    const { width: M, height: L } = $.getBoundingClientRect(), { top: j, left: Y } = r.altPosition ? s($) : c($);
    return { top: j, left: Y, width: M, height: L };
  }, v = () => {
    const $ = Ve(t);
    if ($) {
      const { top: M, left: L, width: j, height: Y } = f($);
      a.value.top = `${M + Y / 2}px`, a.value.transform = "translateY(-50%)", y(L, j, !0);
    }
  }, A = () => {
    a.value.left = "50%", a.value.top = "50%", a.value.transform = "translate(-50%, -50%)", a.value.position = "fixed";
  }, V = () => {
    const $ = Ve(t);
    a.value = r.altPosition($);
  }, q = ($ = !0) => {
    if (!r.inline)
      return i.value ? A() : r.altPosition && typeof r.altPosition != "boolean" ? V() : ($ && n("recalculate-position"), P());
  }, ee = ({
    inputEl: $,
    menuEl: M,
    left: L,
    width: j
  }) => {
    window.screen.width > 768 && y(L, j), z($, M);
  }, G = ($, M) => {
    const { top: L, left: j, height: Y, width: X } = f($);
    a.value.top = `${Y + L + +r.offset}px`, ee({ inputEl: $, menuEl: M, left: j, width: X }), o.value = !1;
  }, C = ($, M) => {
    const { top: L, left: j, width: Y } = f($), { height: X } = M.getBoundingClientRect();
    a.value.top = `${L - X - +r.offset}px`, ee({ inputEl: $, menuEl: M, left: j, width: Y }), o.value = !0;
  }, z = ($, M) => {
    if (r.autoPosition) {
      const { left: L, width: j } = f($), { left: Y, right: X } = M.getBoundingClientRect();
      if (Y < 0)
        return b(L);
      if (X > document.documentElement.clientWidth)
        return d(L, j);
    }
  }, te = ($, M) => {
    const { height: L } = M.getBoundingClientRect(), { top: j, height: Y } = $.getBoundingClientRect(), X = window.innerHeight - j - Y, O = j;
    return L <= X ? G($, M) : L > X && L <= O ? C($, M) : X >= O ? G($, M) : C($, M);
  }, P = () => {
    const $ = Ve(t), M = Ve(e);
    if ($ && M)
      return r.autoPosition ? te($, M) : G($, M);
  };
  return { openOnTop: o, menuPosition: a, setMenuPosition: q, setInitialPosition: v };
}, Mt = [
  { name: "clock-icon", use: ["time", "calendar"] },
  { name: "arrow-left", use: ["month-year", "calendar"] },
  { name: "arrow-right", use: ["month-year", "calendar"] },
  { name: "arrow-up", use: ["time", "calendar"] },
  { name: "arrow-down", use: ["time", "calendar"] },
  { name: "calendar-icon", use: ["month-year", "time", "calendar"] },
  { name: "day", use: ["calendar"] },
  { name: "month-overlay-value", use: ["calendar", "month-year"] },
  { name: "year-overlay-value", use: ["calendar", "month-year"] },
  { name: "year-overlay", use: ["month-year"] },
  { name: "month-overlay", use: ["month-year"] },
  { name: "month-overlay-header", use: ["month-year"] },
  { name: "year-overlay-header", use: ["month-year"] },
  { name: "hours-overlay-value", use: ["calendar", "time"] },
  { name: "minutes-overlay-value", use: ["calendar", "time"] },
  { name: "seconds-overlay-value", use: ["calendar", "time"] },
  { name: "hours", use: ["calendar", "time"] },
  { name: "minutes", use: ["calendar", "time"] },
  { name: "month", use: ["calendar", "month-year"] },
  { name: "year", use: ["calendar", "month-year"] },
  { name: "action-select", use: ["action"] },
  { name: "action-preview", use: ["action"] },
  { name: "calendar-header", use: ["calendar"] },
  { name: "marker-tooltip", use: ["calendar"] },
  { name: "now-button", use: [] },
  { name: "time-picker-overlay", use: ["calendar", "time"] },
  { name: "am-pm-button", use: ["calendar", "time"] },
  { name: "left-sidebar", use: ["menu"] },
  { name: "right-sidebar", use: ["menu"] },
  { name: "month-year", use: ["month-year"] },
  { name: "time-picker", use: ["menu"] },
  { name: "action-row", use: ["action"] }
], av = [{ name: "trigger" }, { name: "input-icon" }, { name: "clear-icon" }, { name: "dp-input" }], ov = {
  all: () => Mt,
  monthYear: () => Mt.filter((e) => e.use.includes("month-year")),
  input: () => av,
  timePicker: () => Mt.filter((e) => e.use.includes("time")),
  action: () => Mt.filter((e) => e.use.includes("action")),
  calendar: () => Mt.filter((e) => e.use.includes("calendar")),
  menu: () => Mt.filter((e) => e.use.includes("menu"))
}, $t = (e, t, n) => {
  const r = [];
  return ov[t]().forEach((a) => {
    e[a.name] && r.push(a.name);
  }), n && n.length && n.forEach((a) => {
    a.slot && r.push(a.slot);
  }), r;
}, Ir = (e) => ({ transitionName: F(() => (t) => e && typeof e != "boolean" ? t ? e.open : e.close : ""), showTransition: !!e }), bt = {
  multiCalendars: { type: [Boolean, Number, String], default: null },
  modelValue: { type: [String, Date, Array, Object, Number], default: null },
  modelType: { type: String, default: null },
  position: { type: String, default: "center" },
  dark: { type: Boolean, default: !1 },
  format: {
    type: [String, Function],
    default: () => null
  },
  closeOnScroll: { type: Boolean, default: !1 },
  autoPosition: { type: Boolean, default: !0 },
  closeOnAutoApply: { type: Boolean, default: !0 },
  teleport: { type: [String, Object], default: "body" },
  altPosition: { type: [Boolean, Function], default: !1 },
  transitions: { type: [Boolean, Object], default: !0 },
  formatLocale: { type: Object, default: null },
  utc: { type: [Boolean, String], default: !1 },
  ariaLabels: { type: Object, default: () => ({}) },
  offset: { type: [Number, String], default: 10 },
  hideNavigation: { type: Array, default: () => [] },
  timezone: { type: String, default: null },
  vertical: { type: Boolean, default: !1 },
  disableMonthYearSelect: { type: Boolean, default: !1 },
  menuClassName: { type: String, default: null },
  dayClass: { type: Function, default: null },
  yearRange: { type: Array, default: () => [1900, 2100] },
  multiCalendarsSolo: { type: Boolean, default: !1 },
  calendarCellClassName: { type: String, default: null },
  enableTimePicker: { type: Boolean, default: !0 },
  autoApply: { type: Boolean, default: !1 },
  disabledDates: { type: [Array, Function], default: () => [] },
  monthNameFormat: { type: String, default: "short" },
  startDate: { type: [Date, String], default: null },
  startTime: { type: [Object, Array], default: null },
  monthYearComponent: { type: Object, default: null },
  timePickerComponent: { type: Object, default: null },
  actionRowComponent: { type: Object, default: null },
  hideOffsetDates: { type: Boolean, default: !1 },
  autoRange: { type: [Number, String], default: null },
  noToday: { type: Boolean, default: !1 },
  disabledWeekDays: { type: Array, default: () => [] },
  allowedDates: { type: Array, default: () => [] },
  showNowButton: { type: Boolean, default: !1 },
  nowButtonLabel: { type: String, default: "Now" },
  markers: { type: Array, default: () => [] },
  modeHeight: { type: [Number, String], default: 255 },
  escClose: { type: Boolean, default: !0 },
  spaceConfirm: { type: Boolean, default: !0 },
  monthChangeOnArrows: { type: Boolean, default: !0 },
  presetRanges: { type: Array, default: () => [] },
  flow: { type: Array, default: () => [] },
  preventMinMaxNavigation: { type: Boolean, default: !1 },
  minRange: { type: [Number, String], default: null },
  maxRange: { type: [Number, String], default: null },
  multiDatesLimit: { type: [Number, String], default: null },
  reverseYears: { type: Boolean, default: !1 },
  keepActionRow: { type: Boolean, default: !1 },
  weekPicker: { type: Boolean, default: !1 },
  filters: { type: Object, default: () => ({}) },
  arrowNavigation: { type: Boolean, default: !1 },
  multiStatic: { type: Boolean, default: !0 },
  disableTimeRangeValidation: { type: Boolean, default: !1 },
  highlight: {
    type: [Array, Function],
    default: null
  },
  highlightWeekDays: {
    type: Array,
    default: null
  },
  highlightDisabledDays: { type: Boolean, default: !1 },
  teleportCenter: { type: Boolean, default: !1 },
  locale: { type: String, default: "en-Us" },
  weekNumName: { type: String, default: "W" },
  weekStart: { type: [Number, String], default: 1 },
  weekNumbers: { type: Boolean, default: !1 },
  calendarClassName: { type: String, default: null },
  noSwipe: { type: Boolean, default: !1 },
  monthChangeOnScroll: { type: [Boolean, String], default: !0 },
  dayNames: {
    type: [Function, Array],
    default: null
  },
  monthPicker: { type: Boolean, default: !1 },
  customProps: { type: Object, default: null },
  yearPicker: { type: Boolean, default: !1 },
  modelAuto: { type: Boolean, default: !1 },
  selectText: { type: String, default: "Select" },
  cancelText: { type: String, default: "Cancel" },
  previewFormat: {
    type: [String, Function],
    default: () => ""
  },
  multiDates: { type: Boolean, default: !1 },
  partialRange: { type: Boolean, default: !0 },
  ignoreTimeValidation: { type: Boolean, default: !1 },
  minDate: { type: [Date, String], default: null },
  maxDate: { type: [Date, String], default: null },
  minTime: { type: Object, default: null },
  maxTime: { type: Object, default: null },
  name: { type: String, default: null },
  placeholder: { type: String, default: "" },
  hideInputIcon: { type: Boolean, default: !1 },
  clearable: { type: Boolean, default: !0 },
  state: { type: Boolean, default: null },
  required: { type: Boolean, default: !1 },
  autocomplete: { type: String, default: "off" },
  inputClassName: { type: String, default: null },
  inlineWithInput: { type: Boolean, default: !1 },
  textInputOptions: { type: Object, default: () => null },
  fixedStart: { type: Boolean, default: !1 },
  fixedEnd: { type: Boolean, default: !1 },
  timePicker: { type: Boolean, default: !1 },
  enableSeconds: { type: Boolean, default: !1 },
  is24: { type: Boolean, default: !0 },
  noHoursOverlay: { type: Boolean, default: !1 },
  noMinutesOverlay: { type: Boolean, default: !1 },
  noSecondsOverlay: { type: Boolean, default: !1 },
  hoursGridIncrement: { type: [String, Number], default: 1 },
  minutesGridIncrement: { type: [String, Number], default: 5 },
  secondsGridIncrement: { type: [String, Number], default: 5 },
  hoursIncrement: { type: [Number, String], default: 1 },
  minutesIncrement: { type: [Number, String], default: 1 },
  secondsIncrement: { type: [Number, String], default: 1 },
  range: { type: Boolean, default: !1 },
  uid: { type: String, default: null },
  disabled: { type: Boolean, default: !1 },
  readonly: { type: Boolean, default: !1 },
  inline: { type: Boolean, default: !1 },
  textInput: { type: Boolean, default: !1 },
  onClickOutside: { type: Function, default: null },
  noDisabledRange: { type: Boolean, default: !1 },
  sixWeeks: { type: Boolean, default: !1 }
}, iv = ["aria-label", "aria-disabled", "aria-readonly"], uv = {
  key: 1,
  class: "dp__input_wrap"
}, lv = ["id", "name", "inputmode", "placeholder", "disabled", "readonly", "required", "value", "autocomplete", "onKeydown"], sv = {
  key: 2,
  class: "dp__input_icon"
}, cv = {
  key: 4,
  class: "dp__clear_icon"
}, fv = /* @__PURE__ */ Ie({
  __name: "DatepickerInput",
  props: {
    isMenuOpen: { type: Boolean, default: !1 },
    inputValue: { type: String, default: "" },
    ...bt
  },
  emits: [
    "clear",
    "open",
    "update:input-value",
    "set-input-date",
    "close",
    "select-date",
    "set-empty-date",
    "toggle",
    "focus-prev",
    "focus",
    "blur"
  ],
  setup(e, { expose: t, emit: n }) {
    const r = e, { getDefaultPattern: a, isValidDate: o, defaults: i } = Ze(r), c = H(), s = H(null), d = H(!1), b = F(
      () => ({
        dp__pointer: !r.disabled && !r.readonly && !r.textInput,
        dp__disabled: r.disabled,
        dp__input_readonly: !r.textInput,
        dp__input: !0,
        dp__input_icon_pad: !r.hideInputIcon,
        dp__input_valid: r.state,
        dp__input_invalid: r.state === !1,
        dp__input_focus: d.value || r.isMenuOpen,
        dp__input_reg: !r.textInput,
        [r.inputClassName]: !!r.inputClassName
      })
    ), y = () => {
      n("set-input-date", null), r.autoApply && (n("set-empty-date"), c.value = null);
    }, f = (P) => {
      var $;
      return mm(P, (($ = i.value.textInputOptions) == null ? void 0 : $.format) || a());
    }, v = (P) => {
      const { rangeSeparator: $ } = i.value.textInputOptions;
      if (r.range) {
        const [M, L] = P.split(`${$}`);
        if (M && L) {
          const j = f(M.trim()), Y = f(L.trim());
          c.value = j && Y ? [j, Y] : null;
        }
      } else if (r.multiDates) {
        const M = P.split(";");
        c.value = M.map((L) => f(L.trim())).filter((L) => L);
      } else
        c.value = f(P);
    }, A = (P) => {
      var $;
      const { value: M } = P.target;
      M !== "" ? (($ = i.value.textInputOptions) != null && $.openMenu && !r.isMenuOpen && n("open"), v(M), n("set-input-date", c.value)) : y(), n("update:input-value", M);
    }, V = () => {
      var P, $;
      (P = i.value.textInputOptions) != null && P.enterSubmit && o(c.value) && r.inputValue !== "" ? (n("set-input-date", c.value, !0), c.value = null) : ($ = i.value.textInputOptions) != null && $.enterSubmit && r.inputValue === "" && (c.value = null, n("clear"));
    }, q = () => {
      var P, $;
      (P = i.value.textInputOptions) != null && P.tabSubmit && o(c.value) && r.inputValue !== "" ? (n("set-input-date", c.value, !0), c.value = null) : ($ = i.value.textInputOptions) != null && $.tabSubmit && r.inputValue === "" && (c.value = null, n("clear"));
    }, ee = () => {
      d.value = !0, n("focus");
    }, G = (P) => {
      var $;
      P.preventDefault(), P.stopImmediatePropagation(), P.stopPropagation(), r.textInput && (($ = i.value.textInputOptions) != null && $.openMenu) && !r.inlineWithInput ? r.isMenuOpen ? i.value.textInputOptions.enterSubmit && n("select-date") : n("open") : r.textInput || n("toggle");
    }, C = () => {
      d.value = !1, r.isMenuOpen || n("blur"), r.autoApply && r.textInput && c.value && (n("set-input-date", c.value), n("select-date"), c.value = null);
    }, z = () => {
      n("clear");
    }, te = (P) => {
      r.textInput || P.preventDefault();
    };
    return t({
      focusInput: () => {
        s.value && s.value.focus({ preventScroll: !0 });
      }
    }), (P, $) => {
      var M;
      return g(), B("div", {
        onClick: G,
        "aria-label": (M = l(i).ariaLabels) == null ? void 0 : M.input,
        role: "textbox",
        "aria-multiline": "false",
        "aria-disabled": P.disabled,
        "aria-readonly": P.readonly
      }, [
        P.$slots.trigger && !P.$slots["dp-input"] && !P.inline ? W(P.$slots, "trigger", { key: 0 }) : x("", !0),
        !P.$slots.trigger && (!P.inline || P.inlineWithInput) ? (g(), B("div", uv, [
          P.$slots["dp-input"] && !P.$slots.trigger && !P.inline ? W(P.$slots, "dp-input", {
            key: 0,
            value: e.inputValue,
            onInput: A,
            onEnter: V,
            onTab: q,
            onClear: z
          }) : x("", !0),
          P.$slots["dp-input"] ? x("", !0) : (g(), B("input", {
            key: 1,
            ref_key: "inputRef",
            ref: s,
            id: P.uid ? `dp-input-${P.uid}` : void 0,
            name: P.name,
            class: pe(l(b)),
            inputmode: P.textInput ? "text" : "none",
            placeholder: P.placeholder,
            disabled: P.disabled,
            readonly: P.readonly,
            required: P.required,
            value: e.inputValue,
            autocomplete: P.autocomplete,
            onInput: A,
            onKeydown: [
              ye(G, ["enter"]),
              ye(q, ["tab"])
            ],
            onBlur: C,
            onFocus: ee,
            onKeypress: te
          }, null, 42, lv)),
          P.$slots["input-icon"] && !P.hideInputIcon ? (g(), B("span", sv, [
            W(P.$slots, "input-icon")
          ])) : x("", !0),
          !P.$slots["input-icon"] && !P.hideInputIcon && !P.$slots["dp-input"] ? (g(), oe(l(Ar), {
            key: 3,
            class: "dp__input_icon dp__input_icons"
          })) : x("", !0),
          P.$slots["clear-icon"] && e.inputValue && P.clearable && !P.disabled && !P.readonly ? (g(), B("span", cv, [
            W(P.$slots, "clear-icon", { clear: z })
          ])) : x("", !0),
          P.clearable && !P.$slots["clear-icon"] && e.inputValue && !P.disabled && !P.readonly ? (g(), oe(l(Lp), {
            key: 5,
            class: "dp__clear_icon dp__input_icons",
            "data-test": "clear-icon",
            onClick: ft(z, ["stop", "prevent"])
          }, null, 8, ["onClick"])) : x("", !0)
        ])) : x("", !0)
      ], 8, iv);
    };
  }
}), dv = { class: "dp__selection_preview" }, yv = { class: "dp__action_buttons" }, pv = ["onKeydown"], mv = /* @__PURE__ */ Ie({
  __name: "ActionRow",
  props: {
    calendarWidth: { type: Number, default: 0 },
    menuMount: { type: Boolean, default: !1 },
    internalModelValue: { type: [Date, Array], default: null },
    ...bt
  },
  emits: ["close-picker", "select-date", "invalid-select"],
  setup(e, { emit: t }) {
    const n = e, { formatDate: r, isValidTime: a, defaults: o } = Ze(n), { buildMatrix: i } = ht(), c = H(null), s = H(null);
    tt(() => {
      n.arrowNavigation && i([Ve(c), Ve(s)], "actionRow");
    });
    const d = F(() => n.range && !n.partialRange && n.internalModelValue ? n.internalModelValue.length === 2 : !0), b = F(() => !f.value || !v.value || !d.value), y = F(() => ({
      dp__action: !0,
      dp__select: !0,
      dp__action_disabled: b.value
    })), f = F(() => !n.enableTimePicker || n.ignoreTimeValidation ? !0 : a(n.internalModelValue)), v = F(() => n.monthPicker ? ee(n.internalModelValue) : !0), A = () => {
      const C = o.value.previewFormat;
      return n.timePicker || n.monthPicker, C(Ue(n.internalModelValue));
    }, V = () => {
      const C = n.internalModelValue;
      return o.value.multiCalendars > 0 ? `${r(C[0])} - ${r(C[1])}` : [r(C[0]), r(C[1])];
    }, q = F(() => !n.internalModelValue || !n.menuMount ? "" : typeof o.value.previewFormat == "string" ? Array.isArray(n.internalModelValue) ? n.internalModelValue.length === 2 && n.internalModelValue[1] ? V() : n.multiDates ? n.internalModelValue.map((C) => `${r(C)}`) : n.modelAuto ? `${r(n.internalModelValue[0])}` : `${r(n.internalModelValue[0])} -` : r(n.internalModelValue) : A()), ee = (C) => {
      if (!n.monthPicker)
        return !0;
      let z = !0;
      return n.minDate && n.maxDate ? Ge(R(C), R(n.minDate)) && We(R(C), R(n.maxDate)) : (n.minDate && (z = Ge(R(C), R(n.minDate))), n.maxDate && (z = We(R(C), R(n.maxDate))), z);
    }, G = () => {
      f.value && v.value && d.value ? t("select-date") : t("invalid-select");
    };
    return (C, z) => (g(), B("div", {
      class: "dp__action_row",
      style: Nt(e.calendarWidth ? { width: `${e.calendarWidth}px` } : {})
    }, [
      C.$slots["action-row"] ? W(C.$slots, "action-row", Je(Ye({ key: 0 }, {
        internalModelValue: e.internalModelValue,
        disabled: l(b),
        selectDate: () => C.$emit("select-date"),
        closePicker: () => C.$emit("close-picker")
      }))) : (g(), B(he, { key: 1 }, [
        ie("div", dv, [
          C.$slots["action-preview"] ? W(C.$slots, "action-preview", {
            key: 0,
            value: e.internalModelValue
          }) : x("", !0),
          C.$slots["action-preview"] ? x("", !0) : (g(), B(he, { key: 1 }, [
            Array.isArray(l(q)) ? x("", !0) : (g(), B(he, { key: 0 }, [
              Fe($e(l(q)), 1)
            ], 64)),
            Array.isArray(l(q)) ? (g(!0), B(he, { key: 1 }, Ae(l(q), (te, P) => (g(), B("div", { key: P }, $e(te), 1))), 128)) : x("", !0)
          ], 64))
        ]),
        ie("div", yv, [
          C.$slots["action-select"] ? W(C.$slots, "action-select", {
            key: 0,
            value: e.internalModelValue
          }) : x("", !0),
          C.$slots["action-select"] ? x("", !0) : (g(), B(he, { key: 1 }, [
            C.inline ? x("", !0) : (g(), B("span", {
              key: 0,
              class: "dp__action dp__cancel",
              ref_key: "cancelButtonRef",
              ref: c,
              tabindex: "0",
              onClick: z[0] || (z[0] = (te) => C.$emit("close-picker")),
              onKeydown: [
                z[1] || (z[1] = ye((te) => C.$emit("close-picker"), ["enter"])),
                z[2] || (z[2] = ye((te) => C.$emit("close-picker"), ["space"]))
              ]
            }, $e(C.cancelText), 545)),
            ie("span", {
              class: pe(l(y)),
              tabindex: "0",
              onKeydown: [
                ye(G, ["enter"]),
                ye(G, ["space"])
              ],
              onClick: G,
              "data-test": "select-button",
              ref_key: "selectButtonRef",
              ref: s
            }, $e(C.selectText), 43, pv)
          ], 64))
        ])
      ], 64))
    ], 4));
  }
}), vv = ["aria-label"], hv = {
  class: "dp__calendar_header",
  role: "row"
}, bv = {
  key: 0,
  class: "dp__calendar_header_item",
  role: "gridcell"
}, gv = /* @__PURE__ */ ie("div", { class: "dp__calendar_header_separator" }, null, -1), wv = ["aria-label"], _v = {
  key: 0,
  role: "gridcell",
  class: "dp__calendar_item dp__week_num"
}, Ov = { class: "dp__cell_inner" }, $v = ["aria-selected", "aria-disabled", "aria-label", "data-test", "onClick", "onKeydown", "onMouseover"], Pv = /* @__PURE__ */ ie("div", { class: "dp__arrow_bottom_tp" }, null, -1), kv = /* @__PURE__ */ Ie({
  __name: "Calendar",
  props: {
    mappedDates: { type: Array, default: () => [] },
    getWeekNum: {
      type: Function,
      default: () => ""
    },
    specificMode: { type: Boolean, default: !1 },
    instance: { type: Number, default: 0 },
    month: { type: Number, default: 0 },
    year: { type: Number, default: 0 },
    ...bt
  },
  emits: [
    "select-date",
    "set-hover-date",
    "handle-scroll",
    "mount",
    "handle-swipe",
    "handle-space"
  ],
  setup(e, { expose: t, emit: n }) {
    const r = e, { buildMultiLevelMatrix: a } = ht(), { setDateMonthOrYear: o, defaults: i } = Ze(r), c = H(null), s = H({ bottom: "", left: "", transform: "" }), d = H([]), b = H(null), y = H(!0), f = H(""), v = H({ startX: 0, endX: 0, startY: 0, endY: 0 }), A = F(() => r.dayNames ? Array.isArray(r.dayNames) ? r.dayNames : r.dayNames(r.locale, +r.weekStart) : Wm(r.locale, +r.weekStart));
    tt(() => {
      n("mount", { cmp: "calendar", refs: d }), r.noSwipe || b.value && (b.value.addEventListener("touchstart", M, { passive: !1 }), b.value.addEventListener("touchend", L, { passive: !1 }), b.value.addEventListener("touchmove", j, { passive: !1 })), r.monthChangeOnScroll && b.value && b.value.addEventListener("wheel", O, { passive: !1 });
    });
    const V = (m) => m ? r.vertical ? "vNext" : "next" : r.vertical ? "vPrevious" : "previous", q = (m, k) => {
      if (r.transitions) {
        const D = it(o(R(), r.month, r.year));
        f.value = Ge(it(o(R(), m, k)), D) ? i.value.transitions[V(!0)] : i.value.transitions[V(!1)], y.value = !1, Kt(() => {
          y.value = !0;
        });
      }
    }, ee = F(
      () => ({
        dp__calendar_wrap: !0,
        [r.calendarClassName]: !!r.calendarClassName
      })
    ), G = F(() => (m) => {
      const k = qm(m);
      return {
        dp__marker_dot: k.type === "dot",
        dp__marker_line: k.type === "line"
      };
    }), C = F(() => (m) => Te(m, c.value)), z = F(() => ({
      dp__calendar: !0,
      dp__calendar_next: i.value.multiCalendars > 0 && r.instance !== 0
    })), te = F(() => r.specificMode ? { height: `${r.modeHeight}px` } : void 0), P = (m, k, D) => {
      var u, w;
      if (n("set-hover-date", m), (w = (u = m.marker) == null ? void 0 : u.tooltip) != null && w.length) {
        const S = Ve(d.value[k][D]);
        if (S) {
          const { width: I, height: U } = S.getBoundingClientRect();
          s.value = {
            bottom: `${U}px`,
            left: `${I / 2}px`,
            transform: "translateX(-50%)"
          }, c.value = m.value;
        }
      }
    }, $ = () => {
      c.value = null;
    }, M = (m) => {
      v.value.startX = m.changedTouches[0].screenX, v.value.startY = m.changedTouches[0].screenY;
    }, L = (m) => {
      v.value.endX = m.changedTouches[0].screenX, v.value.endY = m.changedTouches[0].screenY, Y();
    }, j = (m) => {
      r.vertical && !r.inline && m.preventDefault();
    }, Y = () => {
      const m = r.vertical ? "Y" : "X";
      Math.abs(v.value[`start${m}`] - v.value[`end${m}`]) > 10 && n("handle-swipe", v.value[`start${m}`] > v.value[`end${m}`] ? "right" : "left");
    }, X = (m, k, D) => {
      m && (Array.isArray(d.value[k]) ? d.value[k][D] = m : d.value[k] = [m]), r.arrowNavigation && a(d.value, "calendar");
    }, O = (m) => {
      r.monthChangeOnScroll && (m.preventDefault(), n("handle-scroll", m));
    };
    return t({ triggerTransition: q }), (m, k) => {
      var D;
      return g(), B("div", {
        class: pe(l(z))
      }, [
        ie("div", {
          style: Nt(l(te))
        }, [
          e.specificMode ? x("", !0) : (g(), B("div", {
            key: 0,
            ref_key: "calendarWrapRef",
            ref: b,
            class: pe(l(ee)),
            role: "grid",
            "aria-label": (D = l(i).ariaLabels) == null ? void 0 : D.calendarWrap
          }, [
            ie("div", hv, [
              m.weekNumbers ? (g(), B("div", bv, $e(m.weekNumName), 1)) : x("", !0),
              (g(!0), B(he, null, Ae(l(A), (u, w) => (g(), B("div", {
                class: "dp__calendar_header_item",
                role: "gridcell",
                key: w,
                "data-test": "calendar-header"
              }, [
                m.$slots["calendar-header"] ? W(m.$slots, "calendar-header", {
                  key: 0,
                  day: u,
                  index: w
                }) : x("", !0),
                m.$slots["calendar-header"] ? x("", !0) : (g(), B(he, { key: 1 }, [
                  Fe($e(u), 1)
                ], 64))
              ]))), 128))
            ]),
            gv,
            Re(It, {
              name: f.value,
              css: !!m.transitions
            }, {
              default: Q(() => {
                var u;
                return [
                  y.value ? (g(), B("div", {
                    key: 0,
                    class: "dp__calendar",
                    role: "grid",
                    "aria-label": (u = l(i).ariaLabels) == null ? void 0 : u.calendarDays
                  }, [
                    (g(!0), B(he, null, Ae(e.mappedDates, (w, S) => (g(), B("div", {
                      class: "dp__calendar_row",
                      role: "row",
                      key: S
                    }, [
                      m.weekNumbers ? (g(), B("div", _v, [
                        ie("div", Ov, $e(e.getWeekNum(w.days)), 1)
                      ])) : x("", !0),
                      (g(!0), B(he, null, Ae(w.days, (I, U) => {
                        var _, le, de;
                        return g(), B("div", {
                          role: "gridcell",
                          class: "dp__calendar_item",
                          ref_for: !0,
                          ref: (h) => X(h, S, U),
                          key: U + S,
                          "aria-selected": I.classData.dp__active_date || I.classData.dp__range_start || I.classData.dp__range_start,
                          "aria-disabled": I.classData.dp__cell_disabled,
                          "aria-label": (le = (_ = l(i).ariaLabels) == null ? void 0 : _.day) == null ? void 0 : le.call(_, I),
                          tabindex: "0",
                          "data-test": I.value,
                          onClick: ft((h) => m.$emit("select-date", I), ["stop", "prevent"]),
                          onKeydown: [
                            ye((h) => m.$emit("select-date", I), ["enter"]),
                            ye((h) => m.$emit("handle-space", I), ["space"])
                          ],
                          onMouseover: (h) => P(I, S, U),
                          onMouseleave: $
                        }, [
                          ie("div", {
                            class: pe(["dp__cell_inner", I.classData])
                          }, [
                            m.$slots.day ? W(m.$slots, "day", {
                              key: 0,
                              day: +I.text,
                              date: I.value
                            }) : x("", !0),
                            m.$slots.day ? x("", !0) : (g(), B(he, { key: 1 }, [
                              Fe($e(I.text), 1)
                            ], 64)),
                            I.marker && (!m.hideOffsetDates || I.current) ? (g(), B("div", {
                              key: 2,
                              class: pe(l(G)(I.marker)),
                              style: Nt(I.marker.color ? { backgroundColor: I.marker.color } : {})
                            }, null, 6)) : x("", !0),
                            l(C)(I.value) ? (g(), B("div", {
                              key: 3,
                              class: "dp__marker_tooltip",
                              style: Nt(s.value)
                            }, [
                              (de = I.marker) != null && de.tooltip ? (g(), B("div", {
                                key: 0,
                                class: "dp__tooltip_content",
                                onClick: k[0] || (k[0] = ft(() => {
                                }, ["stop"]))
                              }, [
                                (g(!0), B(he, null, Ae(I.marker.tooltip, (h, E) => (g(), B("div", {
                                  key: E,
                                  class: "dp__tooltip_text"
                                }, [
                                  m.$slots["marker-tooltip"] ? W(m.$slots, "marker-tooltip", {
                                    key: 0,
                                    tooltop: h,
                                    day: I.value
                                  }) : x("", !0),
                                  m.$slots["marker-tooltip"] ? x("", !0) : (g(), B(he, { key: 1 }, [
                                    ie("div", {
                                      class: "dp__tooltip_mark",
                                      style: Nt(h.color ? { backgroundColor: h.color } : {})
                                    }, null, 4),
                                    ie("div", null, $e(h.text), 1)
                                  ], 64))
                                ]))), 128)),
                                Pv
                              ])) : x("", !0)
                            ], 4)) : x("", !0)
                          ], 2)
                        ], 40, $v);
                      }), 128))
                    ]))), 128))
                  ], 8, wv)) : x("", !0)
                ];
              }),
              _: 3
            }, 8, ["name", "css"])
          ], 10, vv))
        ], 4)
      ], 2);
    };
  }
}), Tv = ["aria-label", "aria-disabled"], ta = /* @__PURE__ */ Ie({
  __name: "ActionIcon",
  props: {
    ariaLabel: { type: String, default: "" },
    disabled: { type: Boolean, default: !1 }
  },
  emits: ["activate", "set-ref"],
  setup(e, { emit: t }) {
    const n = H(null);
    return tt(() => t("set-ref", n)), (r, a) => (g(), B("div", {
      class: "dp__month_year_col_nav",
      onClick: a[0] || (a[0] = (o) => r.$emit("activate")),
      onKeydown: [
        a[1] || (a[1] = ye((o) => r.$emit("activate"), ["enter"])),
        a[2] || (a[2] = ye((o) => r.$emit("activate"), ["space"]))
      ],
      tabindex: "0",
      role: "button",
      "aria-label": e.ariaLabel,
      "aria-disabled": e.disabled,
      ref_key: "elRef",
      ref: n
    }, [
      ie("div", {
        class: pe(["dp__inner_nav", { dp__inner_nav_disabled: e.disabled }])
      }, [
        W(r.$slots, "default")
      ], 2)
    ], 40, Tv));
  }
}), Dv = ["onKeydown"], Sv = { class: "dp__selection_grid_header" }, xv = ["aria-selected", "aria-disabled", "data-test", "onClick", "onKeydown", "onMouseover"], Rv = ["aria-label", "onKeydown"], Gt = /* @__PURE__ */ Ie({
  __name: "SelectionGrid",
  props: {
    items: { type: Array, default: () => [] },
    modelValue: { type: [String, Number], default: null },
    multiModelValue: { type: Array, default: () => [] },
    disabledValues: { type: Array, default: () => [] },
    minValue: { type: [Number, String], default: null },
    maxValue: { type: [Number, String], default: null },
    year: { type: Number, default: 0 },
    skipActive: { type: Boolean, default: !1 },
    headerRefs: { type: Array, default: () => [] },
    skipButtonRef: { type: Boolean, default: !1 },
    monthPicker: { type: Boolean, default: !1 },
    yearPicker: { type: Boolean, default: !1 },
    escClose: { type: Boolean, default: !0 },
    type: { type: String, default: null },
    arrowNavigation: { type: Boolean, default: !1 },
    autoApply: { type: Boolean, default: !1 },
    textInput: { type: Boolean, default: !1 },
    ariaLabels: { type: Object, default: () => ({}) },
    hideNavigation: { type: Array, default: () => [] }
  },
  emits: ["update:model-value", "selected", "toggle", "reset-flow"],
  setup(e, { expose: t, emit: n }) {
    const r = e, { setSelectionGrid: a, buildMultiLevelMatrix: o, setMonthPicker: i } = ht(), { hideNavigationButtons: c } = Ze(r), s = H(!1), d = H(null), b = H(null), y = H([]), f = H(), v = H(null);
    ll(() => {
      d.value = null;
    }), tt(() => {
      Kt().then(() => $()), V(), A(!0);
    }), _o(() => A(!1));
    const A = (m) => {
      var k;
      r.arrowNavigation && ((k = r.headerRefs) != null && k.length ? i(m) : a(m));
    }, V = () => {
      const m = Ve(b);
      m && (r.textInput || m.focus({ preventScroll: !0 }), s.value = m.clientHeight < m.scrollHeight);
    }, q = F(
      () => ({
        dp__overlay: !0
      })
    ), ee = F(() => ({
      dp__overlay_col: !0
    })), G = (m) => r.skipActive ? !1 : m.value === r.modelValue, C = F(() => r.items.map((m) => m.filter((k) => k).map((k) => {
      var D, u, w;
      const S = r.disabledValues.some((U) => U === k.value) || P(k.value), I = (D = r.multiModelValue) != null && D.length ? (u = r.multiModelValue) == null ? void 0 : u.some(
        (U) => Te(
          U,
          Pt(
            r.monthPicker ? qt(new Date(), k.value) : new Date(),
            r.monthPicker ? r.year : k.value
          )
        )
      ) : G(k);
      return {
        ...k,
        className: {
          dp__overlay_cell_active: I,
          dp__overlay_cell: !I,
          dp__overlay_cell_disabled: S,
          dp__overlay_cell_active_disabled: S && I,
          dp__overlay_cell_pad: !0,
          dp__cell_in_between: (w = r.multiModelValue) != null && w.length ? L(k.value) : !1
        }
      };
    }))), z = F(
      () => ({
        dp__button: !0,
        dp__overlay_action: !0,
        dp__over_action_scroll: s.value,
        dp__button_bottom: r.autoApply
      })
    ), te = F(() => {
      var m, k;
      return {
        dp__overlay_container: !0,
        dp__container_flex: ((m = r.items) == null ? void 0 : m.length) <= 6,
        dp__container_block: ((k = r.items) == null ? void 0 : k.length) > 6
      };
    }), P = (m) => {
      const k = r.maxValue || r.maxValue === 0, D = r.minValue || r.minValue === 0;
      return !k && !D ? !1 : k && D ? +m > +r.maxValue || +m < +r.minValue : k ? +m > +r.maxValue : D ? +m < +r.minValue : !1;
    }, $ = () => {
      const m = Ve(d);
      if (m) {
        const k = Ve(b);
        k && (k.scrollTop = m.offsetTop - k.offsetTop - (k.getBoundingClientRect().height / 2 - m.getBoundingClientRect().height));
      }
    }, M = (m) => {
      !r.disabledValues.some((k) => k === m) && !P(m) && (n("update:model-value", m), n("selected"));
    }, L = (m) => {
      const k = r.monthPicker ? r.year : m;
      return zu(
        r.multiModelValue,
        Pt(
          r.monthPicker ? qt(new Date(), f.value || 0) : new Date(),
          r.monthPicker ? k : f.value || k
        ),
        Pt(r.monthPicker ? qt(new Date(), m) : new Date(), k)
      );
    }, j = () => {
      n("toggle"), n("reset-flow");
    }, Y = () => {
      r.escClose && j();
    }, X = (m, k, D, u) => {
      m && (k.value === +r.modelValue && !r.disabledValues.includes(k.value) && (d.value = m), r.arrowNavigation && (Array.isArray(y.value[D]) ? y.value[D][u] = m : y.value[D] = [m], O()));
    }, O = () => {
      var m, k;
      const D = (m = r.headerRefs) != null && m.length ? [r.headerRefs].concat(y.value) : y.value.concat([r.skipButtonRef ? [] : [v.value]]);
      o(Ue(D), (k = r.headerRefs) != null && k.length ? "monthPicker" : "selectionGrid");
    };
    return t({ focusGrid: V }), (m, k) => {
      var D;
      return g(), B("div", {
        ref_key: "gridWrapRef",
        ref: b,
        class: pe(l(q)),
        role: "dialog",
        tabindex: "0",
        onKeydown: ye(Y, ["esc"])
      }, [
        ie("div", {
          class: pe(l(te)),
          role: "grid"
        }, [
          ie("div", Sv, [
            W(m.$slots, "header")
          ]),
          m.$slots.overlay ? W(m.$slots, "overlay", { key: 0 }) : (g(), B(he, { key: 1 }, [
            (g(!0), B(he, null, Ae(l(C), (u, w) => (g(), B("div", {
              class: "dp__overlay_row",
              key: w,
              role: "row"
            }, [
              (g(!0), B(he, null, Ae(u, (S, I) => (g(), B("div", {
                role: "gridcell",
                class: pe(l(ee)),
                key: S.value,
                "aria-selected": S.value === e.modelValue && !e.disabledValues.includes(S.value),
                "aria-disabled": S.className.dp__overlay_cell_disabled,
                ref_for: !0,
                ref: (U) => X(U, S, w, I),
                tabindex: "0",
                "data-test": S.text,
                onClick: (U) => M(S.value),
                onKeydown: [
                  ye((U) => M(S.value), ["enter"]),
                  ye((U) => M(S.value), ["space"])
                ],
                onMouseover: (U) => f.value = S.value
              }, [
                ie("div", {
                  class: pe(S.className)
                }, [
                  m.$slots.item ? W(m.$slots, "item", {
                    key: 0,
                    item: S
                  }) : x("", !0),
                  m.$slots.item ? x("", !0) : (g(), B(he, { key: 1 }, [
                    Fe($e(S.text), 1)
                  ], 64))
                ], 2)
              ], 42, xv))), 128))
            ]))), 128)),
            m.$slots["button-icon"] ? an((g(), B("div", {
              key: 0,
              role: "button",
              "aria-label": (D = e.ariaLabels) == null ? void 0 : D.toggleOverlay,
              class: pe(l(z)),
              tabindex: "0",
              ref_key: "toggleButton",
              ref: v,
              onClick: j,
              onKeydown: ye(j, ["enter"])
            }, [
              W(m.$slots, "button-icon")
            ], 42, Rv)), [
              [on, !l(c)(e.type)]
            ]) : x("", !0)
          ], 64))
        ], 2)
      ], 42, Dv);
    };
  }
}), Mv = ["aria-label"], du = /* @__PURE__ */ Ie({
  __name: "RegularPicker",
  props: {
    ariaLabel: { type: String, default: "" },
    showSelectionGrid: { type: Boolean, default: !1 },
    modelValue: { type: Number, default: null },
    items: { type: Array, default: () => [] },
    disabledValues: { type: Array, default: () => [] },
    minValue: { type: Number, default: null },
    maxValue: { type: Number, default: null },
    slotName: { type: String, default: "" },
    overlaySlot: { type: String, default: "" },
    headerRefs: { type: Array, default: () => [] },
    escClose: { type: Boolean, default: !0 },
    type: { type: String, default: null },
    transitions: { type: [Object, Boolean], default: !1 },
    arrowNavigation: { type: Boolean, default: !1 },
    autoApply: { type: Boolean, default: !1 },
    textInput: { type: Boolean, default: !1 },
    ariaLabels: { type: Object, default: () => ({}) },
    hideNavigation: { type: Array, default: () => [] }
  },
  emits: ["update:model-value", "toggle", "set-ref"],
  setup(e, { emit: t }) {
    const n = e, { transitionName: r, showTransition: a } = Ir(n.transitions), o = H(null);
    return tt(() => t("set-ref", o)), (i, c) => (g(), B(he, null, [
      ie("div", {
        class: "dp__month_year_select",
        onClick: c[0] || (c[0] = (s) => i.$emit("toggle")),
        onKeydown: [
          c[1] || (c[1] = ye((s) => i.$emit("toggle"), ["enter"])),
          c[2] || (c[2] = ye((s) => i.$emit("toggle"), ["space"]))
        ],
        role: "button",
        "aria-label": e.ariaLabel,
        tabindex: "0",
        ref_key: "elRef",
        ref: o
      }, [
        W(i.$slots, "default")
      ], 40, Mv),
      Re(It, {
        name: l(r)(e.showSelectionGrid),
        css: l(a)
      }, {
        default: Q(() => [
          e.showSelectionGrid ? (g(), oe(Gt, Ye({ key: 0 }, {
            modelValue: e.modelValue,
            items: e.items,
            disabledValues: e.disabledValues,
            minValue: e.minValue,
            maxValue: e.maxValue,
            escClose: e.escClose,
            type: e.type,
            arrowNavigation: e.arrowNavigation,
            textInput: e.textInput,
            autoApply: e.autoApply,
            ariaLabels: e.ariaLabels,
            hideNavigation: e.hideNavigation
          }, {
            "header-refs": [],
            "onUpdate:modelValue": c[3] || (c[3] = (s) => i.$emit("update:model-value", s)),
            onToggle: c[4] || (c[4] = (s) => i.$emit("toggle"))
          }), Xe({
            "button-icon": Q(() => [
              i.$slots["calendar-icon"] ? W(i.$slots, "calendar-icon", { key: 0 }) : x("", !0),
              i.$slots["calendar-icon"] ? x("", !0) : (g(), oe(l(Ar), { key: 1 }))
            ]),
            _: 2
          }, [
            i.$slots[e.slotName] ? {
              name: "item",
              fn: Q(({ item: s }) => [
                W(i.$slots, e.slotName, { item: s })
              ]),
              key: "0"
            } : void 0,
            i.$slots[e.overlaySlot] ? {
              name: "overlay",
              fn: Q(() => [
                W(i.$slots, e.overlaySlot)
              ]),
              key: "1"
            } : void 0,
            i.$slots[`${e.overlaySlot}-header`] ? {
              name: "header",
              fn: Q(() => [
                W(i.$slots, `${e.overlaySlot}-header`)
              ]),
              key: "2"
            } : void 0
          ]), 1040)) : x("", !0)
        ]),
        _: 3
      }, 8, ["name", "css"])
    ], 64));
  }
}), Nv = { class: "dp__month_year_row" }, Cv = { class: "dp__month_year_wrap" }, Bv = { class: "dp__month_picker_header" }, Av = ["aria-label"], Iv = ["aria-label"], Ev = ["aria-label"], Yv = /* @__PURE__ */ Ie({
  __name: "MonthYearPicker",
  props: {
    month: { type: Number, default: 0 },
    year: { type: Number, default: 0 },
    instance: { type: Number, default: 0 },
    years: { type: Array, default: () => [] },
    months: { type: Array, default: () => [] },
    internalModelValue: { type: [Date, Array], default: null },
    ...bt
  },
  emits: ["update-month-year", "month-year-select", "mount", "reset-flow", "overlay-closed"],
  setup(e, { expose: t, emit: n }) {
    const r = e, { defaults: a } = Ze(r), { transitionName: o, showTransition: i } = Ir(a.value.transitions), { buildMatrix: c } = ht(), { handleMonthYearChange: s, isDisabled: d, updateMonthYear: b } = nv(r, n), y = H(!1), f = H(!1), v = H([null, null, null, null]), A = H(null), V = H(null), q = H(null);
    tt(() => {
      n("mount");
    });
    const ee = (h) => ({
      get: () => r[h],
      set: (E) => {
        const Me = h === "month" ? "year" : "month";
        n("update-month-year", { [h]: E, [Me]: r[Me] }), n("month-year-select", h === "year"), h === "month" ? I(!0) : U(!0);
      }
    }), G = F(ee("month")), C = F(ee("year")), z = (h) => {
      const E = ke(R(h));
      return r.year === E;
    }, te = F(() => r.monthPicker ? Array.isArray(r.disabledDates) ? r.disabledDates.map((h) => R(h)).filter((h) => z(h)).map((h) => Pe(h)) : [] : []), P = F(() => (h) => {
      const E = h === "month";
      return {
        showSelectionGrid: (E ? y : f).value,
        items: (E ? D : u).value,
        disabledValues: a.value.filters[E ? "months" : "years"].concat(te.value),
        minValue: (E ? j : M).value,
        maxValue: (E ? Y : L).value,
        headerRefs: E && r.monthPicker ? [A.value, V.value, q.value] : [],
        escClose: r.escClose,
        transitions: a.value.transitions,
        ariaLabels: a.value.ariaLabels,
        textInput: r.textInput,
        autoApply: r.autoApply,
        arrowNavigation: r.arrowNavigation,
        hideNavigation: r.hideNavigation
      };
    }), $ = F(() => (h) => ({
      month: r.month,
      year: r.year,
      items: h === "month" ? r.months : r.years,
      instance: r.instance,
      updateMonthYear: b,
      toggle: h === "month" ? I : U
    })), M = F(() => r.minDate ? ke(R(r.minDate)) : null), L = F(() => r.maxDate ? ke(R(r.maxDate)) : null), j = F(() => {
      if (r.minDate && M.value) {
        if (M.value > r.year)
          return 12;
        if (M.value === r.year)
          return Pe(R(r.minDate));
      }
      return null;
    }), Y = F(() => r.maxDate && L.value ? L.value < r.year ? -1 : L.value === r.year ? Pe(R(r.maxDate)) : null : null), X = F(() => r.range && r.internalModelValue && (r.monthPicker || r.yearPicker) ? r.internalModelValue : []), O = (h) => h.reverse(), m = (h, E = !1) => {
      const Me = [], me = (ue) => E ? O(ue) : ue;
      for (let ue = 0; ue < h.length; ue += 3) {
        const De = [h[ue], h[ue + 1], h[ue + 2]];
        Me.push(me(De));
      }
      return E ? Me.reverse() : Me;
    }, k = F(() => r.months.find((E) => E.value === r.month) || { text: "", value: 0 }), D = F(() => m(r.months)), u = F(() => m(r.years, r.reverseYears)), w = F(() => a.value.multiCalendars ? r.multiCalendarsSolo ? !0 : r.instance === 0 : !0), S = F(() => a.value.multiCalendars ? r.multiCalendarsSolo ? !0 : r.instance === a.value.multiCalendars - 1 : !0), I = (h = !1) => {
      _(h), y.value = !y.value, y.value || n("overlay-closed");
    }, U = (h = !1) => {
      _(h), f.value = !f.value, f.value || n("overlay-closed");
    }, _ = (h) => {
      h || n("reset-flow");
    }, le = (h = !1) => {
      d.value(h) || n("update-month-year", {
        year: h ? r.year + 1 : r.year - 1,
        month: r.month,
        fromNav: !0
      });
    }, de = (h, E) => {
      r.arrowNavigation && (v.value[E] = Ve(h), c(v.value, "monthYear"));
    };
    return t({
      toggleMonthPicker: I,
      toggleYearPicker: U
    }), (h, E) => {
      var Me, me, ue, De, Ke;
      return g(), B("div", Nv, [
        h.$slots["month-year"] ? W(h.$slots, "month-year", Je(Ye({ key: 0 }, { month: e.month, year: e.year, months: e.months, years: e.years, updateMonthYear: l(b), handleMonthYearChange: l(s), instance: e.instance }))) : (g(), B(he, { key: 1 }, [
          !h.monthPicker && !h.yearPicker ? (g(), B(he, { key: 0 }, [
            l(w) && !h.vertical ? (g(), oe(ta, {
              key: 0,
              "aria-label": (Me = l(a).ariaLabels) == null ? void 0 : Me.prevMonth,
              disabled: l(d)(!1),
              onActivate: E[0] || (E[0] = (se) => l(s)(!1)),
              onSetRef: E[1] || (E[1] = (se) => de(se, 0))
            }, {
              default: Q(() => [
                h.$slots["arrow-left"] ? W(h.$slots, "arrow-left", { key: 0 }) : x("", !0),
                h.$slots["arrow-left"] ? x("", !0) : (g(), oe(l(Ki), { key: 1 }))
              ]),
              _: 3
            }, 8, ["aria-label", "disabled"])) : x("", !0),
            ie("div", Cv, [
              Re(du, Ye({
                type: "month",
                "slot-name": "month-overlay-val",
                "overlay-slot": "overlay-month",
                "aria-label": (me = l(a).ariaLabels) == null ? void 0 : me.openMonthsOverlay,
                modelValue: l(G),
                "onUpdate:modelValue": E[2] || (E[2] = (se) => Le(G) ? G.value = se : null)
              }, l(P)("month"), {
                onToggle: I,
                onSetRef: E[3] || (E[3] = (se) => de(se, 1))
              }), Xe({
                default: Q(() => [
                  h.$slots.month ? W(h.$slots, "month", Je(Ye({ key: 0 }, l(k)))) : x("", !0),
                  h.$slots.month ? x("", !0) : (g(), B(he, { key: 1 }, [
                    Fe($e(l(k).text), 1)
                  ], 64))
                ]),
                _: 2
              }, [
                h.$slots["calendar-icon"] ? {
                  name: "calendar-icon",
                  fn: Q(() => [
                    W(h.$slots, "calendar-icon")
                  ]),
                  key: "0"
                } : void 0,
                h.$slots["month-overlay-value"] ? {
                  name: "month-overlay-val",
                  fn: Q(({ item: se }) => [
                    W(h.$slots, "month-overlay-value", {
                      text: se.text,
                      value: se.value
                    })
                  ]),
                  key: "1"
                } : void 0,
                h.$slots["month-overlay"] ? {
                  name: "overlay-month",
                  fn: Q(() => [
                    W(h.$slots, "month-overlay", Je(ct(l($)("month"))))
                  ]),
                  key: "2"
                } : void 0,
                h.$slots["month-overlay-header"] ? {
                  name: "overlay-month-header",
                  fn: Q(() => [
                    W(h.$slots, "month-overlay-header", { toggle: I })
                  ]),
                  key: "3"
                } : void 0
              ]), 1040, ["aria-label", "modelValue"]),
              Re(du, Ye({
                type: "year",
                "slot-name": "year-overlay-val",
                "overlay-slot": "overlay-year",
                "aria-label": (ue = l(a).ariaLabels) == null ? void 0 : ue.openYearsOverlay,
                modelValue: l(C),
                "onUpdate:modelValue": E[4] || (E[4] = (se) => Le(C) ? C.value = se : null)
              }, l(P)("year"), {
                onToggle: U,
                onSetRef: E[5] || (E[5] = (se) => de(se, 2))
              }), Xe({
                default: Q(() => [
                  h.$slots.year ? W(h.$slots, "year", {
                    key: 0,
                    year: e.year
                  }) : x("", !0),
                  h.$slots.year ? x("", !0) : (g(), B(he, { key: 1 }, [
                    Fe($e(e.year), 1)
                  ], 64))
                ]),
                _: 2
              }, [
                h.$slots["calendar-icon"] ? {
                  name: "calendar-icon",
                  fn: Q(() => [
                    W(h.$slots, "calendar-icon")
                  ]),
                  key: "0"
                } : void 0,
                h.$slots["year-overlay-value"] ? {
                  name: "year-overlay-val",
                  fn: Q(({ item: se }) => [
                    W(h.$slots, "year-overlay-value", {
                      text: se.text,
                      value: se.value
                    })
                  ]),
                  key: "1"
                } : void 0,
                h.$slots["year-overlay"] ? {
                  name: "overlay-year",
                  fn: Q(() => [
                    W(h.$slots, "year-overlay", Je(ct(l($)("year"))))
                  ]),
                  key: "2"
                } : void 0,
                h.$slots["year-overlay-header"] ? {
                  name: "overlay-year-header",
                  fn: Q(() => [
                    W(h.$slots, "year-overlay-header", { toggle: U })
                  ]),
                  key: "3"
                } : void 0
              ]), 1040, ["aria-label", "modelValue"])
            ]),
            l(w) && h.vertical ? (g(), oe(ta, {
              key: 1,
              "aria-label": (De = l(a).ariaLabels) == null ? void 0 : De.prevMonth,
              disabled: l(d)(!1),
              onActivate: E[6] || (E[6] = (se) => l(s)(!1))
            }, {
              default: Q(() => [
                h.$slots["arrow-up"] ? W(h.$slots, "arrow-up", { key: 0 }) : x("", !0),
                h.$slots["arrow-up"] ? x("", !0) : (g(), oe(l(Lu), { key: 1 }))
              ]),
              _: 3
            }, 8, ["aria-label", "disabled"])) : x("", !0),
            l(S) ? (g(), oe(ta, {
              key: 2,
              ref: "rightIcon",
              disabled: l(d)(!0),
              "aria-label": (Ke = l(a).ariaLabels) == null ? void 0 : Ke.nextMonth,
              onActivate: E[7] || (E[7] = (se) => l(s)(!0)),
              onSetRef: E[8] || (E[8] = (se) => de(se, 3))
            }, {
              default: Q(() => [
                h.$slots[h.vertical ? "arrow-down" : "arrow-right"] ? W(h.$slots, h.vertical ? "arrow-down" : "arrow-right", { key: 0 }) : x("", !0),
                h.$slots[h.vertical ? "arrow-down" : "arrow-right"] ? x("", !0) : (g(), oe(rn(h.vertical ? l(Wu) : l(Ji)), { key: 1 }))
              ]),
              _: 3
            }, 8, ["disabled", "aria-label"])) : x("", !0)
          ], 64)) : x("", !0),
          h.monthPicker ? (g(), oe(Gt, Ye({ key: 1 }, l(P)("month"), {
            "skip-active": h.range,
            year: e.year,
            "multi-model-value": l(X),
            "month-picker": "",
            modelValue: l(G),
            "onUpdate:modelValue": E[17] || (E[17] = (se) => Le(G) ? G.value = se : null),
            onToggle: I,
            onSelected: E[18] || (E[18] = (se) => h.$emit("overlay-closed"))
          }), Xe({
            header: Q(() => {
              var se, fe, _e;
              return [
                ie("div", Bv, [
                  ie("div", {
                    class: "dp__month_year_col_nav",
                    tabindex: "0",
                    ref_key: "mpPrevIconRef",
                    ref: A,
                    onClick: E[9] || (E[9] = (be) => le(!1)),
                    onKeydown: E[10] || (E[10] = ye((be) => le(!1), ["enter"]))
                  }, [
                    ie("div", {
                      class: pe(["dp__inner_nav", { dp__inner_nav_disabled: l(d)(!1) }]),
                      role: "button",
                      "aria-label": (se = l(a).ariaLabels) == null ? void 0 : se.prevMonth
                    }, [
                      h.$slots["arrow-left"] ? W(h.$slots, "arrow-left", { key: 0 }) : x("", !0),
                      h.$slots["arrow-left"] ? x("", !0) : (g(), oe(l(Ki), { key: 1 }))
                    ], 10, Av)
                  ], 544),
                  ie("div", {
                    class: "dp__pointer",
                    role: "button",
                    ref_key: "mpYearButtonRef",
                    ref: V,
                    "aria-label": (fe = l(a).ariaLabels) == null ? void 0 : fe.openYearsOverlay,
                    tabindex: "0",
                    onClick: E[11] || (E[11] = () => U(!1)),
                    onKeydown: E[12] || (E[12] = ye(() => U(!1), ["enter"]))
                  }, [
                    h.$slots.year ? W(h.$slots, "year", {
                      key: 0,
                      year: e.year
                    }) : x("", !0),
                    h.$slots.year ? x("", !0) : (g(), B(he, { key: 1 }, [
                      Fe($e(e.year), 1)
                    ], 64))
                  ], 40, Iv),
                  ie("div", {
                    class: "dp__month_year_col_nav",
                    tabindex: "0",
                    ref_key: "mpNextIconRef",
                    ref: q,
                    onClick: E[13] || (E[13] = (be) => le(!0)),
                    onKeydown: E[14] || (E[14] = ye((be) => le(!0), ["enter"]))
                  }, [
                    ie("div", {
                      class: pe(["dp__inner_nav", { dp__inner_nav_disabled: l(d)(!0) }]),
                      role: "button",
                      "aria-label": (_e = l(a).ariaLabels) == null ? void 0 : _e.nextMonth
                    }, [
                      h.$slots["arrow-right"] ? W(h.$slots, "arrow-right", { key: 0 }) : x("", !0),
                      h.$slots["arrow-right"] ? x("", !0) : (g(), oe(l(Ji), { key: 1 }))
                    ], 10, Ev)
                  ], 544)
                ]),
                Re(It, {
                  name: l(o)(f.value),
                  css: l(i)
                }, {
                  default: Q(() => [
                    f.value ? (g(), oe(Gt, Ye({ key: 0 }, l(P)("year"), {
                      modelValue: l(C),
                      "onUpdate:modelValue": E[15] || (E[15] = (be) => Le(C) ? C.value = be : null),
                      onToggle: U,
                      onSelected: E[16] || (E[16] = (be) => h.$emit("overlay-closed"))
                    }), Xe({
                      "button-icon": Q(() => [
                        h.$slots["calendar-icon"] ? W(h.$slots, "calendar-icon", { key: 0 }) : x("", !0),
                        h.$slots["calendar-icon"] ? x("", !0) : (g(), oe(l(Ar), { key: 1 }))
                      ]),
                      _: 2
                    }, [
                      h.$slots["year-overlay-value"] ? {
                        name: "item",
                        fn: Q(({ item: be }) => [
                          W(h.$slots, "year-overlay-value", {
                            text: be.text,
                            value: be.value
                          })
                        ]),
                        key: "0"
                      } : void 0
                    ]), 1040, ["modelValue"])) : x("", !0)
                  ]),
                  _: 3
                }, 8, ["name", "css"])
              ];
            }),
            _: 2
          }, [
            h.$slots["month-overlay-value"] ? {
              name: "item",
              fn: Q(({ item: se }) => [
                W(h.$slots, "month-overlay-value", {
                  text: se.text,
                  value: se.value
                })
              ]),
              key: "0"
            } : void 0
          ]), 1040, ["skip-active", "year", "multi-model-value", "modelValue"])) : x("", !0),
          h.yearPicker ? (g(), oe(Gt, Ye({ key: 2 }, l(P)("year"), {
            modelValue: l(C),
            "onUpdate:modelValue": E[19] || (E[19] = (se) => Le(C) ? C.value = se : null),
            "multi-model-value": l(X),
            "skip-active": h.range,
            "skip-button-ref": "",
            "year-picker": "",
            onToggle: U,
            onSelected: E[20] || (E[20] = (se) => h.$emit("overlay-closed"))
          }), Xe({ _: 2 }, [
            h.$slots["year-overlay-value"] ? {
              name: "item",
              fn: Q(({ item: se }) => [
                W(h.$slots, "year-overlay-value", {
                  text: se.text,
                  value: se.value
                })
              ]),
              key: "0"
            } : void 0
          ]), 1040, ["modelValue", "multi-model-value", "skip-active"])) : x("", !0)
        ], 64))
      ]);
    };
  }
}), Vv = {
  key: 0,
  class: "dp__time_input"
}, Fv = ["aria-label", "onKeydown", "onClick"], Uv = ["aria-label", "onKeydown", "onClick"], Lv = ["aria-label", "onKeydown", "onClick"], Wv = { key: 0 }, zv = ["aria-label", "onKeydown"], Hv = /* @__PURE__ */ Ie({
  __name: "TimeInput",
  props: {
    hours: { type: Number, default: 0 },
    minutes: { type: Number, default: 0 },
    seconds: { type: Number, default: 0 },
    closeTimePickerBtn: { type: Object, default: null },
    order: { type: Number, default: 0 },
    ...bt
  },
  emits: [
    "set-hours",
    "set-minutes",
    "update:hours",
    "update:minutes",
    "update:seconds",
    "reset-flow",
    "mounted",
    "overlay-closed"
  ],
  setup(e, { expose: t, emit: n }) {
    const r = e, { setTimePickerElements: a, setTimePickerBackRef: o } = ht(), { defaults: i } = Ze(r), { transitionName: c, showTransition: s } = Ir(i.value.transitions), d = Qt({
      hours: !1,
      minutes: !1,
      seconds: !1
    }), b = H("AM"), y = H(null), f = H([]);
    tt(() => {
      n("mounted");
    });
    const v = (O, m) => gu(je(R(), O), m), A = (O, m) => Tp(je(R(), O), m), V = F(
      () => ({
        dp__time_col: !0,
        dp__time_col_reg: !r.enableSeconds && r.is24,
        dp__time_col_reg_with_button: !r.enableSeconds && !r.is24,
        dp__time_col_sec: r.enableSeconds && r.is24,
        dp__time_col_sec_with_button: r.enableSeconds && !r.is24
      })
    ), q = F(() => {
      const O = [{ type: "hours" }, { type: "", separator: !0 }, { type: "minutes" }];
      return r.enableSeconds ? O.concat([{ type: "", separator: !0 }, { type: "seconds" }]) : O;
    }), ee = F(() => q.value.filter((O) => !O.separator)), G = F(() => (O) => {
      if (O === "hours") {
        const m = M(r.hours);
        return { text: m < 10 ? `0${m}` : `${m}`, value: m };
      }
      return { text: r[O] < 10 ? `0${r[O]}` : `${r[O]}`, value: r[O] };
    }), C = (O) => {
      const m = r.is24 ? 24 : 12, k = O === "hours" ? m : 60, D = +r[`${O}GridIncrement`], u = O === "hours" && !r.is24 ? D : 0, w = [];
      for (let S = u; S < k; S += D)
        w.push({ value: S, text: S < 10 ? `0${S}` : `${S}` });
      return O === "hours" && !r.is24 && w.push({ value: 0, text: "12" }), Lm(w);
    }, z = (O) => r[`no${O[0].toUpperCase() + O.slice(1)}Overlay`], te = (O) => {
      z(O) || (d[O] = !d[O], d[O] || n("overlay-closed"));
    }, P = (O) => O === "hours" ? lt : O === "minutes" ? st : At, $ = (O, m = !0) => {
      const k = m ? v : A;
      n(
        `update:${O}`,
        P(O)(k({ [O]: +r[O] }, { [O]: +r[`${O}Increment`] }))
      );
    }, M = (O) => r.is24 ? O : (O >= 12 ? b.value = "PM" : b.value = "AM", jm(O)), L = () => {
      b.value === "PM" ? (b.value = "AM", n("update:hours", r.hours - 12)) : (b.value = "PM", n("update:hours", r.hours + 12));
    }, j = (O) => {
      d[O] = !0;
    }, Y = (O, m, k) => {
      if (O && r.arrowNavigation) {
        Array.isArray(f.value[m]) ? f.value[m][k] = O : f.value[m] = [O];
        const D = f.value.reduce(
          (u, w) => w.map((S, I) => [...u[I] || [], w[I]]),
          []
        );
        o(r.closeTimePickerBtn), y.value && (D[1] = D[1].concat(y.value)), a(D, r.order);
      }
    }, X = (O, m) => O === "hours" && !r.is24 ? n(`update:${O}`, b.value === "PM" ? m + 12 : m) : n(`update:${O}`, m);
    return t({ openChildCmp: j }), (O, m) => {
      var k;
      return O.disabled ? x("", !0) : (g(), B("div", Vv, [
        (g(!0), B(he, null, Ae(l(q), (D, u) => {
          var w, S, I;
          return g(), B("div", {
            key: u,
            class: pe(l(V))
          }, [
            D.separator ? (g(), B(he, { key: 0 }, [
              Fe(" : ")
            ], 64)) : (g(), B(he, { key: 1 }, [
              ie("div", {
                class: "dp__inc_dec_button",
                role: "button",
                "aria-label": (w = l(i).ariaLabels) == null ? void 0 : w.incrementValue(D.type),
                tabindex: "0",
                onKeydown: [
                  ye((U) => $(D.type), ["enter"]),
                  ye((U) => $(D.type), ["space"])
                ],
                onClick: (U) => $(D.type),
                ref_for: !0,
                ref: (U) => Y(U, u, 0)
              }, [
                O.$slots["arrow-up"] ? W(O.$slots, "arrow-up", { key: 0 }) : x("", !0),
                O.$slots["arrow-up"] ? x("", !0) : (g(), oe(l(Lu), { key: 1 }))
              ], 40, Fv),
              ie("div", {
                role: "button",
                "aria-label": (S = l(i).ariaLabels) == null ? void 0 : S.openTpOverlay(D.type),
                class: pe(z(D.type) ? "" : "dp__time_display"),
                tabindex: "0",
                onKeydown: [
                  ye((U) => te(D.type), ["enter"]),
                  ye((U) => te(D.type), ["space"])
                ],
                onClick: (U) => te(D.type),
                ref_for: !0,
                ref: (U) => Y(U, u, 1)
              }, [
                O.$slots[D.type] ? W(O.$slots, D.type, {
                  key: 0,
                  text: l(G)(D.type).text,
                  value: l(G)(D.type).value
                }) : x("", !0),
                O.$slots[D.type] ? x("", !0) : (g(), B(he, { key: 1 }, [
                  Fe($e(l(G)(D.type).text), 1)
                ], 64))
              ], 42, Uv),
              ie("div", {
                class: "dp__inc_dec_button",
                role: "button",
                "aria-label": (I = l(i).ariaLabels) == null ? void 0 : I.decrementValue(D.type),
                tabindex: "0",
                onKeydown: [
                  ye((U) => $(D.type, !1), ["enter"]),
                  ye((U) => $(D.type, !1), ["space"])
                ],
                onClick: (U) => $(D.type, !1),
                ref_for: !0,
                ref: (U) => Y(U, u, 2)
              }, [
                O.$slots["arrow-down"] ? W(O.$slots, "arrow-down", { key: 0 }) : x("", !0),
                O.$slots["arrow-down"] ? x("", !0) : (g(), oe(l(Wu), { key: 1 }))
              ], 40, Lv)
            ], 64))
          ], 2);
        }), 128)),
        O.is24 ? x("", !0) : (g(), B("div", Wv, [
          O.$slots["am-pm-button"] ? W(O.$slots, "am-pm-button", {
            key: 0,
            toggle: L,
            value: b.value
          }) : x("", !0),
          O.$slots["am-pm-button"] ? x("", !0) : (g(), B("button", {
            key: 1,
            ref_key: "amPmButton",
            ref: y,
            type: "button",
            class: "dp__pm_am_button",
            role: "button",
            "aria-label": (k = l(i).ariaLabels) == null ? void 0 : k.amPmButton,
            tabindex: "0",
            onClick: L,
            onKeydown: [
              ye(ft(L, ["prevent"]), ["enter"]),
              ye(ft(L, ["prevent"]), ["space"])
            ]
          }, $e(b.value), 41, zv))
        ])),
        (g(!0), B(he, null, Ae(l(ee), (D, u) => (g(), oe(It, {
          key: u,
          name: l(c)(d[D.type]),
          css: l(s)
        }, {
          default: Q(() => [
            d[D.type] ? (g(), oe(Gt, {
              key: 0,
              items: C(D.type),
              "disabled-values": l(i).filters.times[D.type],
              "esc-close": O.escClose,
              "aria-labels": l(i).ariaLabels,
              "hide-navigation": O.hideNavigation,
              "onUpdate:modelValue": (w) => X(D.type, w),
              onSelected: (w) => te(D.type),
              onToggle: (w) => te(D.type),
              onResetFlow: m[0] || (m[0] = (w) => O.$emit("reset-flow")),
              type: D.type
            }, Xe({
              "button-icon": Q(() => [
                O.$slots["clock-icon"] ? W(O.$slots, "clock-icon", { key: 0 }) : x("", !0),
                O.$slots["clock-icon"] ? x("", !0) : (g(), oe(l(Uu), { key: 1 }))
              ]),
              _: 2
            }, [
              O.$slots[`${D.type}-overlay-value`] ? {
                name: "item",
                fn: Q(({ item: w }) => [
                  W(O.$slots, `${D.type}-overlay-value`, {
                    text: w.text,
                    value: w.value
                  })
                ]),
                key: "0"
              } : void 0
            ]), 1032, ["items", "disabled-values", "esc-close", "aria-labels", "hide-navigation", "onUpdate:modelValue", "onSelected", "onToggle", "type"])) : x("", !0)
          ]),
          _: 2
        }, 1032, ["name", "css"]))), 128))
      ]));
    };
  }
}), jv = ["aria-label"], qv = { class: "dp__overlay_container dp__container_flex" }, Gv = {
  key: 1,
  class: "dp__overlay_row"
}, Qv = ["aria-label"], Xv = /* @__PURE__ */ Ie({
  __name: "TimePicker",
  props: {
    hours: { type: [Number, Array], default: 0 },
    minutes: { type: [Number, Array], default: 0 },
    seconds: { type: [Number, Array], default: 0 },
    internalModelValue: { type: [Date, Array], default: null },
    ...bt
  },
  emits: [
    "update:hours",
    "update:minutes",
    "update:seconds",
    "mount",
    "reset-flow",
    "overlay-closed"
  ],
  setup(e, { expose: t, emit: n }) {
    const r = e, { buildMatrix: a, setTimePicker: o } = ht(), i = wo(), { hideNavigationButtons: c, defaults: s } = Ze(r), { transitionName: d, showTransition: b } = Ir(s.value.transitions), y = H(null), f = H(null), v = H([]), A = H(null);
    tt(() => {
      n("mount"), !r.timePicker && r.arrowNavigation ? a([Ve(y.value)], "time") : o(!0, r.timePicker);
    });
    const V = F(() => r.range && r.modelAuto ? Gu(r.internalModelValue) : !0), q = H(!1), ee = (Y) => ({
      hours: Array.isArray(r.hours) ? r.hours[Y] : r.hours,
      minutes: Array.isArray(r.minutes) ? r.minutes[Y] : r.minutes,
      seconds: Array.isArray(r.seconds) ? r.seconds[Y] : r.seconds
    }), G = F(() => {
      const Y = [];
      if (r.range)
        for (let X = 0; X < 2; X++)
          Y.push(ee(X));
      else
        Y.push(ee(0));
      return Y;
    }), C = (Y, X = !1, O = "") => {
      X || n("reset-flow"), q.value = Y, r.arrowNavigation && (o(Y), Y || n("overlay-closed")), Kt(() => {
        O !== "" && v.value[0] && v.value[0].openChildCmp(O);
      });
    }, z = F(() => ({
      dp__button: !0,
      dp__button_bottom: r.autoApply
    })), te = $t(i, "timePicker"), P = (Y, X, O) => r.range ? X === 0 ? [Y, G.value[1][O]] : [G.value[0][O], Y] : Y, $ = (Y) => {
      n("update:hours", Y);
    }, M = (Y) => {
      n("update:minutes", Y);
    }, L = (Y) => {
      n("update:seconds", Y);
    }, j = () => {
      A.value && r.arrowNavigation && A.value.focus({ preventScroll: !0 });
    };
    return t({ toggleTimePicker: C }), (Y, X) => {
      var O;
      return g(), B("div", null, [
        Y.timePicker ? x("", !0) : an((g(), B("div", {
          key: 0,
          class: pe(l(z)),
          role: "button",
          "aria-label": (O = l(s).ariaLabels) == null ? void 0 : O.openTimePicker,
          tabindex: "0",
          ref_key: "openTimePickerBtn",
          ref: y,
          onKeydown: [
            X[0] || (X[0] = ye((m) => C(!0), ["enter"])),
            X[1] || (X[1] = ye((m) => C(!0), ["space"]))
          ],
          onClick: X[2] || (X[2] = (m) => C(!0))
        }, [
          Y.$slots["clock-icon"] ? W(Y.$slots, "clock-icon", { key: 0 }) : x("", !0),
          Y.$slots["clock-icon"] ? x("", !0) : (g(), oe(l(Uu), { key: 1 }))
        ], 42, jv)), [
          [on, !l(c)("time")]
        ]),
        Re(It, {
          name: l(d)(q.value),
          css: l(b)
        }, {
          default: Q(() => {
            var m;
            return [
              q.value || Y.timePicker ? (g(), B("div", {
                key: 0,
                class: "dp__overlay",
                ref_key: "overlayRef",
                ref: A,
                tabindex: "0"
              }, [
                ie("div", qv, [
                  Y.$slots["time-picker-overlay"] ? W(Y.$slots, "time-picker-overlay", {
                    key: 0,
                    hours: e.hours,
                    minutes: e.minutes,
                    seconds: e.seconds,
                    setHours: $,
                    setMinutes: M,
                    setSeconds: L
                  }) : x("", !0),
                  Y.$slots["time-picker-overlay"] ? x("", !0) : (g(), B("div", Gv, [
                    (g(!0), B(he, null, Ae(l(G), (k, D) => an((g(), oe(Hv, Ye({ key: D }, {
                      ...Y.$props,
                      order: D,
                      hours: k.hours,
                      minutes: k.minutes,
                      seconds: k.seconds,
                      closeTimePickerBtn: f.value,
                      disabled: D === 0 ? Y.fixedStart : Y.fixedEnd
                    }, {
                      ref_for: !0,
                      ref_key: "timeInputRefs",
                      ref: v,
                      "onUpdate:hours": (u) => $(P(u, D, "hours")),
                      "onUpdate:minutes": (u) => M(P(u, D, "minutes")),
                      "onUpdate:seconds": (u) => L(P(u, D, "seconds")),
                      onMounted: j,
                      onOverlayClosed: j
                    }), Xe({ _: 2 }, [
                      Ae(l(te), (u, w) => ({
                        name: u,
                        fn: Q((S) => [
                          W(Y.$slots, u, Je(ct(S)))
                        ])
                      }))
                    ]), 1040, ["onUpdate:hours", "onUpdate:minutes", "onUpdate:seconds"])), [
                      [on, D === 0 ? !0 : l(V)]
                    ])), 128))
                  ])),
                  Y.timePicker ? x("", !0) : an((g(), B("div", {
                    key: 2,
                    ref_key: "closeTimePickerBtn",
                    ref: f,
                    class: pe(l(z)),
                    role: "button",
                    "aria-label": (m = l(s).ariaLabels) == null ? void 0 : m.closeTimePicker,
                    tabindex: "0",
                    onKeydown: [
                      X[3] || (X[3] = ye((k) => C(!1), ["enter"])),
                      X[4] || (X[4] = ye((k) => C(!1), ["space"]))
                    ],
                    onClick: X[5] || (X[5] = (k) => C(!1))
                  }, [
                    Y.$slots["calendar-icon"] ? W(Y.$slots, "calendar-icon", { key: 0 }) : x("", !0),
                    Y.$slots["calendar-icon"] ? x("", !0) : (g(), oe(l(Ar), { key: 1 }))
                  ], 42, Qv)), [
                    [on, !l(c)("time")]
                  ])
                ])
              ], 512)) : x("", !0)
            ];
          }),
          _: 3
        }, 8, ["name", "css"])
      ]);
    };
  }
}), Kv = (e, t) => {
  const { isDisabled: n, matchDate: r, getWeekFromDate: a } = Ze(t), o = H(null), i = H(R()), c = (u) => {
    !u.current && t.hideOffsetDates || (o.value = u.value);
  }, s = () => {
    o.value = null;
  }, d = (u) => Array.isArray(e.value) && t.range && e.value[0] && o.value ? u ? Ge(o.value, e.value[0]) : We(o.value, e.value[0]) : !0, b = (u, w) => {
    const S = () => e.value ? w ? e.value[0] || null : e.value[1] : null, I = e.value && Array.isArray(e.value) ? S() : null;
    return Te(R(u.value), I);
  }, y = (u) => {
    const w = Array.isArray(e.value) ? e.value[0] : null;
    return u ? !We(o.value || null, w) : !0;
  }, f = (u, w = !0) => (t.range || t.weekPicker) && Array.isArray(e.value) ? t.hideOffsetDates && !u.current ? !1 : Te(R(u.value), e.value[w ? 0 : 1]) : t.range ? b(u, w) && y(w) || Te(u.value, Array.isArray(e.value) ? e.value[0] : null) && d(w) : !1, v = (u, w, S) => Array.isArray(e.value) && e.value[0] && e.value.length === 1 ? u ? !1 : S ? Ge(e.value[0], w.value) : We(e.value[0], w.value) : !1, A = (u) => !e.value || t.hideOffsetDates && !u.current ? !1 : t.range ? t.modelAuto && Array.isArray(e.value) ? Te(u.value, e.value[0] ? e.value[0] : i.value) : !1 : t.multiDates && Array.isArray(e.value) ? e.value.some((w) => Te(w, u.value)) : Te(u.value, e.value ? e.value : i.value), V = (u) => {
    if (t.autoRange || t.weekPicker) {
      if (o.value) {
        if (t.hideOffsetDates && !u.current)
          return !1;
        const w = yt(o.value, +t.autoRange), S = a(R(o.value));
        return t.weekPicker ? Te(S[1], R(u.value)) : Te(w, R(u.value));
      }
      return !1;
    }
    return !1;
  }, q = (u) => {
    if (t.autoRange || t.weekPicker) {
      if (o.value) {
        const w = yt(o.value, +t.autoRange);
        if (t.hideOffsetDates && !u.current)
          return !1;
        const S = a(R(o.value));
        return t.weekPicker ? Ge(u.value, S[0]) && We(u.value, S[1]) : Ge(u.value, o.value) && We(u.value, w);
      }
      return !1;
    }
    return !1;
  }, ee = (u) => {
    if (t.autoRange || t.weekPicker) {
      if (o.value) {
        if (t.hideOffsetDates && !u.current)
          return !1;
        const w = a(R(o.value));
        return t.weekPicker ? Te(w[0], u.value) : Te(o.value, u.value);
      }
      return !1;
    }
    return !1;
  }, G = (u) => zu(e.value, o.value, u.value), C = () => t.modelAuto && Array.isArray(t.internalModelValue) ? !!t.internalModelValue[0] : !1, z = () => t.modelAuto ? Gu(t.internalModelValue) : !0, te = (u) => {
    if (Array.isArray(e.value) && e.value.length || t.weekPicker)
      return !1;
    const w = t.range ? !f(u) && !f(u, !1) : !0;
    return !n(u.value) && !A(u) && !(!u.current && t.hideOffsetDates) && w;
  }, P = (u) => t.range ? t.modelAuto ? C() && A(u) : !1 : A(u), $ = (u) => t.highlight ? r(u.value, t.highlight) : !1, M = (u) => n(u.value) && t.highlightDisabledDays === !1, L = (u) => t.highlightWeekDays && t.highlightWeekDays.includes(u.value.getDay()), j = (u) => (t.range || t.weekPicker) && (!(t.multiCalendars > 0) || u.current) && z() && !(!u.current && t.hideOffsetDates) && !A(u) ? G(u) : !1, Y = (u) => ({
    dp__cell_offset: !u.current,
    dp__pointer: !t.disabled && !(!u.current && t.hideOffsetDates) && !n(u.value),
    dp__cell_disabled: n(u.value),
    dp__cell_highlight: !M(u) && ($(u) || L(u)) && !P(u),
    dp__cell_highlight_active: !M(u) && ($(u) || L(u)) && P(u),
    dp__today: !t.noToday && Te(u.value, i.value) && u.current
  }), X = (u) => ({
    dp__active_date: P(u),
    dp__date_hover: te(u)
  }), O = (u) => ({
    ...m(u),
    ...k(u),
    dp__range_between_week: j(u) && t.weekPicker
  }), m = (u) => ({
    dp__range_start: t.multiCalendars > 0 ? u.current && f(u) && z() : f(u) && z(),
    dp__range_end: t.multiCalendars > 0 ? u.current && f(u, !1) && z() : f(u, !1) && z(),
    dp__range_between: j(u) && !t.weekPicker,
    dp__date_hover_start: v(te(u), u, !0),
    dp__date_hover_end: v(te(u), u, !1)
  }), k = (u) => ({
    ...m(u),
    dp__cell_auto_range: q(u),
    dp__cell_auto_range_start: ee(u),
    dp__cell_auto_range_end: V(u)
  }), D = (u) => t.range ? t.autoRange ? k(u) : t.modelAuto ? { ...X(u), ...m(u) } : m(u) : t.weekPicker ? O(u) : X(u);
  return {
    setHoverDate: c,
    clearHoverDate: s,
    getDayClassData: (u) => ({
      ...Y(u),
      ...D(u),
      [t.dayClass ? t.dayClass(u.value) : ""]: !0,
      [t.calendarCellClassName]: !!t.calendarCellClassName
    })
  };
}, Jv = ["id", "onKeydown"], Zv = {
  key: 0,
  class: "dp__sidebar_left"
}, eh = {
  key: 1,
  class: "dp__preset_ranges"
}, th = ["onClick"], nh = {
  key: 2,
  class: "dp__sidebar_right"
}, rh = {
  key: 3,
  class: "dp__now_wrap"
}, ah = /* @__PURE__ */ Ie({
  __name: "DatepickerMenu",
  props: {
    openOnTop: { type: Boolean, default: !1 },
    internalModelValue: { type: [Date, Array], default: null },
    ...bt
  },
  emits: [
    "close-picker",
    "select-date",
    "auto-apply",
    "time-update",
    "flow-step",
    "update-month-year",
    "invalid-select",
    "update:internal-model-value",
    "recalculate-position"
  ],
  setup(e, { expose: t, emit: n }) {
    const r = e, { setMenuFocused: a, setShiftKey: o, control: i } = Hu(), { getCalendarDays: c, defaults: s } = Ze(r), d = wo(), b = H(null), y = Qt({
      timePicker: !!(!r.enableTimePicker || r.timePicker || r.monthPicker),
      monthYearInput: !!r.timePicker,
      calendar: !1
    }), f = H([]), v = H([]), A = H(null), V = H(null), q = H(0), ee = H(!1), G = H(0);
    tt(() => {
      var T;
      ee.value = !0, !((T = r.presetRanges) != null && T.length) && !d["left-sidebar"] && !d["right-sidebar"] && ut();
      const K = Ve(V);
      if (K && !r.textInput && !r.inline && (a(!0), M()), K) {
        const ze = (Qe) => {
          !r.monthYearComponent && !r.timePickerComponent && !Object.keys(d).length && Qe.preventDefault(), Qe.stopImmediatePropagation(), Qe.stopPropagation();
        };
        K.addEventListener("pointerdown", ze), K.addEventListener("mousedown", ze);
      }
      document.addEventListener("resize", ut);
    }), _o(() => {
      document.removeEventListener("resize", ut);
    });
    const { arrowRight: C, arrowLeft: z, arrowDown: te, arrowUp: P } = ht(), $ = (T) => {
      T || T === 0 ? v.value[T].triggerTransition(
        O.value(T),
        m.value(T)
      ) : v.value.forEach(
        (K, ze) => K.triggerTransition(O.value(ze), m.value(ze))
      );
    }, M = () => {
      const T = Ve(V);
      T && T.focus({ preventScroll: !0 });
    }, L = () => {
      var T;
      (T = r.flow) != null && T.length && G.value !== -1 && (G.value += 1, n("flow-step", G.value), Se());
    }, j = () => {
      G.value = -1;
    }, {
      calendars: Y,
      modelValue: X,
      month: O,
      year: m,
      time: k,
      updateTime: D,
      updateMonthYear: u,
      selectDate: w,
      getWeekNum: S,
      monthYearSelect: I,
      handleScroll: U,
      handleArrow: _,
      handleSwipe: le,
      getMarker: de,
      selectCurrentDate: h,
      presetDateRange: E
    } = ev(r, n, L, $, G), { setHoverDate: Me, clearHoverDate: me, getDayClassData: ue } = Kv(X, r);
    Xt(
      Y,
      () => {
        r.openOnTop && setTimeout(() => {
          n("recalculate-position");
        }, 0);
      },
      { deep: !0 }
    );
    const De = $t(d, "calendar"), Ke = $t(d, "action"), se = $t(d, "timePicker"), fe = $t(d, "monthYear"), _e = F(() => r.openOnTop ? "dp__arrow_bottom" : "dp__arrow_top"), be = F(() => zm(r.yearRange)), Et = F(() => Hm(r.locale, r.monthNameFormat)), ut = () => {
      const T = Ve(b);
      T && (q.value = T.getBoundingClientRect().width);
    }, Yt = F(() => (T) => c(O.value(T), m.value(T))), gt = F(
      () => s.value.multiCalendars > 0 && r.range ? [...Array(s.value.multiCalendars).keys()] : [0]
    ), Vt = F(
      () => (T) => T === 1
    ), Er = F(() => r.monthPicker || r.timePicker || r.yearPicker), Yr = F(
      () => ({
        dp__flex_display: s.value.multiCalendars > 0
      })
    ), Jt = F(() => ({
      dp__instance_calendar: s.value.multiCalendars > 0
    })), Ft = F(() => ({
      dp__menu_disabled: r.disabled,
      dp__menu_readonly: r.readonly
    })), Vr = F(
      () => (T) => Ur(Yt, T)
    ), Fr = F(
      () => ({
        dp__menu: !0,
        dp__menu_index: !r.inline,
        dp__relative: r.inline,
        [r.menuClassName]: !!r.menuClassName
      })
    ), Ur = (T, K) => T.value(K).map((ze) => ({
      ...ze,
      days: ze.days.map((Qe) => (Qe.marker = de(Qe), Qe.classData = ue(Qe), Qe))
    })), Zt = (T) => {
      T.stopPropagation(), T.stopImmediatePropagation();
    }, p = () => {
      r.escClose && n("close-picker");
    }, N = (T, K = !1) => {
      w(T, K), r.spaceConfirm && n("select-date");
    }, Z = (T) => {
      var K;
      (K = r.flow) != null && K.length && (y[T] = !0, Object.keys(y).filter((ze) => !y[ze]).length || Se());
    }, ce = (T, K, ze, Qe, ...en) => {
      if (r.flow[G.value] === T) {
        const ne = Qe ? K.value[0] : K.value;
        ne && ne[ze](...en);
      }
    }, Se = () => {
      ce("month", f, "toggleMonthPicker", !0, !0), ce("year", f, "toggleYearPicker", !0, !0), ce("calendar", A, "toggleTimePicker", !1, !1, !0), ce("time", A, "toggleTimePicker", !1, !0, !0);
      const T = r.flow[G.value];
      (T === "hours" || T === "minutes" || T === "seconds") && ce(T, A, "toggleTimePicker", !1, !0, !0, T);
    }, nt = (T) => {
      if (r.arrowNavigation) {
        if (T === "up")
          return P();
        if (T === "down")
          return te();
        if (T === "left")
          return z();
        if (T === "right")
          return C();
      } else
        T === "left" || T === "up" ? _("left", 0, T === "up") : _("right", 0, T === "down");
    }, wt = (T) => {
      o(T.shiftKey), !r.disableMonthYearSelect && T.code === "Tab" && T.target.classList.contains("dp__menu") && i.value.shiftKeyInMenu && (T.preventDefault(), T.stopImmediatePropagation(), n("close-picker"));
    };
    return t({
      updateMonthYear: u
    }), (T, K) => {
      var ze;
      return g(), oe(It, {
        appear: "",
        name: (ze = l(s).transitions) == null ? void 0 : ze.menuAppear,
        mode: "out-in",
        css: !!T.transitions
      }, {
        default: Q(() => {
          var Qe, en;
          return [
            ie("div", {
              id: T.uid ? `dp-menu-${T.uid}` : void 0,
              tabindex: "0",
              ref_key: "dpMenuRef",
              ref: V,
              role: "dialog",
              class: pe(l(Fr)),
              onMouseleave: K[12] || (K[12] = (...ne) => l(me) && l(me)(...ne)),
              onClick: Zt,
              onKeydown: [
                ye(p, ["esc"]),
                K[13] || (K[13] = ye(ft((ne) => nt("left"), ["prevent"]), ["left"])),
                K[14] || (K[14] = ye(ft((ne) => nt("up"), ["prevent"]), ["up"])),
                K[15] || (K[15] = ye(ft((ne) => nt("down"), ["prevent"]), ["down"])),
                K[16] || (K[16] = ye(ft((ne) => nt("right"), ["prevent"]), ["right"])),
                wt
              ]
            }, [
              (T.disabled || T.readonly) && T.inline ? (g(), B("div", {
                key: 0,
                class: pe(l(Ft))
              }, null, 2)) : x("", !0),
              !T.inline && !T.teleportCenter ? (g(), B("div", {
                key: 1,
                class: pe(l(_e))
              }, null, 2)) : x("", !0),
              ie("div", {
                class: pe({
                  dp__menu_content_wrapper: ((Qe = T.presetRanges) == null ? void 0 : Qe.length) || !!T.$slots["left-sidebar"] || !!T.$slots["right-sidebar"]
                })
              }, [
                T.$slots["left-sidebar"] ? (g(), B("div", Zv, [
                  W(T.$slots, "left-sidebar")
                ])) : x("", !0),
                (en = T.presetRanges) != null && en.length ? (g(), B("div", eh, [
                  (g(!0), B(he, null, Ae(T.presetRanges, (ne, xt) => (g(), B("div", {
                    key: xt,
                    style: Nt(ne.style || {}),
                    class: "dp__preset_range",
                    onClick: (ve) => l(E)(ne.range, !!ne.slot)
                  }, [
                    ne.slot ? W(T.$slots, ne.slot, {
                      key: 0,
                      presetDateRange: l(E),
                      label: ne.label,
                      range: ne.range
                    }) : (g(), B(he, { key: 1 }, [
                      Fe($e(ne.label), 1)
                    ], 64))
                  ], 12, th))), 128))
                ])) : x("", !0),
                ie("div", {
                  class: "dp__instance_calendar",
                  ref_key: "calendarWrapperRef",
                  ref: b,
                  role: "document"
                }, [
                  ie("div", {
                    class: pe(l(Yr))
                  }, [
                    (g(!0), B(he, null, Ae(l(gt), (ne, xt) => (g(), B("div", {
                      key: ne,
                      class: pe(l(Jt))
                    }, [
                      !T.disableMonthYearSelect && !T.timePicker ? (g(), oe(rn(T.monthYearComponent ? T.monthYearComponent : Yv), Ye({
                        key: 0,
                        ref_for: !0,
                        ref: (ve) => {
                          ve && (f.value[xt] = ve);
                        },
                        months: l(Et),
                        years: l(be),
                        month: l(O)(ne),
                        year: l(m)(ne),
                        instance: ne,
                        "internal-model-value": e.internalModelValue
                      }, T.$props, {
                        onMount: K[0] || (K[0] = (ve) => Z("monthYearInput")),
                        onResetFlow: j,
                        onUpdateMonthYear: (ve) => l(u)(ne, ve),
                        onMonthYearSelect: l(I),
                        onOverlayClosed: M
                      }), Xe({ _: 2 }, [
                        Ae(l(fe), (ve, Qu) => ({
                          name: ve,
                          fn: Q((Lr) => [
                            W(T.$slots, ve, Je(ct(Lr)))
                          ])
                        }))
                      ]), 1040, ["months", "years", "month", "year", "instance", "internal-model-value", "onUpdateMonthYear", "onMonthYearSelect"])) : x("", !0),
                      Re(kv, Ye({
                        ref_for: !0,
                        ref: (ve) => {
                          ve && (v.value[xt] = ve);
                        },
                        "specific-mode": l(Er),
                        "get-week-num": l(S),
                        instance: ne,
                        "mapped-dates": l(Vr)(ne),
                        month: l(O)(ne),
                        year: l(m)(ne)
                      }, T.$props, {
                        "flow-step": G.value,
                        "onUpdate:flow-step": K[1] || (K[1] = (ve) => G.value = ve),
                        onSelectDate: (ve) => l(w)(ve, !l(Vt)(ne)),
                        onHandleSpace: (ve) => N(ve, !l(Vt)(ne)),
                        onSetHoverDate: K[2] || (K[2] = (ve) => l(Me)(ve)),
                        onHandleScroll: (ve) => l(U)(ve, ne),
                        onHandleSwipe: (ve) => l(le)(ve, ne),
                        onMount: K[3] || (K[3] = (ve) => Z("calendar")),
                        onResetFlow: j
                      }), Xe({ _: 2 }, [
                        Ae(l(De), (ve, Qu) => ({
                          name: ve,
                          fn: Q((Lr) => [
                            W(T.$slots, ve, Je(ct({ ...Lr })))
                          ])
                        }))
                      ]), 1040, ["specific-mode", "get-week-num", "instance", "mapped-dates", "month", "year", "flow-step", "onSelectDate", "onHandleSpace", "onHandleScroll", "onHandleSwipe"])
                    ], 2))), 128))
                  ], 2),
                  ie("div", null, [
                    T.$slots["time-picker"] ? W(T.$slots, "time-picker", Je(Ye({ key: 0 }, { time: l(k), updateTime: l(D) }))) : (g(), B(he, { key: 1 }, [
                      T.enableTimePicker && !T.monthPicker && !T.weekPicker ? (g(), oe(rn(T.timePickerComponent ? T.timePickerComponent : Xv), Ye({
                        key: 0,
                        ref_key: "timePickerRef",
                        ref: A,
                        hours: l(k).hours,
                        minutes: l(k).minutes,
                        seconds: l(k).seconds,
                        "internal-model-value": e.internalModelValue
                      }, T.$props, {
                        onMount: K[4] || (K[4] = (ne) => Z("timePicker")),
                        "onUpdate:hours": K[5] || (K[5] = (ne) => l(D)(ne)),
                        "onUpdate:minutes": K[6] || (K[6] = (ne) => l(D)(ne, !1)),
                        "onUpdate:seconds": K[7] || (K[7] = (ne) => l(D)(ne, !1, !0)),
                        onResetFlow: j,
                        onOverlayClosed: M
                      }), Xe({ _: 2 }, [
                        Ae(l(se), (ne, xt) => ({
                          name: ne,
                          fn: Q((ve) => [
                            W(T.$slots, ne, Je(ct(ve)))
                          ])
                        }))
                      ]), 1040, ["hours", "minutes", "seconds", "internal-model-value"])) : x("", !0)
                    ], 64))
                  ])
                ], 512),
                T.$slots["right-sidebar"] ? (g(), B("div", nh, [
                  W(T.$slots, "right-sidebar")
                ])) : x("", !0),
                T.showNowButton ? (g(), B("div", rh, [
                  T.$slots["now-button"] ? W(T.$slots, "now-button", {
                    key: 0,
                    selectCurrentDate: l(h)
                  }) : x("", !0),
                  T.$slots["now-button"] ? x("", !0) : (g(), B("button", {
                    key: 1,
                    type: "button",
                    role: "button",
                    class: "dp__now_button",
                    onClick: K[8] || (K[8] = (...ne) => l(h) && l(h)(...ne))
                  }, $e(T.nowButtonLabel), 1))
                ])) : x("", !0)
              ], 2),
              !T.autoApply || T.keepActionRow ? (g(), oe(rn(T.actionRowComponent ? T.actionRowComponent : mv), Ye({
                key: 2,
                "menu-mount": ee.value,
                "calendar-width": q.value,
                "internal-model-value": e.internalModelValue
              }, T.$props, {
                onClosePicker: K[9] || (K[9] = (ne) => T.$emit("close-picker")),
                onSelectDate: K[10] || (K[10] = (ne) => T.$emit("select-date")),
                onInvalidSelect: K[11] || (K[11] = (ne) => T.$emit("invalid-select"))
              }), Xe({ _: 2 }, [
                Ae(l(Ke), (ne, xt) => ({
                  name: ne,
                  fn: Q((ve) => [
                    W(T.$slots, ne, Je(ct({ ...ve })))
                  ])
                }))
              ]), 1040, ["menu-mount", "calendar-width", "internal-model-value"])) : x("", !0)
            ], 42, Jv)
          ];
        }),
        _: 3
      }, 8, ["name", "css"]);
    };
  }
}), oh = typeof window < "u" ? window : void 0, na = () => {
}, ih = (e) => sl() ? (cl(e), !0) : !1, uh = (e, t, n, r) => {
  if (!e)
    return na;
  let a = na;
  const o = Xt(
    () => l(e),
    (c) => {
      a(), c && (c.addEventListener(t, n, r), a = () => {
        c.removeEventListener(t, n, r), a = na;
      });
    },
    { immediate: !0, flush: "post" }
  ), i = () => {
    o(), a();
  };
  return ih(i), i;
}, lh = (e, t, n, r = {}) => {
  const { window: a = oh, event: o = "pointerdown" } = r;
  return a ? uh(a, o, (i) => {
    const c = Ve(e), s = Ve(t);
    !c || !s || c === i.target || i.composedPath().includes(c) || i.composedPath().includes(s) || n(i);
  }, { passive: !0 }) : void 0;
}, sh = /* @__PURE__ */ Ie({
  __name: "VueDatePicker",
  props: {
    ...bt
  },
  emits: [
    "update:model-value",
    "text-submit",
    "closed",
    "cleared",
    "open",
    "focus",
    "blur",
    "internal-model-change",
    "recalculate-position",
    "flow-step",
    "update-month-year",
    "invalid-select"
  ],
  setup(e, { expose: t, emit: n }) {
    const r = e, a = wo(), o = H(!1), i = ra(r, "modelValue"), c = ra(r, "timezone"), s = H(null), d = H(null), b = H(!1), { setMenuFocused: y, setShiftKey: f } = Hu(), { clearArrowNav: v } = ht(), { validateDate: A, isValidTime: V, defaults: q } = Ze(r);
    tt(() => {
      L(r.modelValue), r.inline || (window.addEventListener("scroll", k), window.addEventListener("resize", D)), r.inline && (o.value = !0);
    }), _o(() => {
      r.inline || (window.removeEventListener("scroll", k), window.removeEventListener("resize", D));
    });
    const ee = $t(a, "all", r.presetRanges), G = $t(a, "input");
    Xt(
      [i, c],
      () => {
        L(i.value);
      },
      { deep: !0 }
    );
    const { openOnTop: C, menuPosition: z, setMenuPosition: te, setInitialPosition: P } = rv(
      s,
      d,
      n,
      r
    ), {
      inputValue: $,
      internalModelValue: M,
      parseExternalModelValue: L,
      emitModelValue: j,
      formatInputValue: Y,
      checkBeforeEmit: X
    } = tv(n, r, b), O = F(
      () => ({
        dp__main: !0,
        dp__theme_dark: r.dark,
        dp__theme_light: !r.dark,
        dp__flex_display: r.inline,
        dp__flex_display_with_input: r.inlineWithInput
      })
    ), m = F(() => r.dark ? "dp__theme_dark" : "dp__theme_light"), k = () => {
      o.value && (r.closeOnScroll ? de() : r.autoPosition ? te() : window.removeEventListener("scroll", k));
    }, D = () => {
      o.value && te();
    }, u = () => {
      !r.disabled && !r.readonly && (P(), o.value = !0, Kt().then(() => {
        te(), o.value && n("open");
      }), o.value || le(), L(r.modelValue));
    }, w = () => {
      $.value = "", le(), n("update:model-value", null), n("cleared"), de();
    }, S = () => {
      const fe = M.value;
      return !fe || !Array.isArray(fe) && A(fe) ? !0 : Array.isArray(fe) ? fe.length === 2 && A(fe[0]) && A(fe[1]) ? !0 : A(fe[0]) : !1;
    }, I = () => {
      X() && S() ? (j(), de()) : n("invalid-select", M.value);
    }, U = (fe) => {
      j(), r.closeOnAutoApply && !fe && de();
    }, _ = (fe = !1) => {
      r.autoApply && V(M.value) && S() && (r.range && Array.isArray(M.value) ? (r.partialRange || M.value.length === 2) && U(fe) : U(fe));
    }, le = () => {
      r.textInput || (M.value = null);
    }, de = () => {
      r.inline || (o.value && (o.value = !1, y(!1), f(!1), v(), n("closed"), P(), $.value && L(i.value)), le(), d.value && d.value.focusInput());
    }, h = (fe, _e) => {
      if (!fe) {
        M.value = null;
        return;
      }
      M.value = fe, _e && (I(), n("text-submit"));
    }, E = () => {
      r.autoApply && V(M.value) && j();
    }, Me = () => o.value ? de() : u(), me = (fe) => {
      M.value = fe;
    }, ue = F(() => r.textInput && q.value.textInputOptions.format), De = () => {
      ue.value && (b.value = !0, Y()), n("focus");
    }, Ke = () => {
      ue.value && (b.value = !1, Y()), n("blur");
    }, se = (fe) => {
      s.value && s.value.updateMonthYear(0, {
        month: lu(fe.month),
        year: lu(fe.year)
      });
    };
    return lh(
      s,
      d,
      r.onClickOutside ? () => r.onClickOutside(S) : de
    ), t({
      closeMenu: de,
      selectDate: I,
      clearValue: w,
      openMenu: u,
      onScroll: k,
      formatInputValue: Y,
      updateInternalModelValue: me,
      setMonthYear: se
    }), (fe, _e) => (g(), B("div", {
      class: pe(l(O))
    }, [
      Re(fv, Ye({
        ref_key: "inputRef",
        ref: d,
        "is-menu-open": o.value,
        "input-value": l($),
        "onUpdate:input-value": _e[0] || (_e[0] = (be) => Le($) ? $.value = be : null)
      }, fe.$props, {
        onClear: w,
        onOpen: u,
        onSetInputDate: h,
        onSetEmptyDate: l(j),
        onSelectDate: I,
        onToggle: Me,
        onClose: de,
        onFocus: De,
        onBlur: Ke
      }), Xe({ _: 2 }, [
        Ae(l(G), (be, Et) => ({
          name: be,
          fn: Q((ut) => [
            W(fe.$slots, be, Je(ct(ut)))
          ])
        }))
      ]), 1040, ["is-menu-open", "input-value", "onSetEmptyDate"]),
      o.value ? (g(), oe(ul, {
        key: 0,
        to: fe.teleport,
        disabled: fe.inline
      }, [
        o.value ? (g(), oe(ah, Ye({
          key: 0,
          ref_key: "dpMenuRef",
          ref: s,
          class: l(m),
          style: l(z),
          "open-on-top": l(C)
        }, fe.$props, {
          "internal-model-value": l(M),
          "onUpdate:internal-model-value": _e[1] || (_e[1] = (be) => Le(M) ? M.value = be : null),
          onClosePicker: de,
          onSelectDate: I,
          onAutoApply: _,
          onTimeUpdate: E,
          onFlowStep: _e[2] || (_e[2] = (be) => fe.$emit("flow-step", be)),
          onUpdateMonthYear: _e[3] || (_e[3] = (be) => fe.$emit("update-month-year", be)),
          onInvalidSelect: _e[4] || (_e[4] = (be) => fe.$emit("invalid-select", l(M))),
          onRecalculatePosition: l(te)
        }), Xe({ _: 2 }, [
          Ae(l(ee), (be, Et) => ({
            name: be,
            fn: Q((ut) => [
              W(fe.$slots, be, Je(ct({ ...ut })))
            ])
          }))
        ]), 1040, ["class", "style", "open-on-top", "internal-model-value", "onRecalculatePosition"])) : x("", !0)
      ], 8, ["to", "disabled"])) : x("", !0)
    ], 2));
  }
}), Ao = /* @__PURE__ */ (() => {
  const e = sh;
  return e.install = (t) => {
    t.component("Vue3DatePicker", e);
  }, e;
})(), ch = /* @__PURE__ */ Object.freeze(/* @__PURE__ */ Object.defineProperty({
  __proto__: null,
  default: Ao
}, Symbol.toStringTag, { value: "Module" }));
Object.entries(ch).forEach(([e, t]) => {
  e !== "default" && (Ao[e] = t);
});
const fh = /* @__PURE__ */ Ie({
  __name: "FormInputDatePicker",
  props: {
    label: null,
    size: null,
    validationMessages: null,
    validation: null,
    disabled: { type: Boolean, default: !1 },
    modelValue: null,
    hint: null,
    placeholder: null,
    id: null,
    readOnly: { type: Boolean, default: !1 },
    showAsRequired: { type: Boolean },
    locale: { default: "cs-CZ" },
    minDate: null,
    maxDate: null,
    enableTime: { type: Boolean, default: !1 },
    ignoreTimeValidation: { type: Boolean, default: !0 },
    dateFormat: null
  },
  emits: ["update:modelValue", "change", "update", "blur"],
  setup(e, { emit: t }) {
    const n = e, r = F({
      get() {
        const s = l(n.modelValue);
        if (!s)
          return;
        if (s instanceof Date)
          return s;
        const d = new Date(s);
        if (d && !isNaN(d.valueOf()))
          return d;
      },
      set(s) {
        let d = l(s);
        !(d instanceof Date) && d && (d = new Date(s)), d instanceof Date && !l(n.enableTime) && (d = new Date(`${d.toISOString().split("T")[0]}T00:00:00.000Z`)), t("update:modelValue", d);
        const b = l(n.validation);
        typeof (b == null ? void 0 : b.$touch) == "function" && b.$touch();
      }
    }), a = F(() => {
      const s = l(n.dateFormat);
      return typeof s == "function" ? s : l(l(n.enableTime) ? $l : bu);
    }), o = F(() => l(r) ? l(a)(l(r)) : null), {
      isRequired: i,
      invalid: c
    } = Tt(n);
    return (s, d) => {
      const b = go, y = pt, f = mt;
      return g(), oe(f, {
        description: e.hint,
        "label-for": e.id ? `${e.id}_input` : void 0,
        class: pe({ "form-group-required": l(i) })
      }, {
        label: Q(() => [
          Fe($e(e.label), 1)
        ]),
        default: Q(() => [
          Re(l(Ao), {
            modelValue: l(r),
            "onUpdate:modelValue": d[0] || (d[0] = (v) => Le(r) ? r.value = v : null),
            "text-input": "",
            "auto-apply": !0,
            "close-on-auto-apply": !e.enableTime,
            disabled: e.disabled,
            "enable-time-picker": e.enableTime,
            "min-date": e.minDate || void 0,
            "max-date": e.maxDate || void 0,
            "prevent-min-max-navigation": !!(e.minDate || e.maxDate),
            "ignore-time-validation": e.ignoreTimeValidation,
            format: l(a),
            locale: e.locale,
            uid: e.id ? `dtpkr_${e.id}` : void 0
          }, {
            "dp-input": Q(() => [
              Re(b, {
                type: "text",
                id: e.id ? `${e.id}_input` : void 0,
                placeholder: e.placeholder,
                size: e.size,
                state: l(c) !== null ? !l(c) : null,
                disabled: e.disabled,
                "model-value": l(o),
                readonly: !0
              }, null, 8, ["id", "placeholder", "size", "state", "disabled", "model-value"])
            ]),
            _: 1
          }, 8, ["modelValue", "close-on-auto-apply", "disabled", "enable-time-picker", "min-date", "max-date", "prevent-min-max-navigation", "ignore-time-validation", "format", "locale", "uid"]),
          l(c) ? (g(), oe(y, { key: 0 }, {
            default: Q(() => [
              Re(Dt, {
                "validation-model": e.validation,
                messages: e.validationMessages
              }, null, 8, ["validation-model", "messages"])
            ]),
            _: 1
          })) : x("", !0),
          W(s.$slots, "input-text")
        ]),
        _: 3
      }, 8, ["description", "label-for", "class"]);
    };
  }
}), dh = ml, yh = vl, ph = hl, mh = bl, vh = wl, hh = _l, bh = fh, _h = {
  install(e) {
    e.component("BForm", Xu), e.component("BFormCheckbox", yu), e.component("BFormCheckboxGroup", pu), e.component("BFormFloatingLabel", Ku), e.component("BFormGroup", mt), e.component("BFormInput", go), e.component("BFormInvalidFeedback", pt), e.component("BFormRadio", Ju), e.component("BFormRadioGroup", mu), e.component("BFormRow", Zu), e.component("BFormSelect", vu), e.component("BFormSelectOption", el), e.component("BFormSelectOptionGroup", tl), e.component("BFormSpinButton", nl), e.component("BFormTag", rl), e.component("BFormTags", al), e.component("BFormText", ol), e.component("BFormTextarea", hu), e.component("BFormValidFeedback", il), e.component("FormInput", dh), e.component("FormInputTextarea", hh), e.component("FormInputCheckbox", yh), e.component("FormInputCheckboxGroup", ph), e.component("FormInputRadioGroup", mh), e.component("FormInputSelect", vh), e.component("FormInputDatePicker", bh);
  }
};
export {
  dh as FormInput,
  yh as FormInputCheckbox,
  ph as FormInputCheckboxGroup,
  bh as FormInputDatePicker,
  mh as FormInputRadioGroup,
  vh as FormInputSelect,
  hh as FormInputTextarea,
  _h as FormInputsPlugin
};
